use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my ($out, $var, $ant);  # declare all your variables as local or you will get errors

  # header
  print "<script language='javascript'>document.getElementById('hl').innerHTML='Disk add (to create n-way mirrors)'</script>\n";

  # menue actions
  ###############


  ###############################################
  # part 1: do function, if question is answered
  ##############################################

    if ($in{'answered'}) {      # question was answered
       &my_add;                 # do it
    }



  ##############################
  # or create a form to ask user
  ##############################

  &load_lib('get-disk.pl');         # get required disk values
  &load_lib('get-sys-status.pl');   # get required pool values

  print "<b>Add a disk to a basic/mirror vdev</b><br>";

  if ($disk{'all_unused'} eq "") {
     print "available disks: none";

  } else {

    $var=&disklib_list('all_unused','state,vendor,product,partcap');

    &ask('begin');
    print "<table width='900'><tr><td valign='top'>";
    &ask('radio_add',"available disks",$var,'','t450d200');
    print "</td><td style='padding-left: 30px' valign='top'>";

    $var=&disklib_list('all_inuse','pool,vdev,vendor,product,partcap');
    &ask("radio_to","to a basic/ mirrored vdev",$var,'','t450d200');

    print "</td></tr></table>";
    &ask('confirm',$txt{'add'},$txt{'proceed'});
  }

  print "<br><br><a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a>\n";
  print "<br><br><div class='info'><pre>$txt{'disk_add_info'}</div><br></pre>";

  print "<script language='javascript'>document.getElementById('hl').innerHTML='Disk add (to create n-way mirrors)'</script>\n";


  #status with disk cap and  model
    $ant.=&exe("zpool status");
    my @l=split(/\n/,$ant);
    my ($s,$t,$k);
    foreach my $l (@l) {
        $t=$l;
        $t=~s/^\s+//;

        if ($l=~/NAME/) { $l.="     CAP            MODELL";}

        if ($t=~/^c\d|^wwn|^scsi|^ata|^sd/) {      # is disk Solaris or Linux
             $t=~s/\s.*//;     # id only
             $t=~s/s0$|p0$//;  # no slices
             $k="$t"."_partcap";
             $s=15-length($disk{$k});

             $l.="     $disk{$k}"." "x $s;
             $k="$t"."_product";
             $k=~s/p\d//;                        #disk not part

             $l.=$disk{$k};

        }

    }
    $ant=join("\n",@l);


    print "<br><table style='width:100%'>\n";
    print "\t<tr>\n";
      print "<td class=\"td1_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<b>zpool status</b></td>";
    print "\t<tr>\n";

    print "\t<tr>\n";
      print "<td class=\"td2_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<pre>$ant</pre></td>";
    print "\t<tr>\n";

    print "</table>\n";

} #/ my_action



######################
sub my_add {
#######################

  # partition
  if ($in{'select_part'}=~/\d/) {
        $in{'radio_to'}.="$in{'select_part'}";
  }

   my $t="$in{'radio_to'}\_pool";
   my $pool=$disk{$t};   #get pool of old disk


#test
#&print_var("zpool replace \"$pool\" $in{'radio_defect'} $in{'radio_replacement'}");




   my $i=&exe("zpool attach -f \"$pool\" $in{'radio_to'} $in{'radio_add'}");
   if ($i ne "") { print "zpool attach \"$pool\" $in{'radio_to'} $in{'radio_add'}<br>$i"; sleep(2); }


 $in{'l3'}="";
 sleep(1);
 reload;
}


###############################################
#end of my script, do not delete the line below
1;
