###############
sub my_action {
###############

 #override with private functions?
 ##################################
 eval { &mylib_menue_pools_create};                   # create this function in a private mylib.pl to replace this action


  my ($var1, $ant, $type,$d);

  &gethash_sys_poolnames;

# header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='$txt{'header'}'</script>\n";


# 1. edited
if ($in{'submit_ok'} ne "submit")     { $in{'answered'} =""; }  #not klicked on submit but on autoselect (encrypt)
if ($in{'answered'}) { &my_create; }     # form -> create

# 2. are the unused hds?
if ($disk{'all_unused'} eq "") {
  print" no disks available!";
  return;
}


# 2. get form
####################################################################
# create new pool

print "<b>Howto create a pool</b><br>A pool consists of one or more vdevs. So first step is always to create a pool from one (the first) vdev<br>";
print "Next step is to extend the pool with more vdevs to increase capacity and performance.<br><br><b>Do not select disks used by Windows!!<br></b>";

# form begin
  &ask('begin');

## name of pool
  &ask('value_new','New pool name',"$in{'value_new'}",'30');

#version
  &ask('select_version',"$txt{'pool_version'} (28v5=all platforms)","default,14,15,19,21,28v5",$in{'select_version'});

# disable features on openzfs
if ($sys{'auto_os_type'}=~/ill\_/) {
   &ask('checkbox_dis','Disable features</b> for compatibility with former OS releases<b>',"yes","no");
}

## checkboxes unused disks
   &ask('checkbox_hd','Disks',$disk{'all_unused'});

## how many disks
  @t=split(/\t/,$disk{'all_unused'});

## type of pool
## one hd
  if (@t > "0")   {   $type="basic"; }

## 2+ hd
  if (@t > 1)     {   $type.=",mirror"; $d="basic"; }

## 2+ hd
  if (@t > 1)     {   $type.=",raidz"; $d="basic"; }

## 3+ hd
  if (@t > 2)     {   $type.=",raidz2"; $d="basic"; }

## 3+ hd
  if (@t > 2)     {   $type.=",raidz3"; $d="basic"; }     #raidz3 option


##type of pool
  $type="[ ---- select carefully // no undo ---- ],$type";

  &ask('select_type',$txt{'first_vdev'},"$type");

  # allow basic vdev types
  &ask('select_allow','Allow basic vdevs<br></b>A failure of a basic vdev means pool lost<b>','no,yes');


  if ($sys{'auto_os_type'}=~/ill\_/) {
    &ask('select_ashift','force ashift (newer Illumos only)<br></b>If you get an error about ashift, select auto<b>',"auto,9,10,11,12,13,14,15,16","12");
  }
  &ask('checkbox_res',$txt{'overflow_protect'},"on","on");

&ask('end');

#info about ashift=12
  print "<br><br>All vdevs should have the same ashift to allow a vdev remove or disk replace with newer disks.<br>In most cases best is ashift=12 (4k disks)";
  print "<br><br>";


## info
  print "<a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a>\n";
  print "$txt{'pool_create_info'}";

print "<br><br>pools:\n";
print "<pre>".&socket("zpool status")."</pre>";
#print &list2table(&zfslib_list_pools('all,header,state,status'));


######################### / form ############################################

} #/ my_action
################



##############################################################################
sub my_create {
################ create pool

   my ($i,@w,$n,$what,$pool,$ver,$opt,$opt1);

   #name of pool
   $in{'value_new'}=&alltrim($in{'value_new'});            # remove  + spaces +

   # Strict
   $in{'value_new'}=~s/[^a-zA-Z0-9_\.\-:]//g;              # allowed in poolname



   # zraid-n, create only in standalone mode
   if ($cfg{'select_servermode'} eq "") { $cfg{'select_servermode'}="standalone"; }
   if (($in{'value_new'}=~/^zraid\-\d/) && ($cfg{'select_servermode'} ne "standalone")) {
       &mess("A zraid pool cannot be created in clustermode for security reasons.<br>Switch to standalone in About &gt; Settings to create a zraid-pool and switch back to cluster-failover mode afterwards.");
   }



   #debug
   #&print_hash(%cfg);

   # Tested to work
   #$in{'value_new'}=~s/[^a-zA-Z0-9_\.\-\: \t]//g;          # allowed in poolname

   # Relaxed version of tested.
   # $in{'value_new'}=~s/[^\w:\.\-\s]//g;                  # allowed in poolname

   # http://www.sun.com/bigadmin/features/articles/zfs_overview.jsp notably omits spaces and tabs
   # however they are legal on opensolaris snv134 at least. Perhaps error checking should be left to the
   # command(?)

   #name??
   if ($in{'value_new'} eq "")    { &mess("missing poolname?"); }

   if ($in{'select_type'}=~/\[/)  { &mess("please select a vdev type with desired pool redundancy"); }

   #version
   if ($in{'select_version'}=~/\d+/) {
      $in{'select_version'}=~s/v5//;
      $ver=" -o version=$in{'select_version'}";

      if ($in{'select_version'} eq "28") {
         $ver.=" -O version=5";
      }
   }

   $opt1="";  # always even when encr
   if ($in{'select_ashift'}=~/\d/) {
       $opt2=" -o ashift=$in{'select_ashift'}"
   }

   #disable features;
   $opt="";
   if ($in{'checkbox_dis'}=~/yes/) {
       $opt=" -d";
   }

   #add opt: aclmode and aclinherit=pass-through

   #crypt
   if ($in{'autoselect_crypt'}  eq "on") {
     if ($in{'value_crypt1pass'} eq "") {                         &mess($txt{'mess_pass_needed'}); }
     if (length($in{'value_crypt1pass'}) < 8) {                   &mess($txt{'mess_minchar'}); }
     if ($in{'value_crypt1pass'} ne $in{'value_crypt2pass'}) {    &mess($txt{'mess_pass_different'}); }
   }


   #get hd-id
   $in{'checkbox_hd'}=~s/[^a-zA-Z0-9\-\_\,\.\+]//gs;        # remove special char from reload
   $in{'checkbox_hd'}=~s/\.\+$//;
   @w = split(/\.\+/,$in{'checkbox_hd'});                   # array of selected disks

#&print_array(@w);

   #number of disks
   $n=@w;

   #type ok?
   #########
     if ($n < 1)  { &mess($txt{'mess_need_disk'}); }

   #basisc
   if ($in{'select_type'} eq "basic") {
       if ($in{'select_allow'} ne "yes") { &mess("Basic vdevs are a security risk as a failure means pool lost.<br>Set allow basic vdevs to yes if you really want basic vdevs."); }
   }

   #mirror
     if (($n < 2) && ($in{'select_type'} eq "mirror"))     { &mess($txt{'mess_mirror'}); }

   #raidz
     if (($n < 2) && ($in{'select_type'} eq "raidz"))      { &mess($txt{'mess_raidz'}); }

   #raidz2
     if (($n < 3) && ($in{'select_type'} eq "raidz2"))     { &mess($txt{'mess_raidz2'}); }

   #raidz3
     if (($n < 4) && ($in{'select_type'} eq "raidz3"))     { &mess($txt{'mess_raidz3'}); }



   #create pool ex.  zpool create -f tank mirror c1d0 c2d0 mirror c3d0 c4d0
   ################################################################

   # 1. hdlist
   ###
     $n=join(" ",@w);  #list of hds: hd1 hd2 ..

   #action
   #######

    if ($in{'select_type'} =~/basic/) {
        $in{'select_type'}="";                                              #basic from form is not a valid type
    }


   # with encryption
   if ($in{'autoselect_crypt'}  eq "on") {


        $d="/usr/sbin/zpool create$opt2 -O encryption=$in{'select_str'} -f \"$in{'value_new'}\" $in{'select_type'} $n";        # spaces are allowed

  #      use Expect;
        my $exp;   #->raw_pty(1);
        $exp = Expect->spawn("sudo $d") or die "Couldn't create zpool: $!\n";

        #$exp->log_stdout(1);             # echo off
        $exp->expect(3,
                [ 'passphrase' =>
                         sub {
                             $exp->send("$in{'value_crypt1pass'}\r");
                             print "Enter passphrase: ****<br>\n";
                             exp_continue;
                         }
                ] ,
                [ 'again' =>
                         sub {
                             $exp->send("$in{'value_crypt2pass'}\r");
                             print "Enter again: ****<br>\n";
                             exp_continue;
                         }
                ]
         );
         $exp->soft_close();
         sleep(2);




   } else {                     #without encryption

          $d="zpool create$opt$opt2$ver -f \"$in{'value_new'}\" $in{'select_type'} $n";        # spaces are allowed
          $i=&socket($d);   # return stderr


        ###############################################################

   }

   #create backup on z-raid
   if ($in{'value_new'}=~/^zraid\-\d$/) {
       &exe("zpool set cachefile=/var/web-gui/_log/cluster/$in{'value_new'}.cache \"$in{'value_new'}\"");

       # create fs backup
       if ($in{'value_new'} eq "zraid-1") {
            &exe("/usr/sbin/zfs create zraid-1/backup_appliance 2>&1");
            &exe("mkdir /zraid-1/backup_appliance/cluster");
            &exe("mkdir /zraid-1/backup_appliance/cluster/jobs");
            &exe("mkdir /zraid-1/backup_appliance/cluster/user");
            &exe("mkdir /zraid-1/backup_appliance/cluster/fo_settings");
            &exe("mkdir /zraid-1/backup_appliance/cluster/comstar");
            &exe("/usr/bin/chown -R root /zraid-1/backup_appliance/cluster");
            &exe("/usr/bin/chmod -R 700 /zraid-1/backup_appliance/cluster 2>&1");
       }
   } #/zraid

  #reload
    if (-f "/tmp/acc-format.log") {  &exe("rm /tmp/acc-format.log"); }
    if (-f "/tmp/acc-parted.log") {  &exe("rm /tmp/acc-parted.log"); }
    if (-f "/tmp/acc-sas2.log")   {  &exe("rm /tmp/acc-sas2.log"); }
    if (-f '/tmp/zfsstat.log')    {  &exe("rm /tmp/zfsstat.log"); }
    if (-f "/tmp/poolstat.log")   {  &exe("rm /tmp/poolstat.log"); }

   #something wrong?
   if ($i ne "") { print $i; sleep(2); }

   #overflow protection= basic reservation of 10%
   if ($in{'checkbox_res'}=~/on/i) {
        $r=&zfslib_get_property("available",$in{'value_new'});
        my $u=$r;
        $u=~s/[^A-Z]//g;
        $r=~s/[^0-9\.]//g;
        $r=$r/10;
        $r=sprintf("%0.2f", $r);
        $r.=$u;

#&mess("$r");
        # $do= &exe("/usr/sbin/zfs set reservation=$r \"$in{'value_new'}\"");      # not needed
        $do.=&exe("zfs set refreservation=$r \"$in{'value_new'}\"");     # fres counts immediatly

        if ($do=~/cannot share/) { $do=""; }      # share on freshly creared pool creates a cannot share message
        if ($do ne "") { print $do; sleep(2); }

   }

   #aclmode and aclinherit=passthrough
   $do=&exe("zfs set aclmode=passthrough \"$in{'value_new'}\"");
   $do.=&exe("zfs set aclinherit=passthrough \"$in{'value_new'}\"");
   if ($do ne "") { print $do; sleep(2); }

   $in{'l2'}="";
   &reload;

   exit;

   #################################

}





###############################################
#end of my script, do not delete the line below
1;
