###############
sub my_action {
###############


 #override with private functions?
 ##################################
 eval { &mylib_menue_pools_add };                   # create this function in a private mylib.pl to replace this action

 my ($var1, $ant, $free, $type, $d);


 #load lib
   #&load_lib('get-disk.pl');   # get required values

# header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='Extend Pool / add vdev'</script>\n";


# 1. edited
if ($in{'answered'}) { &my_add; }     # form -> create


#&print_hash($disk);
# 2. are the free hds?
$free=$disk{'all_unused'};


if ($free eq "") {
  print " no unused disks available!";
  return;
}

if ($zfs{'allpools'} eq "") {
  print "There is no datapool available.<br>Please create a Pool!";
  return;
}

#print "pools<br>";
#print &list_pools;
#return;


# 2. get form
#########################

$var1=&disklib_list('all_unused','vendor,product,partcap');
$var1=~s/\t/,/g;

print "<b>Add a vdev to extend pool capacity</b><br>you cannot add a raid-z to a pool wher you had removed a vdev!<br>";
# form begin
  &ask('begin');

## name of pool

&ask('select_pool','Select pool',$zfs{'datapools'});

## checkboxes unused disks
   &ask('checkbox_hd','Select disks (do not select Windows disks!!)',$var1);

## how many disks
  @t=split(/,/,$free);


##type of add
  &ask('select_what','add disk(s) to a pool with vdev type<br></b>Extend a pool preferable with same regular vdevs like the current ones, ex extend mirrors by mirrors or Z2 vdevs by Z2 vdev. Use basic for regular vdevs only for testing as a disk failure means a pool lost.<br>L2Arc readcache are basic vdevs while Slog are basic or mirror vdevs. Dedup and Special vdevs require same redundancy level than regular vdevs. Prefer n-way mirrors for dedup and special vdevs.<b>',"[ ---- select carefully // partly no undo ---- ],hotspare-disk,[ ---- regular vdevs // no undo ---- ],regular-basic,regular-mirror,regular-raidz1,regular-raidz2,regular-raidz3,[ ---- SSD readcache and Slog ---- ],read-cache(L2arc),write-log(Slog),write-log-mirror(Slog),[ ---- Dedup Allocation Classes ---- ],dedup-basic,dedup-mirror,[ ---- Special Allocation Classes ---- ],special-basic,special-mirror");

# allow other vdev types
&ask('select_allow','Allow adding basic or different vdev types<br></b> ex a mirror to a pool with raid-z<br>or basic to a dedup or special vdev (pool lost on failure)<b>','no,all but basic,all');

if ($sys{'auto_os_type'}=~/ill\_/) {
    &ask('select_ashift','Force ashift (newer Illumos only)<br></b>Best for most cases is ashift=12. If you get an error about ashift, select auto. <b>You need the same ashift in all vdevs to allow a vdev remove for special vdevs',"auto,9,10,11,12,13,14,15,16","auto");
}

&ask('end');

#ashift=12
  print "<br>$txt{'pool_add_footer'}";

## info
  print "<br><br><a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a>\n";
  print "<br><br><div class='info'>$txt{'pool_add_info'}</div>";


  # show discs
    print "\n<br><br><b>$txt{'header2'}</b>\n";

    if ($sys{'auto_os'} eq "Linux") {

        # &print_hash(%disk);
        $r=&disklib_list('all_zfs_usable','header,id,MODEL,SIZE,TYPE');               #list with new lines
        print &list2table($r,'99%,180px,40px,60px,70px,70px,70px,70px,130px,120px,140px,140px,60px');

  } else {


        #$r=&disklib_list('all_inuse','header,vendor,product,revision,partcap,pool');               #list with new lines
        print &list2table($r,'100%,200px,180px,200px,250px');

  }

  #status with disk cap and  model
    $ant.=&exe("zpool status");
    my @l=split(/\n/,$ant);
    my ($s,$t,$k);
    foreach my $l (@l) {
        $t=$l;
        $t=~s/^\s+//;

        if ($l=~/NAME/) { $l.="     CAP            Product";}

        if ($t=~/^c\d|^wwn|^scsi|^ata|^sd/) {      # is disk Solaris or Linux
             $t=~s/\s.*//;     # id only
             $t=~s/s0$|p0$//;  # no slices
             $k="$t"."_partcap";
             $s=15-length($disk{$k});

             $l.="     $disk{$k}"." "x $s;
             $k="$t"."_product";
             $k=~s/p\d//;                        #disk not part
             $l.=$disk{$k};
        }

    }
    $ant=join("\n",@l);
    $ant=~s/FAULTED/<font style='color:red'>FAULTED<\/font>/gs;
    $ant=~s/UNAVAIL/<font style='color:red'>UNAVAIL<\/font>/gs;
    $ant=~s/REMOVED/<font style='color:red'>removed<\/font>/igs;
    $ant=~s/\bAVAIL/<font style='color:blue'>AVAIL<\/font>/gs;
    $ant=~s/INUSE/<font style='color:blue'>INUSE<\/font>/gs;
    $ant=~s/DEGRADED/<font style='color:blue'>DEGRADED<\/font>/gs;


    print "<br><br><table style='width:100%'>\n";
    print "\t<tr>\n";
      print "<td class=\"td1_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<b>zpool status</b></td>";
    print "\t<tr>\n";

    print "\t<tr>\n";
      print "<td class=\"td2_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<pre>$ant</pre></td>";
    print "\t<tr>\n";

    print "</table>\n";



} #/ my_action
################



##############################################################################
sub my_add {
################
   my ($i,@w,$n,$type,$what,$pool,$cap,$vt,$r,$opt);

   #debug
   #&print_hash(%in);

   # name of pool-> select_pool
   # what to add -> select_what

   # disks
   # checkbox_hd => c1t4d0_(VMware-Virtual_disk-1.0-9.00GB).+c1t5d0_(VMware-Virtual_disk-1.0-10.00GB).+c1t6d0_(VMware

   #get hd-id
   $in{'checkbox_hd'}=~s/[^a-zA-Z0-9\-\_\,\.\+]//gs;    # remove special char from reload
   $in{'checkbox_hd'}=~s/\.\+$//;
   @w = split(/\.\+/,$in{'checkbox_hd'});                # array of selected disks

#stop
#&print_array(@w); exit;

   #number of disks
   $n=@w;

   #optional with select_part
   #if (@w ==1) {
   #    if (($in{'select_what'} eq "read-cache") || ($in{'select_what'} eq "write-log"))    {
   #        # partition
   #        if ($in{'select_part'}=~/\d/) {
   #           $w[0]=$w[0].="$in{'select_part'}";
   #        }
   #    }
   #}


   #type ok?

   #########
   if ($n < 1) { &mess('please select one or more disks'); }
   if ($in{'select_what'}=~/\[/) { &mess('please select a vdev option'); }

   #cache without mirror
    if (($n ne "1") && ($in{'select_what'} =~/cache$/)) { &mess('cache requires 1 disk'); }

   #mirror
     if (($n < 2) && ($in{'select_what'} =~/mirror$/))  { &mess('mirror requires 2 or more disks'); }

   #z1
     if (($n < 2) && ($in{'select_what'} =~/raidz1/))   { &mess('raidz1 requires min. 2 disks'); }

   #z2
     if (($n < 3) && ($in{'select_what'} =~/raidz2/))    { &mess('raidz2 requires min. 3 disks'); }

   #z3
     if (($n < 4) && ($in{'select_what'} =~/raidz3/))    { &mess('raidz3 requires min. 4 disks'); }


   # single disk
   if ($n < 2) { $type=""; }                # basic

   #what (vdev type, '' for regular vdev

   $what="spare";                           # default/uncritical/basic ()
   if ($in{'select_what'}=~/regular/) {
        $what="";
   } else {
       #
       if ($in{'select_what'} =~/cache/)        { $what="cache";   }
       if ($in{'select_what'} =~/log/)          { $what="log";     }

       if ($in{'select_what'} =~/dedup/)        { $what="dedup";   }
       if ($in{'select_what'} =~/special/)      { $what="special"; }

       if ($in{'select_what'} =~/spare/)        { $what="spare";   }
   }

   #type
   $type='';  # default/basic
   if ($in{'select_what'} =~/basic/)        { $type="";  }
   if ($in{'select_what'} =~/mirror/)       { $type="mirror";  }
   if ($in{'select_what'} =~/z1/)           { $type="raidz1";  }
   if ($in{'select_what'} =~/z2/)           { $type="raidz2";  }
   if ($in{'select_what'} =~/z3/)           { $type="raidz3";  }

   $opt="";  #
   if ($in{'select_ashift'}=~/\d/) {
       $opt=" -o ashift=$in{'select_ashift'}"
   }

   #################

   # 1. hdlist
   ###
     if ($sys{'auto_os'} eq "Linux") {      # use id not sd
        foreach my $w (@w) {
           $t=$w."_id";      $w=$disk{$t};
        }
     }

     $n=join(" ",@w);  #list of hds: hd1 hd2 ..

   #action
   #######
   # add pool ex. zpool add -f tank log mirror c1d0 c2d0
   ####


   # hinder unwanted adding of basic
   if ($in{'select_what'}=~/basic/) {                 # really??
        if (!($in{'select_allow'} eq "all")) {
           &mess("You should add a basic vdev only for testing purpuses as a failure means whole pool lost<br>To force basic vdevs, select allow = all");
        }
   }

   # checkvdev types of pool, hinder unwanted different one to extend regular vdevs
   if ($in{'select_what'}=~/regular/)  {
        $in{'select_what'}=~s/regular\-//;

        $r=&exe("zpool status \"$pool\"");        # tab sp sp vdev    (vdevs location)

        # $r=~s/\t/(tab)/gs; $r=~s/ /(sp)/gs;
        #&print_var($r);

        # remove up to pool name  tab name sp sp
        $r=~s/.*\t$pool  //s;

        # keep only regular vdevs
        $r=~s/\t  cache.*//s;
        $r=~s/\t  log.*//s;
        $r=~s/\t  dedup.*//s;
        $r=~s/\t  special.*//s;

        $r=~s/errors: .*//s;

        #$r=~s/\t/(tab)/gs; $r=~s/ /(sp)/gs;
        #&mess($r);

        @t=split(/\n/,$r);

        $vt="";
        foreach my $t (@t) {                       # tab sp sp vdev    (vdevs location)
           if ($t=~/\t  mirror/)  { $vt.="mirror,"; }
           if ($t=~/\t  raidz1/)  { $vt.="raidz1,"; }
           if ($t=~/\t  raidz2/)  { $vt.="raidz2,"; }
           if ($t=~/\t  raidz3/)  { $vt.="raidz3,"; }
           if ($t=~/\t  c\d/)     { $vt.="basic,";  }
        }
        $vt=~s/,$//;

    #debug
    #&mess("current types: $vt<br>add what: $in{'select_what'}");

        # hinder adding a different vdev type
        if (!($vt=~/$in{'select_what'}/)) {             # pool has already this type
               if (!($in{'select_allow'}=~/all/)) {
                  &mess("You should add a $in{'select_what'} vdev only to a pool that already contains $in{'select_what'} vdevs<br>or when you set allow to all<br><br>Pool has currently $vt vdevs ");
               }
        }
    }

    $d="zpool add$opt -f \"$in{'select_pool'}\" $what $type $n";
    $d=~s/ +/ /g;

#debug/stop
#&mess("$d");

    print "please wait..<br>$d\n";
    $i=&exe($d);   # return stderr

   #something wrong?
   if ($i ne "") { print $i; sleep(2); }

   print "disks $n added ($what)";
   print ", reload disk info..\n";

   sleep(1);

   $in{'l3'}="";
   &reload;
}





###############################################
#end of my script, do not delete the line below
1;
