###############
sub my_action {
###############
my ($r, $txt,$t,$pool);

# create snap jobs
# 4. mar include esxi hotsnaps in snaps via soap

#form answered
if ($in{'sel_job'} ne "") { $in{'answered'}=""; }        # delete selected
if ($in{'answered'}) { &write_job; }                     ##write job to joblist


#print overview
############################
    &jobslib_job_overview();

     # header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='$txt{'jobs_header'}'</script>\n";

#create form
#############

    #ask basic infos like time
    ##########################
    print "<b>create new auto-snap job</b><br>";
    &ask('begin');

    $r=&zfslib_list('');
    &ask('select_pool','Pool or ZFS to snap',$r);                          #pool or zfs
    &ask('select_disable-rec','Disable recursive snaps (default: use recursive)','no,yes');

    &ask('value_name','Name of snapjob (ex daily)','daily');

    print "Retention policy, keep and optional hold must be both true to delete";
    &ask('select_max','Minimum number of snaps to keep','1,2,3,4,5,6,7,8,9,10,11,12,14,20,21,24,26,28,30,40,52,60,90,120,180,360,720,1000','2');
    &ask('value_hold','Minimum number of days to hold ex 8 (opt)','8','w50m4');

    #pre/post job
    &ask('select_prejob','Run a pre/post script','no,yes');

    # esxi hotsnaps via soap
    &ask('value_esxi','This filesystem is a NFS datastore for ESXi server with ip<br></b>to include ESXi restorable hotmemory snaps in ZFS snaps<br>Setup in menu System > ESXi > NFS datastores<b>');

    print "Can give problems on filesystems containing auto-replications.";
    &ask('checkbox1','delete multiple snaps with size = 0','yes','');


    print "<br><br><b> Timetable</b><br>\n";
    &ask('select_month','Month (1..12)','every,every-2,every-3,every-4,every-6,1,2,3,4,5,6,7,8,9,10,11,12','every');
    &ask('select_day','Day (1..31 sun..sat)',',every,every-2,every-3,every-7,every-14,every/1,mon-fri,mon-sat,sat-sun,first-sat,first-sun,sun,mon,tue,wed,thu,fri,sat,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31','every');
    &ask('select_hour','Hour (0..23)','every,every-1BC,every-2,every-2BC,every-3BC,every-4,every-6,every-6BC,every-12,every/0,every/23;0;1,0,3,6,7,8,9,10,11,12,13,14,15,16,17,18,19,22,23,8;12;16,8;10;12;14;16;18,8;11;14;17;20,0;6;12;18','23');
    &ask('select_min','Minute',',every,every-5,every-15,every-20,every-30,every/0,15;45,0,15,30,45,once','0');
    &ask('select_status','Status','manual,active','active');

    print <<EoF;
<br><b>md-5 verify snapshot</b> (requires Monitor Extension)<br><br>
If you need to verify content of archive-snaps, you can generate and save md5 hashes of each file in a textfile,<br>
optionally print out and sign it. The list is generated via 'digest -a md5 -v file' and saved in a folder or ZFS /pool/validate.<br>
You should not activate on large pools but smaller filesystems or your job will run a very long time.
EoF

   if ($cfg{'ver'}=~/c|m/) {
       print "<br><br>";
       &ask('checkbox_md5','generate checksums','yes','');
   }


    # save to rpool or HA datapool
    print "<b><br>";
    $t="no";

    $r=`sudo test -d /zraid-1/backup_appliance/cluster/jobs/ && echo 1 || echo 2`;    chomp($r);
    if ($r eq "1") { $t="no,yes"; }
    &ask('select_clusterjob',"Cluster aware snap-job for zraid-1</b>.<br>Job can be automatically switched to a head on a failover<b>","$t");

    print "<br>";
    &ask('end');

    print "<br><br>Info: 0-3-5 means 0, 3 and 5<br>every-2 (hour) means every two hours<br>every-1BC (hour) means every hour between 6-11 and 11-18 hour (ABCD, each 6 hours from 0..23)";
    print "<br>every month can be every, every-2, every-3,every-4, every-6";
    print "<br>every day can be every, every-2, every-3, every-7, every-14";
    print "<br>every hour can be  every, every-2, every-3, every-4, every-6, every-12, opt followed by ABCD - A=0..5, B=6..11, C=12..17, D=18..23";
    print "<br>every minute can be every, every-3, every-5, every-10, every-15, every-20, every-30";
    print "<br>minute=once means: execute job once after each reboot";


} #/ my_action
##############





################################################################################################
sub write_job {    # write job to joblist
################

  # call editpar from menu job create
  if ($in{'action'} eq 'editpar') { return; }        #

  my ($action,$id,$var,$del);            #

  # 1. parse input
  ################
      $in{'value_name'}=~tr/A-Z/a-z/;
      $in{'value_name'}=~s/[^a-z0-9\-]//;     #allowed in name. snap will have name pool@name_time

      if ($in{'value_name'} eq "") { &mess('unallowed or empty snapname'); }
      $in{'value_hold'}=~s/\D//g;


  # 2. id of this job ########
  ############################
  $id=time();

  # 3. needed variables for this job :  pool=syspool \n keep=3 \n name=snapname, (predefined are id=sec from 1970),
  ###################################
    $var ="job=snap\n";
    $var.="pool=$in{'select_pool'}\n";
    $var.="disable-rec=$in{'select_disable-rec'}\n";
    $var.="keep=$in{'select_max'}\n";
    $var.="hold=$in{'value_hold'}\n";
    $var.="name=$in{'value_name'}\n";
    $var.="prejob=$in{'select_prejob'}\n";
    $var.="esxi_ip=$in{'value_esxi'}\n";                              # ip, this is a filesystem -> ESXi NFS
    if ($in{'checkbox1'} ne "") {  $var.="delzero=yes\n"; }  else {$var.="delzero=no\n";  }

  # date
    $var.="month=$in{'select_month'}\n";
    $var.="day=$in{'select_day'}\n";
    $var.="hour=$in{'select_hour'}\n";
    $var.="min=$in{'select_min'}\n";
    $var.="status=$in{'select_status'}\n";
    $var.="clusterjob=$in{'select_clusterjob'}\n";
    $var.="last=new\n";

  #md5
    if ($in{'checkbox_md5'} ne "") {
         $var.="md5=yes\n";
    }


#debug
#&mess("<pre>id=$id\n$var");

  # 3. create job.par with variables inside
  ##########################################
    my $f="/var/web-gui/_log/jobs/$id.par";     # jobfile

    # optionally HA setup
    open (F,">$f");
          print F "$var";
    close (F);

    # cluster-job
    if (($in{'select_clusterjob'} eq "yes") && ($in{'select_pool'}=~/^zraid\-1/)) {
        $r=`sudo cp $f /zraid-1/backup_appliance/cluster/jobs/$id.par`;
    }

  # reload page
  reload;

} #/ write job
###############


####
#end of my script, do not delete the line below
1;
