use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

                        my ($out, $var);  # declare all your variables as local or you will get errors

                         # header
                         print "<script language='javascript'>document.getElementById('hl').innerHTML='$txt{'jobs_header'}'</script>\n";

                        # declare later needed vars ($hour,..), used in auto.pl
                        use vars qw($date $hour $min $sec $source_ip);

                        ##################################################
                        # debug mode:
                        # create file /tmp/debug
                        # stop execution via
                        # print('message');  exit;  # message is displayed
                        ##################################################

                        # menue actions
                        ###############


                        ###############################################
                        # part 1: do function, if question is answered
                        ##############################################


                        if ($in{'sel_job'} ne "") { $in{'submit_ok'}=""; }        # delete selected

                        if ($in{'submit_ok'} ne "") {      # submit
                            &write_job;       # do it
                        }



                        ##############################
                        # or create a form to ask user
                        ##############################

                        &sync_source_target;     # source target of sync


} #/ my_action



################################################################################################
sub write_job {    # write job to joblist
################

  # call editpar from menu job create
  if ($in{'action'} eq 'editpar') { return; }        #

  # 1. parse input
  ################

    my $source_ip = $in{'autoselect_host'};
    $source_ip=~s/.* //;

    $in{'value_zfs_name'}=~s/\s//g;
    if ($in{'value_zfs_name'} eq '') {
        $in{'value_zfs_name'} = $in{'select_src_zfs'};
        $in{'value_zfs_name'}=~s/^.*\///;
    } else {
        $in{'value_zfs_name'}=~s/[^a-zA-Z0-9_\.\-:]//g;            # allowed in name
        if ($in{'value_zfs_name'} eq '') { &mess('ERROR: name of dataset; Please enter a valid name of dataset'); }
    }
    my $dest = $in{'select_dest_zfs'};
    $in{'select_dest_zfs'} .= "\/$in{'value_zfs_name'}";


    #source = target on local transfer
    if ( $in{'autoselect_host'}=~/127\.0\.0\.1/) {
       if ($in{'select_dest_zfs'}=~/$in{'select_src_zfs'}\b/)  { &mess("local sync: source and destination must be different/ target cannot contain source!<br>$in{'select_src_zfs'} -> $in{'select_dest_zfs'}");  }
    }
    $in{'autoselect_host'}=~s/ .*//; # hostname only

    my $target_host = &exe("hostname");
    chomp($target_host);

    # port from id > 50000
    # $port=((($id / 60) % 55500) + 10000);
    my $id = time();
    my $port=substr($id,-4,4);
    my $sum="";
    my @sum=split(//,$id);
    foreach my $char (@sum) { $sum=$sum+ord($char); }
    $port=$sum+50000+$port;


    # 2. needed variables for this job :  pool=syspool \n keep=3 \n name=snapname, (predefined are id=sec from 1970),
    ###################################

    my $var="source_host=$in{'autoselect_host'}\n";
    $var.="source_ip=$source_ip\n";
    $var.="target_host=$target_host\n";
    $var.="target_ip=$in{'autoselect_target_ip'}\n";
    $var.="source=$in{'select_src_zfs'}\n";

    $var.="destination=$in{'select_dest_zfs'}\n";
    $var.="type=$in{'select_type'}\n";                                # tar netcat
    $var.="id=$id\n";

    # local?
    my $rec="";
    if  ($in{'autoselect_host'} eq $target_host) {
               $var.="local=yes\n";
               $rec="sync,cp";
    }  else {
               $rec="tar,netcat";
    }


    $var.="stop=1\n";                                             # set to 1, if you want to stop it based on psinfo
    $var.="auto_stop=0\n";                                        # set to 1, if you have a sub auto_stop to process other things after killing processes

  ############################



  # 3. create job.pre with variables inside
  ###########################################
  # Options in field Text2
    if ($rec eq "") { $rec="-"; }
    &jobslib_job_create($id, $var, "$source_ip\-$port", "$in{'autoselect_host'}\/$in{'select_src_zfs'}", $rec, $in{'select_dest_zfs'});     #parameter id,var,text1,opt1,text2,opt2,ps info

  # reload page
    $in{'l3'}="";
    &reload;
    exit;
} #/ write job
###############



############### auto_job begin ######### do not remove or rename this line
sub auto_job {   # set needed variables as =variable= - they are stored via sub write_job when creating a job
##############

    # parameter from rewrite/create
    $sys{'port'}       = 81;
    my $id                = "=id=";
    my $source_host       = "=source_host=";
    my $target_host       = "=target_host=";
    my $source_ip         = "=source_ip=";
    my $target_ip         = "=target_ip=";
    my $source            = "=source=";
    my $destination       = "=destination=";             # zfs/folder

    #parameter: jobid action sourcehost targethost 'sourcezfs' 'targetfolder'
    my $r=`perl /var/web-gui/data/napp-it/zfsos/_lib/extensions/synclib.pl =id= sync =source_ip= =target_ip= '=source=' '=destination='`;
    return($r);

} #/auto job


##############
sub auto_stop  {    # cancel/ kill job
##############
      # how to kill it.
      # example stop remote zfs send, delete opt snaps
      # needed script in jobslib is todo

      #parameter: jobid action sourcehost targethost 'sourcezfs' 'targetfolder'
      my $r=`perl /var/web-gui/data/napp-it/zfsos/_lib/extensions/synclib.pl =id= kill =source_ip= =target_ip= '=source=' '=destination='`;
      return($r);

} #/auto stop

###############
sub auto_delete  {    # delete job
###############

    # actions when deleting a job:
    # -> opt delete source snap: done in stop


} #/auto delete


# auto_job end  #########  do not remove or rename this line
#########################




###########################
sub sync_source_target {   #  get source and target of a sync
###########################
    my (@source,@target,$s,$t,@g,$g,$r,@w,$w,$hostname,@h,$v);


    # always a member
       $hostname=`hostname`;
       chomp($hostname);


    #read list of groups-members
       $t=$cgipath."_log/group";
       @t=();
       &read_dir("$t","t");
       foreach $t (@t) {
                if (!($t=~/~\d+\.\d+\.\d+\.\d+\.txt/)) { next; }                #np group member
                $t=~s/~/ /; $t=~s/\.txt$//;
                push (@g,"$t");
       }
 #      &print_array(@g);
 #      &print_var($t);


       if ($in{'autoselect_host'} eq "") { $in{'autoselect_host'}="$hostname 127.0.0.1"; }        #default

       #zfs list (source)
       if ($in{'autoselect_host'} eq "$hostname 127.0.0.1") {
         $r=&exe("zfs list -t filesystem,volume");
         @w=split(/\n/,$r);
         foreach $w (@w) {
            if ($w=~/^$zfs{'syspool'}\b/) { next; }
            $w=~s/\s.*//;
            if ($w eq "NAME") { next; }
            if (!($w=~/\//)) { next; }      # source and target only datasets, not the pool
            push (@target,$w);
            push (@source,$w);
         }

       } else {        # remote source

            $w=$in{'autoselect_host'}; $w=~s/ .*//;                #hostname only
            $r=&grouplib_ask_remote_zfslist($w,"","","grouplib_source_target 709");            #commalist
            @w=split(/,/,$r);
            foreach $w (@w) {
              $w=~s/\s.*//;
              if (!($w=~/\//)) { next; }      # only datasets, not the pool
              push (@source,$w)
            }

            #get target
            $r=&exe("zfs list -t filesystem");
            @w=split(/\n/,$r);
            foreach $w (@w) {
                    if ($w=~/^$zfs{'syspool'}\b/) { next; }
                    $w=~s/\s.*//;
                    if ($w eq "NAME") { next; }

                    push (@target,$w)
            }

       }

       #form source




        print "<div class='info'>$txt{'jobs_sync_info'}</div><br>";
        print "<b style='color:red'> - under development - not ready to use - </b><br><br>";


        my $ip=&exe("ifconfig -a");
        @t=();
        @t=split(/\n/,$ip);

        $ip="";
        foreach my $t (@t) {
                $t=~s/^\s+//;
                if (!($t=~/^inet /)) { next; }
                $t=~s/inet //;
                $t=~s/ .*//;
                if (!($t=~/\d+\.\d+\.\d+\.\d+/)) { next; }
                if ($t eq "127.0.0.1") { next; }
                $ip.="$t\t";
        }
        $ip=~s/\t$//;

        &ask('begin','b');

        print " <b style='background-color:#dddddd'>Highspeed snap- and filebased sync including Windows/ NFS4 ACL from:</b><br><br>";

        $g=join(",",@g);
        &ask('autoselect_host','Source host',$g,$in{'autoselect_host'});

        $s=join(",",@source);
        &ask('select_src_zfs','Source Pool/ ZFS',$s,$in{'select_src_zfs'});

        print "<br> <b style='background-color:#dddddd'>Sync to Localhost (One-Way)</b><br><br>";

        &ask('autoselect_target_ip','My ip, used for sync',$ip,$in{'target_ip'});
         $t=join(",",@target);
        &ask('select_dest_zfs','Name of ZFS to keep in sync',$t,$in{'select_dest_zfs'});
        &ask('value_zfs_name','opt. use a target folder within',$in{'value_zfs_name'});

        print "<br> <b style='background-color:#dddddd'>Options:</b><br><br>";
        &ask('select_type','Remote sync type','tar via netcat',$in{'select_type'});

        print "<br><br><b style='background-color:#dddddd'> Timetable</b><br><br>\n";

        $t=&getv($cfg{'app_sync'});      # registered or evaluation
        if ($t=~/eval/i) {
            &ask('select_month','If you want to use timetables and remote sync, <br>you must register the sync extension.','manual','manual');
        } else {
           &ask('select_month','Month (1..12)','every','every');
           &ask('select_day','Day (sun..sat 1..31)','every,sun,mon,tue,wed,thu,fri,sat,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31','sun');
           &ask('select_hour','Hour (0..23)','every,every-2,every-2BC,every-3BC,0,3,6,9,12,15,18,21','0');
           &ask('select_min','Minute (15 Min interval)','every,every-3,every-5,every-10,every-15,every-20,every-30,0,15,30,45,','0');
        }

        &ask('hidden','changed','1');

        print "<a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a>\n";
        print "<div class='info'>Info: 0-3-5 means 0, 3 and 5<br>every-2 (hour) means every two hours<br>every-1BC (hour) means every hour between 7-12 and 13-19 hour (ABCD, each 6 hours from 0..23)";
        print "<br>every month can be every, every-2, every-3,every-4, every-6";
        print "<br>every day can be every, every-2, every-3, every-7, every-14";
        print "<br>every hour can be  every, every-2, every-3, every-4, every-6, every-12, opt followed by ABCD - A=0..5, B=6..11, C=12..17, D=18..23";
        print "<br>every minute can be every, every-3, every-5, every-10, every-15, every-20, every-30";
        print "<br><br>Your source/target must have different hostnames and should not change IP";
        print "<br>Your target ZFS is read-only after replication. After disabling replication, you can set it to read/write and use it at usual";
        print "</div><br><br>";

        &ask('end');    # create job , start it manually
        print "<br>ZFS Sync is one-Way sync, speed optimized and unencrypted. <br>If you want to sync over unsecure networks like Internet, a VPN link is suggested!<br>\n";

        #print_array(@source);
}


###############################################
#end of my script, do not delete the line below
1;