#
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my ($appl, $r, $out, $var, @t, @ip, @search, @v, $child);  # declare all your variables as local or you will get errors

  #&print_hash(%cfg);

  if ($sys{'auto_os'} eq "Linux") { &mess('Currently only available on OI/OmniOS/Solaris'); }
  &load_lib('grouplib.pl');

  # add to search
  @search=();                            # optionional add ("172.16.1.","172.16.2.","172.16.3.")

  &log_end;
  ####################################
  print "Netscan: <br><br>";
  ###################################

  # fork parent=monitor, child=task;  #my parent=$$;
        $child=fork();
        if ($child) {    # parent process
              &my_search;
        } else {
              &my_monitor;
        }

  exit;

} #/ my_action


#############   #show version
sub my_show_ver {
#############
my $ip=$_[0];
my $r;

                        #connect via netcat on port $sys{'port'} (81)
                        $r=`perl -e 'print\"GET /cgi-bin/admin.pl?action=rgroup   HTTP/1.0\n\n\"' | nc -w 5 $ip 81`;
                        if ($r eq "")                         {
                                                    return("<font style='color:red'>remote call: timeout</font>");
                          } else {
                                                    if ($r=~/refused/s)    { return("connection refused"); }
                                                    if ($r=~/napp-it-ok:/s)  {
                                                          $r=~s/.*napp-it-ok://s;
                                                          $r=~s/: command not found//s;
                                                          return ($r);
                                                    }  else {
                                                          return("not a napp-it server");
                                                    }
                         }
}

#############
sub my_search {
#############
  my ($r,@search,@v,$out,@ip,$log,$appl,@sorted);

  #read appliances.log
  $log="/var/web-gui/_log/monitor/appliances.log";
  `sudo touch $log`;  `sudo chmod 666 $log`;

  #get my ip's
  $r=&exe("ipadm show-addr -o ADDR");
  chomp($r);
  @t=split(/\n/,$r);
  foreach my $t (@t) {
     if ($t=~/^127/)    { next; }
     if ($t=~/:/)       { next; }          # ip v6
     if (!($t=~/^\d/))  { next; }


     # discard last                        # ex 192.168.1.23/24
     @v=(); @v=split(/\./,$t);
     $t="$v[0].$v[1].$v[2].";              # 192.168.1.

     if ($out=~/$t,/)    { next; }
     push(@search,"$t");                   # my networks
     $out.="$t,";
     print "$t"."0, ";

  }

  #@search=("192.168.88.","172.16.1.");
  # scan netorks
    for my $s (@search) {
        print "<hr>$s<hr>";
        for (my $i=1;$i<255; $i++) {

             # step 1 ping
             $r=`/usr/sbin/ping $s$i 1`;
#print "sudo ping $r<br>";
             if ($r=~/no answer/s) {

#print " $s$i no reply<br>";
                  next;
             }

            $r=`nc -z $s$i 81 2>&1`;
            chomp($r);
            if ($r=~/succ/s) {
                push(@ip,"$s$i");
               # print " $r";
                $r=&my_show_ver("$s$i");
                print "$s$i -> $r<br>";

                #print "<br>log $s$i to /var/web-gui/_log/monitor/appliances.log";
                @t=();
                open(PF, "<$log");
                     flock(PF, LOCK_EX);
                     @t = <PF>;
                close(PF);
                $appl=join("",@t);
                $appl=~s/\n//gs;

                if (!($appl=~/$s$i/s)) {
                    if ($r=~/v\.|Version/)  {

                        $t=~s/p_stat.*//;  # stat
                        # print " -> update appliances.log";
                        # update /var/web-gui/_log/monitor/appliances.log`;
                        push(@t,"$s$i \n");             # ip only

                        #@t= sort { $a <=> $b } @t;
                        @t=sort @t;
                        #&print_array(@t);

                        $t=join("",@t);
                        open (PF, ">$log");
                            flock(PF, LOCK_EX);
                            print PF "$t";
                        close (PF);
                    }
                }

                next;
            }
#print " $s$i up but not answering on port 81<br>";

        }
    }
}

## monitor ##
sub my_monitor {
##############  # kill hanging nc -z
my ($r,$t,$old,@t,@new);
  while(1) {
            sleep(1);
            $r=`ps axw | grep 'nc -z' | grep 81`;               #all nc
            if ($r eq "") { next; }

            @new=();
            @new=split(/\n/,$r);
            foreach $t (@new)  {
                 $t=~s/^ +//;  $t=~s/ .*//;    #keep ps
                 if ($old=~/$t\b/) {
                      $r=`sudo kill -9 $t 2>&1`;
                      next;
                      #print "kill -9 $t -> $r <br>";
                 }   # hanging
            }
            $old=join(" ",@new);
            #print "old=$old<br>";
  }
}



###############################################
#end of my script, do not delete the line below
1;