#!
use strict;         # check for proper code

###############
sub my_action {
###############
# keyserver 16.8.19

  my ($out, $var);  # declare all your variables as local or you will get errors
  &get_my_data;

  print <<EoF;
  <b style='font-size:16px'>Keyserver status</b><br><br>

  The keyserver functionality allows to store keys for encrypted filesystems and request them via your webserver and https. <br>
  The keyserver stores the keys on an encrypted filesystem either on a local pool or one from a remote iSCSI target.<br><br>

  To make the keys accessable you must first unlock this key filesystem manually.<br><br><br>


EoF

  &ask('value_1','Keyserver license status',$current{'keyserver_l'},'w300m250readonly');
  &ask('value_1','Keyserver enabled in appliance settings ',$current{'keyserver_en'},'w300m250readonly');
  print "<br>";
  &ask('value_1','Key path ',$current{'keyserver_p'},'w300m250readonly');
  &ask('value_1','Key path available/accessable ',$current{'keyserver_a'},'w300m250readonly');

  # header
  print "<script language='javascript'>document.getElementById('hl').innerHTML='Keyserver'</script>\n";
  &log_end;
} #/ my_action


 #################
 sub get_my_data {
 #################
     if ($cfg{'select_keyserver'} eq "yes") { $current{'keyserver_en'}="enabled"; } else { $current{'keyserver_en'}="disabled"; }
     if ($cfg{'pver'} =~/c/)                { $current{'keyserver_l'}="ok, complete license"; }  else { $current{'keyserver_l'}="complete license required";  }
     if ($cfg{'value_keyserver_path'} eq "") {
        $current{'keyserver_p'}="not defined";
        $current{'keyserver_a'}="-";
     } else {
        $current{'keyserver_p'}="$cfg{'value_keyserver_path'}";
        my $r=`sudo test -d "$current{'keyserver_p'}" && echo 1 || echo 2`;  chomp($r);
        if ($r eq "1") {
            $current{'keyserver_a'}="yes";
        }  else {
            $current{'keyserver_a'}="not available or locked";
        }
     }
 }



###############################################
#end of my script, do not delete the line below
1;