# get-disk-status.pl
# edited 3.01.2018
#
# (c) napp-it 2010-2018
# fill %disk with disk infos from cfgadm (configured etc)


use strict;
&get_mydisk_stat;           # add  infos to %disk    (preloaded on menu disk controller only)


######################  was  &disklib_ctrl via cfgadm
sub get_mydisk_disklib_ctrl  {  #hide:
######################         (disk details)
   my ($r,@w,@i,@c,$t,$i);


   # get disk of controller
   $r=&exe("cfgadm -avl","n",'get-disk-status.pl 21');                # sata0/0::dsk/c0t0d0                    disk         connected    configured   ok

   $r=~s/\nunavailable//gs;                                           # add info from second line

   @w=split(/\n/,$r);
   $r="";

   foreach $t (@w) {
        chomp ($t);
        if (!(($t=~/^When/i) || ($t=~/connected/))) { next; }

        if ($t=~/^When/i) { $t.=" Modell";}
        $t=~s/^When/Interface/;
        $t=~s/Type /Type\/Online /;

        $t=~s/ +/\t/g;
        $t=~s/\t+$//;
        @i=split(/\t/,$t);

        $r="$i[0]\t$i[1]\t$i[2]\t$i[3]\t$i[4] $i[5] $i[6] $i[7] $i[8] $i[9] $i[10] $i[11]";
        $r=~s/ +$//;
        push (@c,$r);
   }

   $t=join("\n",@c);
   $current{'disklib_ctrl'}=$t;
   return $t;
}


######################
sub get_mydisk_stat  {
######################         (disk details)
##!! get_mydsk_stat in disklib.pl

  my (@w,$w,$key,$k,$n,@p,$p,$r,$i,$v,@v,$d,@d,$id,$guid,$phys,$devid,$j,$ids,$out,$device,$t);


  #get controller-infos
  $out= "Collect available Controllerinfo via cfgadm -avl\n";
  $r=&get_mydisk_disklib_ctrl;


 #test
 # &mess("r=<br>$r");

  #get disks out of list
  @w=split(/\n/,$r);

#debug
#&print_array(@w);

  foreach $w (@w) {

           # first line
           if ($w=~/^Interface/) { next; }

           #parameter
           @p=();
           @p=split(/\t/,$w);


           #disk
           if ($w=~/^[a-zA-Z0-9\/]+::/) {         # disk c1::

                 if (!($w=~/dev\/dsk/)) {  next; }          # not a disk

                 $out.="disk $w\n";

                 #get interface
                 #c13::dsk/c13t0d0 connected configured unknown Solidata SSD
                 $i=$p[0];
                 $device=$p[0];

                 $p[0]=~s/.*\///;    # id:  c1::dsk/c1t0d0 -> c1t0d0
                 $id=$p[0];
                 $i=~s/:.*//;        # if

                 # get device
                 $key=$id."_device";
                 $device=~s/ .*//;
                 $disk{$key}=$device;


                 #opt, da obiges bei  LSI2008 Fehler macht
                 # ex disk c4::w50014ee0ab86f82e,0 connected configured unknown Client Device: /dev/dsk/c1t50014EE0AB86F82Ed0s0(sd2)

                 if (!($disk{$key}=~/^.+::dsk/)) {

                     $t=$w; $t=~s/.*dsk/dsk/;
                     $t=~s/s\d+.*|p\d+.*//;

                     $id=$t;
                     $id=~s/dsk\///;               # dsk/c1t50014EE0AB86F82Ed0

                     $key=$id."_device";
                     $disk{$key}=$i."::$t";

                     $key=$id."_if";
                     $disk{$key}=$i;

                 }   else {
                      #id.interface
                      $key=$id."_if";
                      $disk{$key}=$i;
                 }


                 #id.online
                 $key=$id."_online";
                 $disk{$key}=$p[1];

                 #disk connected
                 if ($p[1] eq 'connected') {
                   $disk{'connected'}.="$id\t";
                 }

                 #id.busy
                 $key=$id."_busy";
                 $disk{$key}=$p[2];
                 if ($p[2] eq 'configured') {
                      if (!($disk{'configured'}=~/$id\b/)) {
                         if ($id=~/^c\d/) {
                           $disk{'configured'}.="$id\t";
                         }
                      }
                 } else {
                     if ($id=~/\w\d/) {                                   # is a disk
                         $id=~s/\s.*//;
                         if (!($disk{'notconfigured'}=~/$id\b/)) {
                            $disk{'notconfigured'}.="$id\t";
                         }
                      }
                 }


                 #id.phys
                 $key=$id."_phys";
                 $disk{$key}=$p[3];

                 #id.modell
                 $key=$id."_modell";
                 $disk{$key}=$p[4];


                 #sn
                 if ($w=~/SN: /) {
                 $key=$id."_sn";
                 $disk{$key}=$w;
                 $disk{$key}=~s/.*SN: //;

                 $disk{$key}=~tr/a-z/A-Z/;                                 # normalize wg lsi sas2
                 $disk{$key}=~s/[^A-Z0-9]//g;

                 #
  #$disk{$key}=~s/ .*//;
  #&print_var($disk{$key});
                 }


                 next;
           }
           $out.="controller $w\n";
           $w=~s/\s.*//;
           $disk{'controller'}.="$w\t";
  }

  # optional
  $disk{'all_dsk'}=~s/^\t+//;

 # &print_hash(%disk);

    my $t=&getv($cfg{'app_acc'});
    if ($t=~/val/is) { sleep(1);  }

}

# eof
1;
