# job functions for napp-it    Copyright (c) 2009-2020 Gnther Alka
################################
# functions are autoloaded if action contains &thislib_xx() ex &zfslib_list() will autoload zfslib via require

#13.jan add user namelength >8

#########
sub userlib {  # 13.jan.2020
########################### del user problem
}

####################
sub userlib_del_map {
####################
  my ($r);
  my $m=$in{'sel_map'};
  $m=~s/\.\+$//;
  if ($m eq "") { return; }             # nothing selected

  my @m=split(/\.\+/,$m);
  foreach my $t (@m) {
     print &exe("idmap remove \'$t\'")."<br>";
  }
  sleep(3);
  return;

&print_array(@m);
&print_hash(%in);

}

########################
sub userlib_idmap_overview {
########################
       my ($r,$i,@i,@v,$v,$l,@l);

       my $url="<a title='add idmapping' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;prop==prop=\">=text=</a>";
       my $sel="<input type=\"checkbox\" name=\"sel_map\" value=\"Z.+\">";

       #set property -> answered
       if ($in{'answered'}) {
            if ($in{'submit_ok'} eq "delete selected") {
                 &userlib_del_map;
            } else {
                 # add idmap
                 &userlib_change_property;
            }
       }


       print "<br><br><b>SMB-Unix Idmapping</b>";
       $r=&exe("idmap list");

       # add [-d] win/unixuser:..  unix/winiuser:..

       #rearrange
       @l=split(/\n/,$r);
       foreach $l (@l) {
          $l=~s/  +/\t/g;
          @v=();
          @v=split(/\t/,$l);   # =>, smb, unix

          # unixuser = winuser
          $v[4]="= ";

          if ($v[0] =~/\-d/) {
               $v[4]="=>";
          }

          if ($cfg{'ver'}=~/c|a/) {
           $t=$sel;
           $t=~s/Z/$v[1]/;
          } else {
           $t="";
          }

          $i="$v[1]\t$v[4]\t$v[2]\t$t\t&nbsp;";
          $i=~s/\"//g;
          push(@i,$i);

       }
       @i=sort(@i);

       $t=$url; $t=~s/=prop=/add-idmapping/; $t=~s/=ask=//; $t=~s/=text=/add idmapping/;
       if ($cfg{'ver'}=~/c|a/) { push(@i,"<br>++ $t"); } else { push(@i,"<br>use acl extension or CLI to edit"); }  # add idmap

       $i=join("\n",@i);

       # del selected
       if ($cfg{'ver'}=~/c|a/) {
       &ask('begin_sel');
       print "\n<div id='chb'>\n";   # select all input
       }

       if (@i ==1) {          # only add
            $i="-none-\n$i";
       } else {
            $t="<b>Map user/group</b>\t<b>=/=></b>\t<b>to user/group</b>";
            if ($cfg{'ver'}=~/c|a/) { $t.="\t<input type='checkbox' style='margin:0 0 0 4px' onclick='toggleChecked(this.checked)'>\t&nbsp;"; }
            $i="$t\n$i";

       }



       print &list2table($i);

###############################
       if ($cfg{'ver'}=~/c|a/) {
       print "</div><br>\n"; # /chb      #/del
       &ask('confirm','delete selected','delete selected mappings?');
  # js for select all
  print <<EoF;
  <script type="text/javascript">
      function toggleChecked(status) {
      \$(".checkbox").each( function() {
      \$(this).attr("checked",status);
      })
      }

      function toggleChecked(status) {
      \$("#chb input").each( function() {
      \$(this).attr("checked",status);
      })
      }
</script>

EoF
}
#############################



       # popup/ edit-window
       if ($in{'prop'} eq "add-idmapping")  {
              &userlib_ask_property;
       }
       print "<div class='info'><pre>$txt{'user_idmap_add'}</pre></div> <br><br><br>";

}

#######################
 sub userlib_smbuser_overview {                    # print group overview (smb-groups only)
############### print overview if user
    my ($n,$r,$s,$t,@l,@u,$u,@w,$out,$url,$ask,@g,$g,@m,$m,$i);

    #hide user:
    my $hide=",admin,avahi,mysql,nfs,napp-it,";                         # hide user ex ",a,b,c," -> comma at begin and end!!

    # do not offer delete
    my $noedit=",admin,root,guest,";

    #header of list
    $u[0]="<b>user names</b>\t(userid)\t(unixgroup)\t(groupid)\t(unix/afp-info)\t<b>member of smb group</b>\tWindows SID\t(SMB) Password\toption";

    @w=&userlib_get_my_user('a');
#&print_array(@w);

    foreach $t (@w) {
       $u=$t; $u=~s/\s.*//;
       if ($hide=~/,$u,/) { next; }                #hide user
       push (@u,$t);
    }
#&print_array(@u);

    #set property -> answered
            if ($in{'answered'}) { &userlib_change_property; }

    #delete -> answered
            if ($in{'old'} ne "") { &userlib_change_property; }

    #url
    $url="<a title='=title=' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action==action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list==list=\&amp;prop==prop=\&amp;old==old=\"=ask=>=text=</a>";
    $ask=" onclick=\"return(confirm('=ask2=?'))\"";

    my $smbadm_show;
    #list of groups
    if ($sys{'auto_os'} eq "Solaris 11") {
          $smbadm_show=&exe("smbadm show-groups");
    } else {
          $smbadm_show=&exe("smbadm show");
    }


    my $idmap_list=&exe("idmap dump");                          # get all mappings
    my $hostname=&exe("hostname");
#&print_array(@u);

    foreach $t (@u) {

        @w=();                                                  # 0..4 data, 5= smb-pw
        @w=split(/\t/,$t);                                      # skip headline
        if (!($w[1]=~/^\d/)) { next; }                          # no id inkl root
        $w[5]=""; # group member

        # 5 member of smb-group
                # $smbadm_show ->                               # get all groups
                @g=split(/\n/,$smbadm_show);                    # group\n\tSID
                $g="";
                foreach $i (@g) {
                        if ($i=~/^\s/) { next;}                 #\t SID
                        $i=~s/ *\(.*//s;                        # grpopname ex 'power users'
                        $r=&exe("smbadm show -m \'$i\'");       # get all groupsmembers
                        $r=~s/.*Members:\n*//s;
                        $r=~s/\t//gs;
                        @m=split(/\n/,$r);

#&print_var($i);
#&print_array(@m);
                        foreach $m (@m) {
                                $m=~s/\@.*//;                        #xx@host -> xx
                                $m=~s/.*\\//;                        #HOST\xx -> xx

                                if ($w[0] eq "$m") {
                                        $i=substr($i,0,3);
                                        $g.="$i, ";
                                        $w[5].="$i ";
                                }  else {
                                        $w[5].="";
                                }
                        }
                }


        # 6 Win SID
                @g=split(/\n/,$idmap_list);                            # all mappings   w[1]=uid vs  usid:S-1-5-21-817609387-3303751983-3622753285-1106      ==      uid:106

                $w[6]="";
                foreach my $g (@g) {
                     if ($g=~/uid:$w[1]\b/) {
                          $g=~s/usid://;
                          $g=~s/\s.*//;
                          $g=&get_short_a($g,'l');                      # ex char,20l
                          $w[6].="$g";
                          last;
                     }
                }
                $w[6]=~s/, $//;

                #



        # 7 set pw
                  if ($noedit=~/,$w[0],/) {
                        $w[7]="use passwd";
                  } else {
                      $r=$url;
                      $n="set pw for $w[0]";
                        $w[7]=$url;
                        $w[7]=~s/=text=/$n/;
                        $w[7]=~s/=prop=/set-userpw/;
                        $w[7]=~s/=title=/$n/;
                        $w[7]=~s/=old=//;
                        $w[7]=~s/=ask=//;
                        $w[7]=~s/=action=/set_pw/;
                        $w[7]=~s/=list=/$w[0]/;
                  }
                $t=join("\t",@w);

#&print_array(@w);
        # 8 option delete
             if ($w[5] ne "") {
                       $w[8]="(SMB group member)"
             } else {

                  if ($noedit=~/,$w[0],/) {
                        $w[7]="-\t-";
                  } else {
                        $r=$url;
                        $n="delete user";
                        $w[8]=$url;
                        $w[8]=~s/=text=/$n/;
                        $w[8]=~s/=title=/$n $w[0]/;
                        $w[8]=~s/=prop=/del-user/;
                        $w[8]=~s/=old=/$w[0]/;
                        $w[8]=~s/=ask=/$ask/;
                        $w[8]=~s/=ask2=/delete user $w[0]?/;
                        $w[8]=~s/=list=/$w[0]/;
                  }
             }

             #wg sort (++ last entry)
             $w[0]=" $w[0]";
             $t=join("\t",@w);

    }
#&print_array(@u);

    #add new user
                $r=$url;                        #intarectiv add user -> expect-module, next version
                $r=~s/=text=/add local user/;
                $r=~s/=title=/add local user/;
                $r=~s/=list=//;
                $r=~s/=prop=/add-smbuser/;
                $r=~s/=action=/add-smbuser/;
                $r=~s/=old=//;
                push(@u,"<br>++ $r");


    $out=join("\n",@u);

    #show as table
    $out=&list2table($out,'100%,180px,70px,70px,70px,150px,110px,110px','sort2');
    #print "<pre class='tt'>$out</pre><div class='info'>$txt{'user_info'}</div>";
    print "<b>Local User (SMB requires SMB PW)</b><br>$out<div class='info'><pre>$txt{'user_info'}</pre></div>";

    #popup/ edit-window
    if (($in{'action'} eq "add-smbuser") || ($in{'action'} eq "set_pw")) {
              &userlib_ask_property;
    }

    return;


}

##################
sub userlib_setpw {    #name, pass
###################
        # join domain via Expect
        my $user=$_[0];
        my $pass=$_[1];

        use Expect;
        my $timeout="2";

         my $exp; #->raw_pty(1);
        if ($sys{'auto_os'}=~/nexenta/i) {
                 print "sudo passwd $user\n";
                 $exp = Expect->spawn("sudo passwd $user") or die "Couldn't start program: $!\n";
        } else {
                 print "sudo passwd $user\n";
                 $exp = Expect->spawn("sudo passwd $user") or die "Couldn't start program: $!\n";
        }
        # prevent the program's output from being shown on our STDOUT # $exp->log_stdout(0);  # (1)=echo on



         #print "<br> new Password: ***\n";
        #$exp->log_stdout(1);             # echo off
        $exp->expect($timeout,
                [ 'New' =>
                         sub {
                             $exp->send("$pass\r");
                              print "<br>\n";
                             exp_continue;
                         }
                ] ,
                [ 'Re-enter new Password' =>
                         sub {
                             $exp->send("$pass\r");
                              print "<br>\n";
                             exp_continue;
                         }
                ]
         );
         $exp->soft_close();
         sleep(2);
}

###############
sub userlib_get_my_user {        # return str of users uid >100 or with smb pw
######################
    my ($r,$s,$t,@l,@u,@m,$m);
    my $list=",";

    $m=&exe("cat /var/smb/smbpasswd");
    @m=split(/\n/,$m);


    $r=&exe('logins');                               # all user
    $r=~s/  +/\t/gs;
    @l=split(/\n/,$r);

    # step 1 all user with smb pw
    foreach $s (@l) {                                # all user
        @w=();
        @w=split(/\t/,$s);

        foreach $m (@m) {
                 if ($m=~/^$w[0]\:/) {                # w1 username
                      push (@u,"$s\tyes");
                      $list.="$w[0],";
                 }
        }
        #if ($w[1] eq "napp-it") { next; }
        #if ($w[2] eq "staff" ) { push (@u,$s); }    # only members of staff
    }

    # step 2 add all user > uid 99 and < 60000
    #&mess($list);
    foreach $s (@l) {                                # all user
        @w=();
        @w=split(/\t/,$s);

        if (($w[1] < 100) || ($w[1] >=60000))  { next; }
        if ($w[0] eq "napp-it") { next; }

        if (!($list=~/,$w[0],/)) {
           push (@u,"$s\tno");
        }
    }



    @u=sort(@u);
    $r=join("\n",@u);
    if ($_[0] eq "a") { return (@u); }               # return my user as array
    return ($r);                                     # return my user as string
}

 ######################
 sub userlib_change_property {                 #hide:
 #######################    set zfs details
 my ($r,$s,$t,$do,$h,$u,$g);

  #add idmap, use prop
 ###############
  if ($in{'prop'} eq "add-idmapping") {

        $in{'text1'}=~s/^ +//; $in{'text1'}=~s/ +$//;
        $in{'text2'}=~s/^ +//; $in{'text2'}=~s/ +$//;
        if (($in{'text1'} eq "") || ($in{'text2'} eq "")) { &mess("Enter a mapping!"); }

        print "please wait..\n";
        $t=" -d";

        if ($in{'dir'} eq "=") {  $t=""; }
        $u=$in{'type1'};
        if ($u=~/win/) { $u=~s/win/unix/; }  else { $u=~s/unix/win/; }

        $r=&exe("idmap add$t \"$in{'type1'}:$in{'text1'}\" $u:$in{'text2'}");
        print $r;
        sleep(2);


        $in{'prop'}="";
        &reload;
  }


 #### create smb + unix group
  if ($in{'action'} eq "add-smbgroup") {
        $do="1";
       print "please wait..\n";
        #parse input
        $in{'text'}=lc($in{'text'});
        $in{'text'}=~s/[^a-z0-9 ]//g; $in{'text'}=~s/\s+$//g;
        if ($in{'text'} eq "") { &mess('please enter a valid groupname'); }

        $in{'desc'}=~s/[^A-Za-z0-9 ]//g; $in{'desc'}=~s/ +/ /g;
        if ($in{'desc'} ne "") { $in{'desc'}="'".$in{'desc'}."'"; } else { $in{'desc'}="none"; }

       # check if group exists
       $r=`cat /etc/group`;
       if ($in{'text'} ne "staff") {
          if ($r=~/\b$in{'text'}\:/s)  {  &mess("groupadd: unixgroup $in{'text'} already exists, choose another name!"); }
       }

       # 1. unix groupadd name
          if ($in{'text'} ne "staff") {   # default unix
                $r=&exe("groupadd \'$in{'text'}\'");
                if ($r =~/ERROR:/) { &mess("groupadd $in{'text'}<hr>$r"); }
          }
        # 2. smbadm create group
            if ($sys{'auto_os_type'}=~/_s/) {         # solaris 11
                $r=&exe("smbadm create-group -d $in{'desc'} \'$in{'text'}\'");
                if (!($r =~/created/)) { &mess("smbadm create-group -d $in{'desc'} $in{'text'}<hr>$r"); }
            } else {
                $r=&exe("smbadm create -d $in{'desc'} \'$in{'text'}\'");
                if (!($r =~/created/)) { &mess("smbadm create -d $in{'desc'} $in{'text'}<hr>$r"); }
            }

        # 3. add mapping
                $r=&exe("idmap add -d wingroup:$in{'text'}\@BUILTIN unixgroup:$in{'text'}");
             #   if ($r ne "") { &mess("idmap add wingroup:$in{'text'}\@BUILTIN unixgroup:$in{'text'}<hr>$r"); }

        $in{'action'}="";
        &reload;
  }

 #### delete  smb + unix group
  if ($in{'action'} eq "del-smbgroup") {
       $do="1";
       print "please wait..\n";
       #$in{'old'}="'"."$in{'old'}"."'";
       #$in{'old'}=~s/\'+/\'/g;
       # 1. smbadm delete group
            if ($sys{'auto_os_type'}=~/_s/) {         # solaris 11
                $r=&exe("smbadm delete-group \'$in{'old'}\'");
            } else {
                $r=&exe("smbadm delete \'$in{'old'}\'");
            }

       # 2. groupdel name
         if ($in{'old'} ne "staff") {   # default unix
                $r=&exe("groupdel \'$in{'old'}\'");
                if ($r =~/ERROR:/) { &mess("groupdel $in{'old'}<hr>$r"); }
         }

       # 3. delete mapping
                 $r=&exe("idmap remove wingroup:$in{'old'}");

       $in{'action'}="";
       &reload;
  }


 #add member to smb group
 ###########
  if ($in{'action'} eq "add-smb_groupmember") {
  #&print_hash(%in);
        $do="1";
        print "please wait..\n";
        # smbadm add-member
        #$in{'prop'}="'".$in{'prop'}."'";
        $in{'prop'}=~s/\'+//g;
        $in{'text'}=~s/[^a-zA-Z0-9\-\_\\\. ]//g;

#&mess("smbadm add-member -m \'$in{'text'}\' \'$in{'prop'}\'");
        $r=&exe("smbadm add-member -m \'$in{'text'}\' \'$in{'prop'}\'");
        if (!($r =~/is now a member/)) {
            if ($r=~/unable to obtain SID/) { $r.="<hr> - if you are in domain mode, user is not found in domain<br> - if you are in workgroup mode, please set a password for $in{'text'} and retry."; }
            print "$r";
            sleep(2);
        }

        # idmap add -d user (text) to root, if group (prop) = administrators?
        ##   no automatic mapping, on workgroups you get problems with guest access and mappings !!

        $in{'action'}="show_members";
        &reload;
  }

 #remove member from smb group
 ###############
  if ($in{'action'} eq "remove-smb_group_member") {
        $do="1";
        print "please wait..\n";
        # $in{'prop'}="'"."$in{'prop'}"."'"; $in{'prop'}=~s/\'+/\'/g;
        # smbadm remove-member
                $in{'old'}=~s/.*\\//; $in{'old'}=~s/\@.*//;        #delete domain name from username
                $r=&exe("smbadm remove-member -m \'$in{'old'}\' \'$in{'prop'}\'");
                if (!($r =~/has been removed/)) {
                        print "$r";
                        sleep(2);
                }


        $in{'action'}="show_members";
        &reload;
  }


 #### create user
 ###################

  if ($in{'action'} eq "add-smbuser") {
       $do="1";
       $u="";
       print "please wait..\n";

        #parse input
        #$in{'text'}=~tr/A-Z/a-z/;  # A.. erlaubt

         $in{'text'}=~s/[^A-Za-z0-9\.\-\_\@ ]//g;  # space erlaubt
         $in{'text'}=~s/  +/ /g;             # only single space
         $in{'text'}=~s/^\s+//g;
         $in{'text'}=~s/\s+$//g;

         $in{'pw'}=~s/\s//g;

        $in{'pw2'}=~s/\s//g;
        if ($in{'pw2'} ne $in{'pw'}) { &mess($txt{'repeat_pw_err'}); }

        $in{'uid'}=~s/\D//g;
        if ($in{'uid'} ne "") {
            # if ($in{'uid'} < 100) { &mess('please use a UID > 100'); }     # allow creation of system user
            $u=" -u $in{'uid'}";
        }

        if ($in{'text'} eq "") { &mess('please enter a valid username [Aa-z,0-9.-_ ]'); }

        #group
        $in{'gid'}=~s/ +//g;
        $g="staff";

        if ($in{'gid'} ne "") {
           $g=$in{'gid'};
        }

       # 1. useradd, nur user, keinen ordner in /export
            $r=&exe("useradd -g $g$u -c \'$in{'info'}\' -s /bin/false \'$in{'text'}\' 2>&1");
            if ($r ne "") {
              if ($r=~/name too long/) {
                  print "Posix allows a max username of 8 char. Your name is longer. This is uncritical for most cases ex SMB filer use.<br><br>";
                  sleep(4);
              } else {
                 if (!($r=~/should be/))  {
                     &mess($r);                            # erromess with 'Peter Paul' but ok
                 }
              }
            }

 #&print_hash(%in);
        # 2. set pw
             sleep(2);
             &userlib_setpw("\'$in{'text'}\'","$in{'pw'}");

        # check/ establish a mapping between builtin smb group 'power users' and unixgroup staff
        $r=&exe('idmap list');
        if (!($r=~/unixgroup:staff/s)) {
            $r=&exe("idmap add -d wingroup:'power users\@BUILTIN' unixgroup:staff");
        }

        $in{'action'}="";
        &reload;
  }

 #### delete local user
 ##########
  if ($in{'prop'} eq "del-user") {
       $do="1";
       print "please wait..\n";
               $r.=&exe("userdel \'$in{'old'}\'");
               print "$r<br>";
               sleep(1);
                #if ($r =~/ERROR:/) { &mess($r); }

               #update /var/smb/smbpasswd
               $r=&exe('cat /var/smb/smbpasswd');
               @t=();
               my @new=();
               @t=split(/\n/,$r);
               foreach my $l (@t) {
                 if (!($l=~/^$in{'old'}:/)) { push (@new,"$l"); }
               }
               #write
               &exe("chmod 666 /var/smb/smbpasswd");
               $t=join("\n",@new);
               $t=~s/\n+$//s; $t.="\n";
               open (PF, ">/var/smb/smbpasswd");
                   print PF "$t";
               close (PF);
               &exe("chmod 400 /var/smb/smbpasswd");

               sleep(2);
        &reload;
  }


 #### set user-pw
  if ($in{'action'} eq "set_pw") {


        $in{'pw'}=~s/\s//g;
        $in{'pw2'}=~s/\s//g;
        if ($in{'pw2'} ne $in{'pw'}) { &mess($txt{'repeat_pw_err'}); }

            &userlib_setpw("\'$in{'list'}\'","$in{'pw'}");

            $in{'action'}="";
            &reload;
  }


#&mess('ok');
} #/sub


#######################
sub userlib_ask_property {        #hide:
#######################

    my ($ask,$close,$form,$info,$t,$opt,$r,$do,$hn);
    $close="<a href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list=$in{'list'}\&amp;zfs=$in{'zfs'}\"><b>$txt{'cancel'}</b></a>";

    #add local user
    if ($in{'action'} eq "add-smbuser") {
        $do="1";
        $form="username $in{'list'}\: <input type='text' name='text' value='' style='width: 120px; margin-left:4px'>";
        $form.="\&nbsp;Info: <input type='text' name='info' maxlength='20' value='' style='width: 120px; margin-left:8px'> <br>";

        $form.="password: <input type='password'  maxlength='16' name='pw' value='' style='width: 120px; margin-left:8px'> again: <input type='password'  maxlength='16' name='pw2' value='' style='width: 120px'> $txt{'repeat_pw'}";

        $form.="<br><br>set UID: <input type='text' name='uid' maxlength='20' value='' style='width: 120px; margin-left:22px'> ";
        $form.="GID: <input type='text' name='gid' maxlength='20' value='' style='width: 120px;margin-left:11px'> optional<br>";

        $info="name: A-Z,a-z,0-9,-\<br>$txt{'user_user_add'}<br><br>UID/GID settings are optionally used for NFS compatibility otherwise keep empty";
        $info.="<br>Idmap problem: <font style='color:red'>never reuse a UID</font> or a new user may appear as the deleted user from Windows";
    }

    #set userpw
    if ($in{'action'} eq "set_pw") {
        $do="1";
        $form="set pw of user $in{'list'}\: <br><input type='password' name='pw' value='' maxlength='16' style='width: 130px'> $txt{'repeat_pw'}: <input type='password' name='pw2' value='' maxlength='16' style='width: 130px'>";
        $info="$txt{'user_setpw'}";
    }

    #add local group
    if ($in{'action'} eq "add-smbgroup") {
        $do="1";

        $form="add smb+unix group <input type='text' name='text' value='' style='width: 130px'>";
        $form.="&nbsp;description:&nbsp;<input type='text' name='desc' value='' style='width: 130px'>";
        $info="$txt{'user_smbgroup_add'}";
    }

    #add smb group-member
    if ($in{'action'} eq "add-smb_groupmember") {
        $do="1";
        $hn=&exe('hostname'); $hn=~s/\s+$//;
        $form="add member to group $in{'prop'} <input type='text' name='text' value='' style='width: 150px'>";
        $info="<br> $txt{'user_smbgroup_addmember'}<br>";
    }

    #add idmapping, use prop
    if ($in{'prop'} eq "add-idmapping") {
        $do="1";

        $form="add idmap ". &select('type1','winuser,wingroup,unixuser,unixgroup') ."<input type='text' name='text1' value='' style='width: 130px'> ";
        $form.=&select('dir','=>,=')." <input type='text' name='text2' value='' style='width: 130px'> ";
        $info="<i>$txt{'user_idmap_add'}</i>";
    }


     ### form ###
     if ($do) {
        print &ask_pop("$form","$info","$opt");
     }


} #/sub

#######################
 sub userlib_smbgroup_details {            # print smb group members with delete and add option
#######################
    my ($group,@z,$url,$u,$n,$r,@w,@g,$w,$out,$ask);

    $url="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list==list=\&amp;prop==prop=\&amp;action==action=\&amp;old==old=\"=ask=>=text=</a>";
    $ask=" onclick=\"return(confirm('=ask2=?'))\"";

    #answered
            if ($in{'answered'}) { &userlib_change_property; $in{'old'}="";  &reload; }

    # remove members
            if ($in{'action'} eq "remove-smb_group_member") { &userlib_change_property; &reload; }

    # ask add members
            if ($in{'action'} eq "add-smb_groupmember") { &userlib_ask_property; }


    #get members
#&print_hash(%in);
    $n="'"."$in{'prop'}"."'"; $n=~s/\'+/\'/g;

    #list of groups
    if ($sys{'auto_os'} eq "Solaris 11") {
         $r=&exe("smbadm show-groups -m $n");                        # name\nsid\nMembers: \nmember1\nmember2
    } else {
        $r=&exe("smbadm show -m $n");                        # name\nsid\nMembers: \nmember1\nmember2
    }

    $r=~s/.*Members:\n//is;
    $r=~s/.*no members/no-members/is;
    $r=~s/\t//gs;
    @w=split(/\n/,$r);
 #&print_array(@w);
    foreach $t (@w) {

        @g=();
        @g=split(/\t/,$t);

       if ($g[0]=~/no-members/) { next; }

       #delete smb group member
                        $n="remove";
                        $g[2]=$url;
                        $g[2]=~s/=text=/$n/;
                        $n=$g[0];
                        $n=~s/.*\\//; $n=~s/\@.*//;        #delete domain name from username

                        $g[2]=~s/=prop=/$in{'prop'}/;
                        $g[2]=~s/=action=/remove-smb_group_member/;         $g[2]=~s/=old=/$n/;
                        $g[2]=~s/=ask=/$ask/;                                $g[2]=~s/=ask2=/remove $n?/;
                        $g[2]=~s/=list=/members/;

       # add space
                $g[0]=" $g[0]";          #wg sort

       $t=join("\t",@g);
    }

    @w=sort(@w);

    @g=();
    push (@g,"<b>members of smb-group $in{'prop'}</b>\tstatus\toption");
    push(@g,@w);                                        #add members

    #add new member to group
                        $r=$url;
                        $r=~s/=text=/add member/;
                        $r=~s/=list=/members/;
                        $r=~s/=prop=/$in{'prop'}/;
                        $r=~s/=action=/add-smb_groupmember/;
                        $r=~s/=old=//; $r=~s/=ask=//;
                        push(@g,"<br>++ $r");



    ####
    $out=join("\n",@g);

#test
#&print_array(@g); exit;

    #show as table
    print &list2table($out,'100%,540px,,120px','sort2');


}

#######################
 sub userlib_smbgroup_overview {            # print group overview (smb-groups only)
 ############### print overview if user zfs
    my ($group,@z,$url,$u,$n,$r,@w,@g,$w,$out,$ask);

    #set property -> answered
            if ($in{'answered'}) { &userlib_change_property; }

    #delete -> answered
            if ($in{'action'} eq "del-smbgroup") { &userlib_change_property; }

    #url
    $url="<a title='=title=' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;action==action=\&amp;list==list=\&amp;prop==prop=\&amp;old==old=\"=ask=>=text=</a>";
    $ask=" onclick=\"return(confirm('=ask2=?'))\"";

        #list of groups
               if ($sys{'auto_os'} eq "Solaris 11") {
                    $r=&exe("smbadm show-groups");
                } else {
                    $r=&exe("smbadm show");
                }
                @w=split(/\n/,$r);

        #get group names -> @z
        foreach $w (@w) {
                if (!($w=~/^\w+/)) { next; }        #'   SID:..'
                $w=~s/\s+\(.*//;                        # group name ex backup operators
                push (@z,$w);
        }

#test
#&print_array(@z); exit;

    push (@g,"<b>smb-groups</b>\t<b>about_and_members</b>\t<b>SID</b>\t<b>option</b>");

    foreach $t (@z) {

        $r="'".$t."'";
        if ($sys{'auto_os'} eq "Solaris 11") {
                    $r=&exe("smbadm show-groups -m $r");
        } else {
                    $r=&exe("smbadm show -m $r");                # group info inkl members of group
        }


        $r=~s/\n/\t/gs;                                # name (info) \n     SID: ...   \n    members
        chomp($r);
        $r=~s/\(/\t\(/g;
        $r=~s/\tSID: //g;                                 # SID
        $r=~s/\t+/\t/gs; $r=~s/\t$//;                 # delete empty rows
        $r=~s/\tMembers:.*/\t<b>with members<\/b>/;                         # only info
        push (@g,$r);
    }


    #insert link to details
    foreach $t (@g) {
        @w=();
        @w=split(/\t/,$t);

        $n=$w[0]=~s/ +$//;                #no space at end

       if (!($w[2]=~/\d/)) { next; }                #sid


       #delete smb group if empty and not a default group with short SID (12 char
                if (($w[3] eq "No members") && (length($w[2]) > 12)) {
                        $n="delete";
                        $w[3]=$url;
                        $w[3]=~s/=text=/$n/;
                        $w[3]=~s/=title=/$n $w[0]/;
                        $w[3]=~s/=action=/del-smbgroup/; $w[3]=~s/=old=/$w[0]/;
                        $w[3]=~s/=ask=/$ask/; $w[3]=~s/=ask2=/delete group $w[0]?/;
                        $w[3]=~s/=list=//;

                }

        #groupname -> link. show members (details) -> "prop"
                $n=$w[0];
                $w[0]=$url;
                $w[0]=~s/=text=/$n/;
                $w[0]=~s/=title=/$n/;
                $w[0]=~s/=list=/members/;
                $w[0]=~s/=prop=/$n/;
                $w[0]=~s/=action=/show_members/;
                $w[0]=~s/=old=//;
                $w[0]=~s/=ask=//;


                $t=join("\t",@w);
    }


    #add new group
                $r=$url;
                $r=~s/=text=/add local group/;
                $r=~s/=list=//;
                $r=~s/=title=/add local group/;
                $r=~s/=prop=/add-smbgroup/;
                $r=~s/=action=/add-smbgroup/;
                $r=~s/=old=//;
                push(@g,"<br>++ $r");


    $out=join("\n",@g);

#test
#&print_array(@g); exit;

    #show as table
    $out=&list2table($out,,'sort2');
    print "<br><br><br><b>Local SMB-Groups:</b><br>$out <pre>$txt{'user_footer'} </pre><div class='info'><pre>$txt{'group_info'}</pre></div> \n\n";

   #add details (members)
   if ($in{'list'} eq "members") {
         &userlib_smbgroup_details;
   }

   #popup/ edit-window
   if ($in{'action'} eq "add-smbgroup") {
         &userlib_ask_property;
   }

   return;

 }

#################
 sub userlib_unixgroup_overview {            # print group overview (unix-groups only)
 ############### print overview if user zfs
    my ($group,@z,$url,$u,$n,$r,@w,@g,$p);

    push(@g,"<b>Unix AFP-groups</b>\t<b>group-id</b>\t<b>members</b>");

    #get groups
    $group=&exe("cat /etc/group");                #ex name:*:id:xx
    chomp($group);
    @z=split(/\n/,$group);
    foreach $t (@z) {
        #remove all after last :
        $p=rindex($t,":");
        $t=substr($t,0,$p);
        $t=~s/\:.*\:/\t/;
    }


    foreach $t (@z) {
        chomp($t);
                $p=$t; $p=~s/\t.*//;
                $r=&exe("logins -g $p");                #members of group
                @w=();
                @w=split(/\n/,$r);
                foreach $g (@w) { $g=~s/ .*//; }        #user only
                $r=join(",",@w);
                $t.="\t$r";
        push (@g,$t);
    }
    $out=join("\n",@g);

    #show as table
    $out=&list2table($out,'','sort2');
    print "<pre class='tt'>$out</pre>";
    print "\n</body></html>";
    return;

 }



#EoF ######################
# do not remove line below (return true)
1;
