# get_basic-sys.pl
# basic info for global hashes
# loaded always

# edited 05.11.2019
#
# (c) napp-it 2010,2011,2012
# fill %sys with basic pool infos

use strict;


# 1. zpool hash (info)
#######################
#    disk hash  (poolmember)
 if ($sys{'auto_os'} eq "Linux") {
      $zfs{'syspool'}="";
 } else {
        #name of syspool (syspool or rpool)                                   # names of syspool in nexenta/osol
         $zfs{'syspool'}="rpool";


        #network defalt or nwam?
        my $r=`svcs | grep network/physical`;

        if ($r=~/:nwam/s)    { $sys{'network'}="nwam"; }
        if ($r=~/:default/s) { $sys{'network'}="default"; }
 }
 # get poolnames
 &gethash_sys_poolnames;

  # ldate
 &getdate;
 &get_ldate;



####################### get datapools, allpools
sub gethash_sys_poolnames {
    my $ant=&exe('zpool list -H -o name','','get-sys.pl 36');                 # get names
    my @pools=split(/\n/,$ant);
    foreach my $p (@pools) {
          if (!($zfs{'allpools'}=~/\b$p\b/)) {
              $zfs{'allpools'}.="$p\t";
          }
          if ($p ne $zfs{'syspool'}) {
               if (!($zfs{'datapools'}=~/\b$p\b/)) {
                  $zfs{'datapools'}.="$p\t";
               }
          }
    }
    $zfs{'allpools'}=~s/\t+$//;
    $zfs{'datapools'}=~s/\t+$//;


    #my $t=&getv($cfg{'app_acc'});
    #if ($t=~/val/is) { sleep(1);  }

}


  #add to %sys
  # print "Content-type: text/html\n\n";
  # &print_hash(%zfs);



  sub get_ldate {
    my ($ant,@old,@new,$ok,$k,$date,$d,$diff,$ref,$r,@l,@w,$h,$s);

    $sys{'edition'}="Free";      # license
    $sys{'version2'}="Free";     # napp-it
    if ($sys{'version'}=~/pro|dev/i) { $sys{'version2'}="Pro";  }

    if (-f "/var/web-gui/_log/appliance.log") {
       $ant=`cat /var/web-gui/_log/appliance.log`;

       @old=split(/\n/,$ant);
       foreach my $li (@old) {

              $ok="";
              $k="0";
              if (!($li=~/::/)) { push (@new,$li); next; }

              @w=split(/\|/,$li);

              $h=$w[1];
              $h=~s/.*h:/h:/;
              $h=~s/ \- .*//;
              $h=~s/\_.*//;  # opt name
              $t=&get_hid;

              # mid
              if ($t ne $h) {

                   # on aio check only partly
                   $s="1";
                   if (length($t) <= 15) {
                      $s=$t;
                      $s=~s/h:m//;
                      if ($h=~/$s/) { $s="0"; } else { $s="1"; }

                   }
               }

                   # check against mac
                   $r=`sudo /sbin/ifconfig -a | grep :`;  # all mac from ifconfig
                   chomp($r);
                   @t=split(/ +/,$r);
                   $r="";
                   foreach my $t (@t) {
                     if ($t=~/..:..:/) { $r=$t; last; }
                   }

                   if ($r eq "") { $r="invalid"; }
                   $r=~s/://gs;
#print "Content-type: text/html\n\n";
#&mess($r);


                   $h=~s/h:m//;
                   $h=~s/.90$//;
                   if ($r=~/$h/is) {
                     $s="0";
                   }
              if ($t=~/unknown/) { $s="0"; }  # unknown failure of nic detection   
              if ($s) {
                      #
                      open (PF, ">>/tmp/nappit/k.log");
                            print PF "$li (wrong machine id $sys{'date_us'}\n";
                            print PF "$ant\n";
                      close (PF);

                      open (PF, ">>/var/web-gui/_log/appliance.oldkey");
                            print PF "$li (wrong machine id $sys{'date_us'} \'$t\',\'$h\')\n";                                     # \n at the end
                      close (PF);
                      $ok.="0";
              }


              #valid
              $t=&getv2($w[1]);
              if (!($t=~/\d\d\d\d/)) {
                   open (PF, ">>/var/web-gui/_log/appliance.oldkey");
                         print PF "$li (date expired or invalid key)\n";                                     # \n at the end
                   close (PF);
                   $ok.="0";
              }


              if (!($ok=~/0/)) {

                       $sys{'edition'}="Pro";

                       if ($w[1]=~/^complete/) {
                            if (!($cfg{'ver'}=~/c/)) { $cfg{'ver'}.="c"; }
                            if (!($cfg{'ver'}=~/a/)) { $cfg{'ver'}.="a"; }
                            if (!($cfg{'ver'}=~/r/)) { $cfg{'ver'}.="r"; }
                            if (!($cfg{'ver'}=~/m/)) { $cfg{'ver'}.="m"; }
                        }
                        if ($w[1]=~/\_evaluation/) {
                            if (!($cfg{'ver'}=~/e/)) { $cfg{'ver'}.="e"; }
                        }
                        if ($w[1]=~/\_home|\_noncom/) {
                            if (!($cfg{'ver'}=~/h/)) { $cfg{'ver'}.="h"; }
                        }
                        if (($w[1]=~/acl/) && (!($cfg{'ver'}=~/a/))) {$cfg{'ver'}.="a";  }
                        if (($w[1]=~/mon/) && (!($cfg{'ver'}=~/m/))) {$cfg{'ver'}.="m";  }
                        if (($w[1]=~/rep/) && (!($cfg{'ver'}=~/r/))) {$cfg{'ver'}.="r";  }
                        if (!($cfg{'ver'}=~/p/)) {$cfg{'ver'}.="p";  }
              }

              if (!($ok=~/0/)) {
                     push (@new,$li);
              }
        }

        if (@new < @old) {
             $t=join("\n",@new);
             open (PF, ">/var/web-gui/_log/appliance.log");
                  print PF "$t";                                     # \n at the end
             close (PF);
             &read_ahfile("/var/web-gui/_log/appliance.log","cfg","h+");                    #read appliance-info -> %cfg
        }
    }


    #sol only

        &exe("touch /var/web-gui/_log/napp-it_ws_off");
        &about_stat_disable;

        &exe("touch /var/web-gui/_log/napp-it_acc_off");
        &about_acc_disable;   sleep(1);


#&print_hash(%cfg);

}

# eof
1;
