# job functions for napp-it    Copyright (c) 2009-2015 napp-it
#
# 30. apr 2015

use strict;
#use vars qw(%in %current %sys);
use vars qw($cgipath $i $t $p $o $action $txt $ev %t %p %in %cfg @p @t @cfg %disk %sys %zfs %action %current %opt %txt);         # menues and global var + global temp

################################

 # common job and task libs
 require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/task-lib.pl";        #


#########
sub jobslib {  #8.Feb.2015
########################### last: keep, hold in repli
}


#####################
 sub jobslib_ask_jobproperty {       #hide: ask for property
 #####################        (div window in front)

    if ($in{'answered'}) { &joblib_change_jobproperty; exit; }

    my ($ask,$close,$form,$info,$t,$opt,$r,$ok);
    $close="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=$in{'action'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list=$in{'list'}\&amp;zfs=$in{'zfs'}\"><b>\&nbsp;cancel\&nbsp;/close\&nbsp;</b></a>";

    #ask timetable of job 'list'
    if ($in{'prop'} eq "month") {

      #replicate without extension: only manual in month
      $t=$in{'list'}."_job";
      if (($current{$t} eq "replicate") && (!($cfg{'ver'}=~/c|r/))) {
        $info="modify month not possible without a valid replication extension<br><br>";
        $form="set month to ". &select('value','manual');             #
        $ok="1";
      }  else {

        $info="modify month<br><br>";
        $form="set month to ". &select('value','every,every-2,every-3,every-4,every-6,1,2,3,4,5,6,7,8,9,10,11,12',$in{'items'});             #
        $ok="1";
      }
    }

    if ($in{'prop'} eq "day") {
      $info="modify day<br><br>";
      $form="set day to ". &select('value','every,every-2,every-3,every-7,every-14,mon-fri,mon-sat,sat-sun,first-sat,first-sun,sun,mon,tue,wed,thu,fri,sat,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31',$in{'items'});             #
      $ok="1";
    }

    if ($in{'prop'} eq "hour") {
      $info="modify hour to: every, every-2, every-3, every-4, every-6, every-12, opt followed by ABCD  <br>A=0..5, B=6..11, C=12..17, D=18..23";
      $form="set hour to ". &select('value','every,every-BC,every-2BC,every-3BC,every-2,every-3,every-4,every-6,every-12,7;13,7;13;19,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23',$in{'items'});             #
      $ok="1";
    }

    if ($in{'prop'} eq "min") {
      $info="modify minute to: every, every-2, every-3, every-4, every-6, every-12,minutes";
      $form="set minute to ". &select('value','every,every-2,every-3,every-5,every-10,every-15,every-20,every-30,0,5,10,15,20,25,30,35,40,45,50,55,once',$in{'items'});             #
      $ok="1";
    }

    if ($ok ne "1") {      # other par
      $r="$in{'prop'}\_info";
      $info=$current{$r};

      $t="$in{'job'}\_$in{'prop'}";
      $form="$in{'prop'}  = <input type='text' class='input' name='text' value=\"$current{$t}\" style='width: 400px'> ";
    }

     ### form ###
     $ask=&ask_pop("$form","$info","$opt");
     return ($ask);
 }


######################
 sub jobslib_change_jobproperty {                 #hide:
 #######################
   my ($r,$s,$t,@w,$w);


   if (!($in{'list'}=~/\d+/))       { &mess('change prop error: missing jobid'); }
   $in{'value'}=~s/\~|\s+//g;

   if ("month,day,hour,min"=~/$in{'prop'}/) {
     if (!($in{'value'}=~/\w+/))     { &mess('change prop error: missing value'); }
   } else {
     if ($in{'text'} eq "") { $in{'text'}="-"; }
   }

   ##### timetable
   $w="";
   if ($in{'prop'} eq "month") { $w=$in{'list'}."_month"; $current{$w}=$in{'value'};   }
   if ($in{'prop'} eq "day")   { $w=$in{'list'}."_day";   $current{$w}=$in{'value'};   }
   if ($in{'prop'} eq "hour")  { $w=$in{'list'}."_hour";  $current{$w}=$in{'value'};   }
   if ($in{'prop'} eq "min")   { $w=$in{'list'}."_min";   $current{$w}=$in{'value'};   }

   # otherwise text input (opt1, opt2 etc)
   if ($w eq "") {
      $in{'text'}=~s/\/+$//;     # zfs should nnit have / at the end
      $w=$in{'list'}."_$in{'prop'}";   $current{$w}=$in{'text'};
   }

   #if ($in{'prop'} eq "opt1")   { $w=$in{'list'}."_opt1";   $current{$w}=$in{'text'};   }
   #if ($in{'prop'} eq "opt2")   { $w=$in{'list'}."_opt2";   $current{$w}=$in{'text'};   }
   #if ($in{'prop'} eq "opt3")   { $w=$in{'list'}."_opt3";   $current{$w}=$in{'text'};   }


   &task_update_par($in{'list'});
   print "request update";

   sleep(1);

   $in{'answered'}="";
   $in{'prop'}="";
   &reload;


  #######
 }



################
sub jobslib_job_create {  # parameter: id, variable, comment1, opt1, comment2, opt2, psinfos (++ -list), remote psinfo (++-list)
################

       #z.b. autosnap parameter:
       #$var="pool=$in{'select_pool'}\n";
       #$var.="keep=$in{'select_max'}\n";
       #$var.="name=$in{'text_name'}";
       #ex &job_create($id,$var,"snap pool",$in{'select_pool'},"snaps_keep\_$in{'select_max'}","$in{'text_name'}");     #parameter id,var,text1,opt1,text2,opt2
       ##################################

       # level2~level3~text1~opt1~text2~opt2~month~day~hour~min~id~status~last.log
       # ps info, list of local prozesses, when job is running ex. zfs receive a/b+mbuffer -I :3240
       # rps info, list of remoze prozesses, when job is running ex. zfs send..


  my ($f,$id,$opt1,$opt2,$c1,$c2,$l2,$l3,$var,$action,@vars,$k,$v,$ps,$run,$tmp,$lokal,$remote,$active);
  $active="active"; #or manual

  print "create job, please wait...\n";

  $id=$_[0];

  $var="id=$_[0]\n";
  $var.="$_[1]\n";                                                   # variables ex pool=syspool\nkeep=3
  $var.="text1=$_[2]\n";
  $var.="opt1=$_[3]\n";
  $var.="text2=$_[4]\n";
  $var.="opt2=$_[5]\n";
  $var.="ps=$_[6]\n";
  $var.="rps=$_[7]\n";

  if ($in{'select_month'}=~/manual/) {
     $active="manual";
     $in{'select_month'}="0";
     $in{'select_day'}="0";
     $in{'select_hour'}="0";
     $in{'select_min'}="0";
  }

  # time only in jobname !!
  #$var.="month=$in{'select_month'}\n";
  #$var.="day=$in{'select_day'}\n";
  #$var.="hour=$in{'select_hour'}\n";
  #$var.="min=$in{'select_min'}\n";

  $c1=$_[2];
  $c1=~s/\//\%/g;
  $c1=~s/\~/-/gs;
  $c1=~s/\s/_/gs;
  $c1=~s/\//\%/gs;                                                  # text1
  $c1=~s/[^a-zA-Z0-9\-\.\%\_,]//gs;
  $c1=substr($c1,0,39);                                             # max 40 char

  $opt1=$_[3]; $opt1=~s/~/-/gs;
  $opt1=~s/\s/_/gs;                                                 # opt1
  $opt1=~s/\//\%/gs;
  $opt1=~s/[^a-zA-Z0-9\-\.\_,\%\@]//gs;                             # / -> %

  $c2=$_[4]; $c2=~s/\~/-/gs;
  $c2=~s/\s/_/gs;
  $c2=~s/\//\%/gs;                                                  # text2
  $c2=~s/[^a-zA-Z0-9\-\.\_,\%]//gs;
  $c2=substr($c2,0,39);                                             # max 40 char

  $opt2=$_[5]; $opt2=~s/~/-/gs;
  $opt2=~s/\s/_/gs;                                                 # opt2 keep
  $opt2=~s/\//\%/gs;
  $opt2=~s/[^a-zA-Z0-9\-\.\_,\%\@]//gs;

  $ps=$_[6]; # processinfo


  $l2=$in{'l2'}; $l2=~s/^\d+_//; $l2=~s/_//g; $l2=~s/ /_/g;         # remove sort of menue and other _
  $l3=$in{'l3'}; $l3=~s/^\d+_//; $l3=~s/_//g; $l3=~s/ /_/g;

  # $id=time();                                      # job-id must be set via parameter not current time !!
  $f="/var/web-gui/_log/jobs/";                      # path to job logfolder ../_log/
  $f.="$id\~$l2\~$l3~$c1\~$opt1\~$c2~$opt2\~$in{'select_month'}\~$in{'select_day'}\~$in{'select_hour'}\~$in{'select_min'}\~$id\~$active\~new.job";

#&mess($f);

  &str2file("$var",$f);                           #create .pre file with variables ex:  pool=syspool\keep=2



  #######################################
  #write job id.pl from menue-action file
  ########################################

  $f=$sys{'path'}."action.pl";

  if (!(-f $f)) {  &mess("needed menu-script $f not found!");  }

  #read action.pl
  ###############
  $action=&read_file($f);

  if (! (($action=~/\# auto_job begin/s) && ($action=~/\# auto_job end/s)) ){  &mess("needed menue-script $f <br>must contain: <br><br># auto_job begin <br>  sub auto_job {...}<br># auto_job end");  }

  # extract auto_job
  ##################
  $action=~s/^.*\# auto_job begin/# auto_job begin/s;
  $action=~s/\# auto_job end.*/# auto_job end #/s;
  $action.="\n1;\n";                                                                # needed end of file for require

  #variables to insert
  ####################
  @vars=split(/\n/,$var);

  foreach $tmp (@vars) {
       if (!($tmp=~/\=/)) { next; }
       chomp($tmp);
       $k=$tmp; $k=~s/\=.*//;
       $t=index($tmp,"=");
       $v=substr($tmp,$t+1);

       $k=~s/[^a-zA-Z0-9\-\_]//g;
       if ($k ne "") {
                $action=~s/\=$k\=/$v/gs;
       }
  }


  #write jobfile id.pl
  &str2file($action,"/var/web-gui/_log/jobs/$id.pl");

  #&mess("$var<hr>$action<hr>$k->$v");




  sleep(1);                                          #sleep 1s to get new id
  return;
}


################# edit jobs
sub jobslib_edit {
##################

    # this function is called on edit without par or on list all jobs with par=jobtype
    # joblist, get info for text1,text2,iopt1,opt2,op3

    my $id=$_[0];
    my ($t,$j);

    # get current job-type
    if ($id ne "") {
        $j=$id."_job";                # for jobtype
    } else {
        $j=$in{'list'}."_job";        # for jobtype
        $id=$in{'list'};
    }

    #defaults
         $current{'text1'}="";
         $current{'text2'}="";
         $current{'opt1'}="";
         $current{'opt2'}="";
         $current{'opt3'}="";
         $current{'editpar'}="";

    #valid type
         if ($current{$j} eq "")          { return; }


    # replicate:
    if ($current{$j} eq "replicate") {
        #$current{'editpar'}="host,hostip,transport,port,dest_sharename,dest_shareguest,dest_shareabe,send_i,keep,hold,transfer_zero";  # transfer_zero optional
        $current{'editpar'}="host,hostip,transport,port,dest_sharename,dest_shareguest,dest_shareabe,send_i,keep,hold";

        $current{'hostip_info'}="Enter ip of source host (used for transfers)";
        $current{'host_info'}="Enter name of source host";
        $current{'hold_info'}="Hold target snaps for n (days)  ns for snaps <br><br>ex 8 for 8 days and 8s for 8 snaps<br>left empty for default=hold last 2 snaps";
        $current{'keep_info'}="Keep one target snap for n hours (1..24), days, months or years, opt char (commalist) ex<br>hours:24,days:32,months:12,years:2";
        $current{'transport_info'}="Enter transport mechanism: nc or mbuffer";
        $current{'port_info'}="Enter used port > 50000-60000 ex: 54786";
        $current{'dest_sharename_info'}="Share replicated filesystem (R/O) under this name:";
        $current{'dest_shareabe_info'}="Activate ABE on this share (show only accessable files) = yes/no";
        $current{'dest_shareguest_info'}="Activate guest-access on  this share = yes/no";
        $current{'send_i_info'}="incremental zfs send: use only last snapshot (-i) or include all intermediate snaps (-I)<br>default/no value is: -i";

        # $current{'transfer_zero_info'}="Do replications with source snap size=0, default=no (yes)"; # optional

        # list job values in job overview
        $t=$id."_host";
        $current{'text1'}=$current{$t};          # from
        $t=$id."_hostip";
        $current{'text1'}.=" $current{$t}";     # ip

        $t=$id."_source";
        $current{'opt1'}=$current{$t};          # source zfs

        $t=$id."_transport";
        $current{'text2'}=$current{$t};         # transport

        $t=$id."_recursiv";
        if ($current{$t}=~/yes|1/) {
          $current{'text2'}.=" rec";            # opt add rec
        }
        $t=$id."_send_dedup";
        if ($current{$t}=~/yes|1/) {
           $current{'text2'}.=" ded";           # opt add dedup
        }

        $t=$id."_dest_sharename";
        if ($current{$t}ne "") {
          $current{'text2'}.=" smb";            # opt share
        }

        $t=$id."_keep";
        $current{$t}=~s/\-//g;
        if ($current{$t} ne "") {
          $current{'text2'}.=" kp";            # opt add keep
        }
        $t=$id."_hold";
        if ($current{$t} ne "") {
          $current{'text2'}.=" hld";            # opt add hold
        }

        $t=$id."_destination";
        $current{'opt2'}=$current{$t};          # dest

        $t=$id."_port";
        $current{'opt3'}="port $current{$t}";   # port

        $t=$id."_send_i";
        if ($current{$t}=~/-I/) {
           $current{'text2'}.=" -I";           # opt send i
        }
    }

    #######
    # other
    if ($current{$j} eq "other") {
        #todo
        $current{'editpar'}="action,err,noerr,condition";
        $current{'action_info'}="Enter a cli command like ntpdate pool.ntp.org or a shell script like /root/action.sh";
        $current{'condition_info'}="A return value of your cli cpommand is treated as error: always,never,condition";
        $current{'noerr_info'}="If error is set to condition, there is no error set when script returns: ";
        $current{'err_info'}="If error is set to condition, there is an error set when script returns: ";

        $t=$id."_name";
        $current{'text1'}=$current{$t};

        $t=$id."_action";
        $current{'opt1'}=$current{$t};

        $current{'text2'}="error";

        $t=$id."_condition";
        $current{'opt2'}=$current{$t};

    }

    #######
    # email
    if ($current{$j} eq "email") {
        $current{'editpar'}="server,pw,to,from,user,trigger";
        $current{'server_info'}="Enter smtp server ex smtp.name.com";
        $current{'pw_info'}="Enter pw for mailuser (stored cleartext!, use a separate log account/forwarder)";
        $current{'user_info'}="Enter username for smtp";
        $current{'from_info'}="Mail are send from: ex alert\@san1.com";
        $current{'to_info'}="Mail is send to (commalist allowed): name\@enterprise.com";
        $current{'trigger_info'}="Trigger (commalist): ex Disk,Low,Job";

       # not used (rename job-tls-email.pl to job-email.pl)
       # $current{'tls_info'}="TLS is needed for some mailer like Google and requires manual installation of Perl TLS modules. Use TLS: yes/no";

        if (-f "/var/web-gui/_log/use_tls.log") {
            $current{'opt3'}="TLS port 587";
        } else {
            $current{'opt3'}="smtp port 25";
        }

        $t=$id."_server";
        $current{'opt1'}=$current{$t};

        $t=$id."_to";
        $current{'opt2'}=$current{$t};

        $t=$id."_text1";
        $current{'text1'}=$current{$t};

        #alert
        $t=$id."_trigger";
        if ($current{$t} ne "") {
           $current{'text2'}=$current{$t};
        } else {
          $current{'text2'}="Info";
        }
    }

    #######
    # push
    if ($current{$j} eq "push") {
        $current{'text1'}='push alerts';

        $current{'opt1'}='token';
        $t=$id."_token";
        $current{'text2'}=$current{$t};
        $t=$id."_user";
        $current{'opt2'}=$current{$t};
    }

    #######
    # scrub
    if ($current{$j} eq "scrub") {
       $current{'editpar'}="pool";
        $current{'pool_info'}="Enter ZFS pool name for autoscrub: ex tank";
        $t=$id."_pool";
        $current{'text1'}=$current{$t};
    }

    #######
    # snap
    if ($current{$j} eq "snap") {
        $current{'editpar'}="pool,keep,hold,name,delzero,prejob";
        if ($cfg{'ver'}=~/c|m/) { $current{'editpar'}.=",md5"; }

        $current{'pool_info'}="Enter ZFS name for autosnap: ex tank/data";
        $current{'keep_info'}="How many snaps should be kept: 1..n";
        $current{'hold_info'}="How many days should snaps be kept: (optional)";
        $current{'prejob_info'}="Execute a id.pre and id.post script to create hotsnaps in ESXi prior a ZFS snap (yes,no)";
        $current{'name_info'}="Jobname ex weekly";
        $current{'delzero_info'}="Delete all zerosnaps beside newest: yes/no<br>Do not set to yes on filesystems with auto-replications.";
        $current{'md5_info'}="Create md5 list of all files via 'digest -a md5 -v file' in folder or ZFS /pool/validate: yes/no";

        $t=$id."_pool";
        $current{'text1'}=$current{$t};

        $t=$id."_keep";
        $current{'opt1'}="keep $current{$t}";

        $t=$id."_name";
        $current{'text2'}="$current{$t}";

        $t=$id."_delzero";
        if ($current{$t} eq "yes")  {  $current{'opt2'}="del zero"; }

        $t=$id."_hold";
        if ($current{$t} >0)        {  $current{'opt2'}.=", hld $current{$t}"; }

        $t=$id."_prejob";
        if ($current{$t} eq "yes")  {  $current{'opt3'}="pre "; }

        $current{'opt2'}=~s/^, //;

        $t=$id."_md5";
        if ($current{$t} eq "yes")  {  $current{'opt3'}.="md5"; }

    }

    #######
    # backup
    if ($current{$j} eq "backup") {
        # editpar: none

        $t=$id."_nfiles";
        $current{'text1'}="$current{$t}";

        $t=$id."_efiles";
        $current{'opt1'}="$current{$t}";

        $t=$id."_ofiles";
        $current{'text2'}="$current{$t}";

        $t=$id."_pool";
        $current{'opt2'}="$current{$t}";
    }


}

###################
sub jobslib_job_overview {    # print list with edit of created jobs below current menue level, parameter: none
###################

     # each job is a file in /_log/jobs/

     # job art ex snap
     # comment ex snap, keep
     # opt1 ex. vol1
     # opt2 ex 4
     # m=minute                                    # every, 0..59
     # h=hour                                      # every, 0..23h
     # d=day ex                                    # every, 1..31 and sun..sat
     # m=monthly                                   # every, 1..12

     # status: active, pause
     # last: last status (error, ok)

     # ex -> job_snap_weekly_weekly snaps of vol3_q:h=1:w=*:m=*.txt
     # content of file: log of actions

     # show execute status (running) from at: option : run now or stop if runnung
     # hash job parameter -> ex  $job{'1234567_hour'}

     #############################################################################
     my ($time,@jobs,$r,$log,@list,$l,@l,$url,$w,@w,$i,$job,$l2,$l3,$ask,@m,%job,$info,$id,@p,$p,$run,$rrun,@rp,$really,$j,$current,$tdel,$h,$lokal,$remote,@u,$u);

     $l2=$in{'l2'};
     $l2=~s/^\d+\_//;  $l2=~s/ .*//;
     $l3=$in{'l3'};
     $l3=~s/^\d+\_//;  $l3=~s/ .*//;

     #get path to logfolder  napp-it/_log/jobs/
      $log="/var/web-gui/_log/jobs/";

      my $action=$in{'action'};               #  $in{'action'} is deleted by &ask in Monotor
      my $prop=$in{'prop'};                   #  $in{'prop'} is deleted by &ask in Monitor

     # part 1 request execute actions
     ##########################################################################

     # read jobparameter to %current
     &task_read_jobpar("","-$cfg{'ver'}");

#debug
#&print_hash(%current);

     $time=time();

    ####################
    #request run job now
    ####################
    if (($in{'action'} eq "run") && ($in{'job'} =~/\d+/)) {

                 $p="$in{'job'}"."_job";
                 $t=$current{$p};
                 open (PF, ">/tmp/nappit/job-$t\_$in{'job'}.request");          # ex ex /tmp/nappit/job-scrub_1350378156.request
                       flock(PF, LOCK_EX);
                       print PF "run_$in{'job'} $time";
                 close (PF);
                 print "request job-$t\_$in{'job'}.request, please wait...";
                 if (-f "/tmp/nappit/$in{'job'}.cancel")  { `sudo rm /tmp/nappit/$in{'job'}.cancel`; }     # del last cancel req

                 $in{'action'}="";
                 sleep(1);
                 &reload;
    }

     ####################
     # request delete job
     ####################

#debug
#&print_hash(%in);

     #delete selected
     $in{'sel_job'}=~s/\.\+$//;
     chomp($in{'sel_job'});

     #delete single?
     if (($in{'action'} eq "delete") && ($in{'job'} =~/\d+/)) {
           $in{'sel_job'}=$in{'job'};
     }

     # delete selected
     if ($in{'sel_job'} ne "") {
        @t=();
        @t=split(/\.\+/,$in{'sel_job'});

#debug
#print_array(@t);

        foreach my $jb (@t) {
            $jb=~s/\D//g;

            # opt1, job is running, set a delete request

                 open (PF, ">/tmp/nappit/$jb.delete");                   # ex /tmp/nappit/1350378156.delete
                       flock(PF, LOCK_EX);
                       print PF "delete_$jb $time";                      # no content !! -> timer when .running
                 close (PF);

           # opt2, job not running, delete a del request via jobscript, need both because real state may be different from jobview
                 $p="$jb"."_job";
                 $t=$current{$p};
                 $t=~s/\s//g;

                 if (($t eq "") && ($jb > 0))        {                  # unknown jobtype, just delete
                     `sudo rm /var/web-gui/_log/jobs/$jb*`;
                 } else {

                    open (PF, ">/tmp/nappit/job-$t\_$jb.request");      # ex ex /tmp/nappit/job-scrub_1350378156.request
                       flock(PF, LOCK_EX);
                       print PF "delete_$jb $time";
                    close (PF);
                 }
                 print "request $jb.delete -> $t<br>";
                 if (-f "/tmp/nappit/$jb.cancel")  { `sudo rm /tmp/nappit/$jb.cancel`; }     # del last cancel req

        }
        $in{'action'}="";
        sleep(1);
        &reload;
     }


    #################################
    #stop or cancel a running job now
    #################################
    if (($in{'action'} eq "stop") && ($in{'job'} =~/\d+/)) {

          # opt1, job is running, set a cancel request

                 open (PF, ">/tmp/nappit/$in{'job'}.cancel");                   # ex /tmp/nappit/1350378156.cancel
                       flock(PF, LOCK_EX);
                       print PF "cancel_$in{'job'} $time";
                 close (PF);

          # opt2, job not running, delete a cancel request via jobscript, need both because real state may be different from jobview
                 $p="$in{'job'}"."_job";
                 $t=$current{$p};
                 open (PF, ">/tmp/nappit/job-$t\_$in{'job'}.request");          # ex ex /tmp/nappit/job-scrub_1350378156.request
                       flock(PF, LOCK_EX);
                       print PF "cancel_$in{'job'} $time";
                 close (PF);


                 print "request $in{'job'}.cancel, please wait...";
                 if (-f "/tmp/nappit/agent-pages_15.htm")  { `sudo rm /tmp/nappit/agent-pages_15.htm`; }
                 $in{'action'}="";
                 sleep(1);
                 &reload;
    }



    #change manual/active
    ######################
    if (($in{'action'} =~/manual/) && ($in{'job'} =~/\d+/)) {
          $t=$in{'job'}."_status";
          $current{$t}="manual";
          &task_update_par($in{'job'});
          print "request active -> manual";
          if (-f "/tmp/nappit/agent-pages_15.htm")  { `sudo rm /tmp/nappit/agent-pages_15.htm`; }
          $in{'action'}="";
          sleep(1);
          &reload;
    }
    if (($in{'action'} =~/active/) && ($in{'job'} =~/\d+/)) {
          $t=$in{'job'}."_job";
          if (($current{$t} eq "replicate") && (!($cfg{'ver'}=~/c|r/))) {
              &mess("only manual use without replication extension possible");
          }

          $t=$in{'job'}."_status";
          $current{$t}="active";
          &task_update_par($in{'job'});
          print "request manual -> active";
          if (-f "/tmp/nappit/agent-pages_15.htm")  { `sudo rm /tmp/nappit/agent-pages_15.htm`; }
          $in{'action'}="";
          sleep(1);
          &reload;
    }

   #######################
   # part 2, show job-overview
   #########################################################################################

    #read jobs
    @t=();
    @t=&task_get_dir("$log",".par","jobslib 392");        # &task_get_dir("dir","Muster","Zeilennr") return array


     #url to edit a job
     $url=" <a title=\"=title=\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list==list=\&amp;prop==prop=\&amp;action==action=\&amp;items==items=\&amp;job==job=\"=ask=>=text=</a>";
     $ask=" onclick=\"return(confirm('=ask2=?'))\"";

     # del selected if websocket monitor=off
     my $del="&nbsp;<input style=\"vertical-align: top; margin:0; padding:0; font-size: 8px\" type=\"checkbox\" name=\"sel_job\" value=\"JOB.+\">";
     if (!(-f "/tmp/nappit/napp-it_ws_off")) { $del=""; }


     #convert _ to \t, remove .txt ,add exe and delete
     ##################################################
     foreach $t (@t) {                                     # each job   123.par

              $id=$t;
              $id=~s/\..*$//;                              # job id

              #selected jobs only? (memue l2, show in any l3)
              if ($l2 ne "") {
                   $j="$id"."_job";
                   if (!($l2=~/$current{$j}/i)) { next; }
              }
              #selected subjobs only? (memue l3)           # show jobs always in any l3 menue

              &jobslib_edit($id);                          # values for this list entry

              #get laststate
              $i="$log$id.log";                          # log last runs

              # default
              $p="$id\_last10run";
              $current{$p}="";

              $p="$id\_lastrun";
              $current{$p}="";


              if (-f $i) {
                 @p=();
                 open (F,"<$i");
                    flock(F, LOCK_EX);
                    @p=<F>;
                 close (F);

                 $p="$id\_lastrun";
                 if ($p[0]=~/^error/)  {
                     $current{$p}="error";                  # read laststate

                     #check error within last 10 entries
                     $p="$id\_last10run";
                     if (($p[0]=~/^error/) || ($p[1]=~/^error/) || ($p[2]=~/^error/) || ($p[3]=~/^error/) || ($p[4]=~/^error/) || ($p[5]=~/^error/) || ($p[6]=~/^error/) || ($p[7]=~/^error/) || ($p[8]=~/^error/) || ($p[9]=~/^error/) || ($p[10]=~/^error/))  {
                           $current{$p}="error";
                     } else {
                           $current{$p}="ok";
                     }
                 }
              }

              #build jobline
              $t="";
              $j="$id"."_job";   $t="$current{$j}";           # jobtype   1

              ## these values are in %current without id (from jobslib_edit)
              $t.="\t$current{'text1'}";                      # text1     2
              $t.="\t$current{'opt1'}";                       # opt1      3
              $t.="\t$current{'text2'}";                      # text2     4
              $t.="\t$current{'opt2'}";                       # opt2      5
              $t.="\t$current{'opt3'}";                       # opt3      6

              ##
              $j="$id"."_month"; $t.="\t$current{$j}";        # month     7
              $j="$id"."_day";   $t.="\t$current{$j}";        # day       8
              $j="$id"."_hour";  $t.="\t$current{$j}";        # hour      9
              $j="$id"."_min";   $t.="\t$current{$j}";        # min       10
              $t.="\t$id";                                    # id        11
              $j="$id"."_status";  $t.="\t$current{$j}";      # status    12
              $j="$id"."_last";    $t.="\t$current{$j}";      # last      13
              $t.="\t=local=";                                # state like running  15
              $t.="\t=exe=\t=delete=";                        # 16-17
              push (@jobs,$t);
     }
     ###################
#&print_hash(%current);
#&print_array(@jobs);


     #insert url to edit
     ####################################################
     @jobs=sort(@jobs);
     my ($p1,$p2);
     foreach $t (@jobs) {                                 #job,t1,o1,t2,o2,m,d,h,m,id,status,last,local,exe

              $lokal="";
              $remote="";

              @w=();
              @w=split(/\t/,$t);
              $id=$w[10];                      #jobid
              $really="";

              #0=job

                        $i=$w[0];
                        $w[0]=$url;

                        $p="$id\_last10run";
                        if ($current{$p} eq "error")  {
#&print_hash(%current);
                          $p1="<font class='font_orange'>"; $p2="</font>"; $w[0]=~s/=title=/$i $id error last 10 logs/;
                        } else {
                          $p1=""; $p2=""; $w[0]=~s/=title=/$i $id/;
                        }

                        $w[0]=~s/=text=/$p1$i$p2/; $w[0]=~s/=ask=//;
                        $w[0]=~s/=action=/info/;  $w[0]=~s/=items=//;
                        $w[0]=~s/=job=/$id/;

              #1=text1
                        $w[1]=&get_short_a($w[1],'20f');

              #2=opt1
                        if ($w[2] eq "") {$w[2]="-"; }
                        $w[2]=&get_short_a($w[2],'20f');

              #3=text2
                        $w[3]=~s/_/\&nbsp;/g;
                        $w[3]=&get_short_a($w[3],'10f');

              #4=opt2
                        if ($w[4] eq "") {$w[4]="-"; }
                        $w[4]=&get_short_a($w[4],'20f');

              #5=opt3
                        if ($w[5] eq "") {$w[5]="-"; }
                        $w[5]=&get_short_a($w[5],'10f');

              #6=month
                         $w[6]=&jobslib_get_url($id,"$url","month",$w[6]);   # id,url,opt,val
                         $w[6]=~s/=title=/month $id/;

              #7=day
                        $w[7]=&jobslib_get_url($id,"$url","day",$w[7]);      # id,url,opt,val ;
                        $w[7]=~s/=title=/day $id/;

              #8=hour
                        $w[8]=&jobslib_get_url($id,"$url","hour",$w[8]);      # id,url,opt,val ;
                        $w[8]=~s/=title=/hour $id/;

              #9=min
                        $w[9]=&jobslib_get_url($id,"$url","min",$w[9]);      # id,url,opt,val ;
                        $w[9]=~s/=title=/min $id/;

              #10=id

                        $i=$w[10];
                        $w[10]=$url; $w[10]=~s/=text=/$i/; $w[10]=~s/=ask=//;
                        $w[10]=~s/=action=/editpar/;  $w[10]=~s/=items=//;
                        $w[10]=~s/=job=/$id/;         $w[10]=~s/=list=/$id/;
                        $w[10]=~s/=title=/$id/;

               #11=status active/ manual/ running -> with stop option
                #########################################################

                        $i=$w[11];

                        $w[11]=$url;
                        $w[11]=~s/=job=/$id/;
                        $w[11]=~s/=ask=/$ask/;
                        $w[11]=~s/=title=/$i $id/;

                        if ($i =~/active/) {
                                $w[11]=~s/=ask2=/set job $id to manual/;
                                $w[11]=~s/=text=/$i/;
                                $w[11]=~s/=action=/manual/;

                        } else {
                                $w[11]=~s/=ask2=/set job $id to active/;
                                $w[11]=~s/=text=/$i/;
                                $w[11]=~s/=action=/active/;
                        }

                        if ($w[6] eq "0")     { $w[11]="manual"; }             # month=0
                        if ($w[0] =~/remote/) { $w[11]="remote"; }             # month=0


                        $i="";
                        $w[11]=~s/=ask2=//;  $w[11]=~s/=items=//;        $w[11]=~s/=delete=//;




                 #12 last, new, ok error, load values in tasklib!!
                 ##########

                        #$w[12]=~s/_/ /;  $w[12]=~s/_/:/;        #date_hour_min -> date hour:min
                        #$i="$id\_lastrun";                      # from last entry in id.log (1st line start with err)
                        #if ($current{$i} eq "error")  { $w[12]= "<font style=\"color:#ff0000\">"."$w[12]"."</font>"; }        #alert

                        $w[12]=~s/_| /\&nbsp;/g;
                        $i="$id\_lastrun";                      # from last entry in id.last (1st line start with err)
                        if ($current{$i} eq "error")  {
                             $i= "<font style=\"color:#ff0000\">"."$w[12]"."</font>";         #alert
                        } else {
                              $i=$w[12];
                        }
                        $i=~s/_/ /;  $i=~s/_/:/;

                        if (-f "/var/web-gui/_log/jobs/$id.last") {
                             $w[12]=$url;
                             $p="$id\_last10run";

                             $w[12]=~s/=text=/$i/;      $w[12]=~s/=ask=//;    $w[12]=~s/=action=/info/;
                             $w[12]=~s/=prop=/last/;    $w[12]=~s/=items=//;  $w[12]=~s/=title=/show last log from $id/;
                             $w[12]=~s/=job=/$id/;
                        }  else {
                             $w[12]=$i;
                        }



                #13 display job status
                ################################

                   $t="$id\_state";
                    #cancel requested?

                   if ($current{$t} ne "") {   # request, running or run/cancel
                       $w[13]=~s/=local=/<a href=\"#\" onClick=\"javascript:alert(\'$id\')\"><font class=\"font_darkblue\">$current{$t}<\/font><\/a>/;
                   }

                   # otherwise
                        $w[13]=~s/=local=/-/;



                #14=cancel, run now
                ###########
                       $i="$id\_state";

                       if ($current{$i}=~/run/) {
                                $w[14]=$url;
                                $w[14]=~s/=text=/cancel/;                     $w[14]=~s/=ask=/$ask/;
                                $w[14]=~s/=ask2=/stop or cancel job $id now/; $w[14]=~s/=action=/stop/;
                                $w[14]=~s/=title=/stop or cancel $id/;
                        }  else {
                             if ($w[0]=~/remote/) {                    # remote initiated job
                                $w[14]="-";
                             } else {
                                $w[14]=$url;                $w[14]=~s/=text=/run now/;             $w[14]=~s/=ask=/$ask/;
                                $w[14]=~s/=action=/run/;    $w[14]=~s/=ask2=/run job $id now/;
                                $w[14]=~s/=title=/run now $id/;
                             }
                        }


                       # $run="";

                       $w[14]=~s/=job=/$id/;      $w[14]=~s/=items=//;
                       $w[14]=~s/=delete=//g;


                #15=delete or % or Size
                ##############

                    # job is running opt -> % or size

                    $t="$id\_state";
#&print_hash(%current);
                    if ($current{$i}=~/run/) {

                         $t="/tmp/nappit/$id.progress";                           # all local processes are running  sourcesize_destsize_percent
                         if (-f $t) {
                             $i=`cat $t`;
                             $i=~s/\n.*//s;                                       # first line
                             $i=~s/.*\_//;

                             if (($i eq "") || ($i>105)) {
                                   $i="\% n.a.";
                             }   else {
                                  if (!($i=~/[A-Z]/)) {                             # not 12M
                                     if ($i ne "0") {
                                       $i="$i\%";
                                     }
                                  }
                             }
                             $w[15]=~s/=delete=/$i/;
                         }  else {
                             $w[15]=~s/=delete=/\% n.a./;
                         }
                         $w[15]=~s/=title=/$i $id/;
                    } else {

                        ## job is not running -> show delete
                        ###############################

                         if ($w[0]=~/remote/) {                    # remote initiated job
                           $w[15]="-";
                           $w[15]=~s/=title=/$id/;
                        } else {
                           $i=$w[15];
                           $w[15]=$url;

                           $w[15]=~s/=text=/$i/;
                           $w[15]=~s/=ask=/$ask/;        $w[15]=~s/=ask2=/delete job $id !!!/;

                           $w[15]=~s/=job=/$id/;         $w[15]=~s/=items=//;
                           $w[15]=~s/=delete=/delete/;   $w[15]=~s/=action=/delete/;
                           $w[15]=~s/=title=/delete $id/;

                           $w[15].=" $del";
                           $w[15]=~s/JOB/$id/g;
                        }
                    }


               $t=join("\t",@w);
     }

     #make list
     $l=join("\n",@jobs);

#test
#&print_array(@jobs);
#&mess("$w[11]<hr>$l");
#$t=time();
#$l=~s/by/$t/gs;


     #add headers
     $l="Joblog\tText1\tOpt1/ from\tText2\tOpt2/ to\tOpt3\tMonth\tDay\tHour\tMin\tID/ edit\tStatus\tLast\&nbsp;\&nbsp;\&nbsp;\&nbsp;\&nbsp;\tJobstate\&nbsp;\&nbsp;\tExecute&nbsp;&nbsp;\tJob\n".$l;

     #create nice list
     $l=&list2table("$l","","sort2");

     # add begin (job delete)
     #del selected if websocket mon=off
     if (-f "/tmp/nappit/napp-it_ws_off") {
         &ask('begin_jd','b');                                                  # delete $in{'action'}, use $action and $prop from now

         #keep action for edit
         $in{'action'}=$action;
     }

     $l="<!--wsarea-->\n<div id='wsarea'>\n$l\n</div>\n<!--wsarea_end-->\n";    # realtime update of list only

     ###########
     #add auto service status
     if ($l3 eq "") {
        $r=&exe("crontab -l root",'','jobslib 580');                           # get crontab for user root
        @l=split(/\n/,$r);
        $r=" napp-it auto-service is: check cron for auto.pl at console";
        foreach $t (@l) {
            if ($t=~/auto\.p./) {
                #
                $r="auto-service: enabled every minute";
                if ($t=~/^0+,15/) {
                  $r="auto-service: enabled every 15 minutes, <br><b>this disables all jobs with min other than 0, 15, 30, 45</b>";
                }
                if ($t=~/^0+,5/) {
                  $r="auto-service: enabled every 5 minutes";                    #print result
                }
            }
        }
     }

    ####################################
     print "$l\n";

     # add confirm if websocket mon=off
     if (-f "/tmp/nappit/napp-it_ws_off") {
          print "<br><br>\n";
          &ask('confirm','delete selected','delete selected jobs?');
     }

     print "<br><br>$r<br>";
     print "$txt{'disable_mon'}<br><br><br>";


    #cancel edit?
    if ($in{'old'} eq "cancel") {
         $in{'action'} = "editpar";
         $in{'job'} = $in{'list'};
    }

    # general job-log
    #################
    if (($action eq "") && ($in{'l3'} eq "")) {
         print "<b> Logged Infos about last 50 Jobs</b> (newest first, click under jobinfo for more details)";
         $r=&exe("touch /var/web-gui/_log/jobs/jobs.log");
         $r=&exe("cat /var/web-gui/_log/jobs/jobs.log");
         $r=~s/error;/<font style=\"color:#ff0000\">error<\/font>;/gs;
         $r=~s/;/\t/gs;
         print &list2table($r,'99%,65px');
    }

     ## edit jobpar
     ##############
     # cancel edit?
 #&mess("$prop, $action, $in{'answered'}");

     if ($action eq "editpar")  {

         #get edit defaults
         &jobslib_edit($in{'list'});

         #list job_allpar
         print "<b> Edit Parameters: Job $in{'list'}</b>";

         $r=$current{'editpar'};
         if ($r eq "") { $r = "none"; }

         @t=();
         @t=split(/,/,$r);

         $r="";
         foreach my $t (@t) {
             $p="$in{'list'}"."_$t";  # parameter
             $p=$current{$p};
             if ($t eq "pw") { $p="********"; }

            $t=&jobslib_get_url($in{'list'},"$url","$t",$t);   # id,url,opt,val
            $r.="$t\t$p\n";
         }
         $r=~s/,$//;
         print &list2table($r,'99%,145px');
         print "<br><br>";

         #ask property
             if (!  (($prop eq "") || ($prop eq "=prop=")  || ($in{'answered'} eq "1"))  ) {                  # use $prop
                   print &jobslib_ask_jobproperty;
             }

          #set property
             if (($prop ne "") && ($in{'answered'} eq "1")) {
                     &jobslib_change_jobproperty;
             }
    }

#&print_hash(%current);
    #this job log
    ###############
    if ($action eq "info") {
      if ($in{'prop'} eq "last") {
         # last detailled joblog
         print "<b> Log: Last run of Job $in{'job'}</b> (newest first)";
         $r=&exe("cat /var/web-gui/_log/jobs/$in{'job'}.last");
         @t=();
         @t=split(/\n/,$r);
         @t=reverse(@t);
         $r=join("\n",@t);

         $r=~s/error/<font style=\"color:#ff0000\">error<\/font>;/gs;
         print &list2table($r,'99%,65px')
      } else {
         # global joblog
         print "<b> Log: Job $in{'job'}</b> (newest first)";
         $r=&exe("cat /var/web-gui/_log/jobs/$in{'job'}.log");
         $r=~s/error;/<font style=\"color:#ff0000\">error<\/font>;/gs;
         $r=~s/;/\t/gs;
         print &list2table($r,'99%,65px');
      }
    }



    return;

}


####################
sub jobslib_get_url {  # id,url,opt,val
####################
my $id=$_[0];
my $url=$_[1];
my $opt=$_[2];
my $val=$_[3];
my $i=$val;
    if ($val eq "") {$val="-"; }

    $val=$url;
    $val=~s/=job=/$id/;
    $val=~s/=prop=/$opt/;
    $val=~s/=ask=//;
    $val=~s/=text=/$i/;
    $val=~s/=items=/$i/;
    $val=~s/=list=/$id/;
    $val=~s/=action=/editpar/;
    return ($val);
}

###############
sub jobslib_enable_auto {  # enable autojobs, parameter: none=15 or 1=1min
###############
my ($file,$r,$c,$a,$p,$out,@l,$int);
       $int="15";                                       # default intervall
       if ($_[0] eq "1") { $int="1"; }
       if ($_[0] eq "5") { $int="5"; }

       $a="/var/web-gui/data/napp-it/zfsos/_lib/scripts/auto.pl";
       $file="/var/web-gui/_log/crontab.txt";           #  path to log crontab


        $r=&exe("crontab -l root",'','jobslib 677');    # get crontab for user root
        chomp($r);
        $r=~s/\s+$//gs;                                 # trim


        $c="* * * * * perl $a";                         # call auto.pl every 1 min, default


        if ($int eq "5") {
               $c="0,5,10,15,20,25,30,35,40,45,50,55 * * * * perl $a";                # call auto.pl every 5 min
        }
        if ($int eq "15") {
               $c="00,15,30,45 * * * * perl $a";        # call auto.pl every 15 min
        }

        @l=split(/\n/,$r);
        push(@l,"");                                    # needed for empty file

        if ($r=~/\/auto\.pl/s)  {                       # modify perl auto.pl
           foreach my $l (@l) {
             if ($l=~/auto.pl/)  {  $l=$c;  }           # replace auto entry
           }

        }  else {
           $p="1";                                      # add perl auto.pl as first entry (there are reported problems when it is the last)
           foreach my $l (@l) {
             chomp($l);
             if ($l=~/^\#/)  {  next;  }
             if ($p eq "1") {
                $l="$c\n$l";
                $p="0";
                last;
             }
           }
        }
        $r=join("\n",@l);
#&mess($r);
        `touch $file`;
        &exe("chmod 666 $file");

        #write new crontab
        open (PF, ">$file");
             flock(PF, LOCK_EX);
             print PF "$r\n";                                           # write with \n
        close (PF);


        $out.=&exe("crontab < '$file'");                                 # set crontab
        $r=exe("crontab -l root",'','jobslib 693');                      # get new crontab for user root
#&mess($out);
        @l=split(/\n/,$r);
        $r="napp-it auto-script disabled";
        foreach $t (@l) {
          if ($t=~/\/auto\.pl/) {
             if ($t=~/^00/) {
               $r="\nauto-script enabled in root crontab (runs every 15 minutes):<br><b>this disables all jobs with min other than 0, 15, 30, 45</b><br>\n$t";                    #print result
             }
             if ($t=~/^0,5/) {
               $r="\nauto-script enabled in root crontab (runs every 5 minute)\n$t";                   #print result
             }
             if ($t=~/^\* /) {
               $r="\nauto-script enabled in root crontab (runs every minute):\n$t";                    #print result
             }
          }
        }
        return ($r);
}




sub jobslib_disable_auto { # disable autojobs
#################
my ($file,$r,@l,$p);

     $file="/var/web-gui/_log/crontab.txt";            #  path to log crontab
     `touch $file`;
     &exe("chmod 666 $file");

     $r=&exe("crontab -l root",'','jobslib 717');      # get crontab for user root
     @t=();
     if ($r=~/auto\.pl/s)  {                           # remove perl auto.pl
           $r=~s/\s+$//gs;                             # trim
           @l=split(/\n/,$r);
           @t=();
           foreach $t (@l) {
               if (!($t=~/auto\.pl/)) { push (@t,"$t"); }
           }

           #write new crontab
           open (PF, ">$file");
              flock(PF, LOCK_EX);
              foreach my $t (@t) {
                 print PF "$t\n";                      # write with \n
              }
           close (PF);
     }

     $r=&exe("crontab < '$file'");                     # set crontab
     $r=&exe("crontab -l root",'','jobslib 730');                       # get crontab for user root
#&mess($r);

     @l=split(/\n/,$r);
     $r="\n  - napp-it auto-script disabled -";
     foreach $t (@l) {
          if ($t=~/auto\.p./) { $r="\n$t"; }           #print result
     }
     return ($r);
}


#EoF ######################
# do not remove line below (return true)
1;
