# os-lib.pl
####

# os functions for napp-it    Copyright (c) 20010 napp-it
# this lib is created automatically on a new os-folder if missing

##########
sub oslib {  #13.10.2010
##########
}


################
sub oslib_status  {                 #hide:  -> print os status info in menue napp-it - about
###############
   my ($ant,$r,$t,$v,$h,$ok,$ref);

   #defaults:
   $h=`hostname`;
   chomp($h);
   
    #&print_array(@new);
    #show edition
    $t=&getp();
    print "<pre>\n<b style='background-color:#dddddd'>napp-it Edition:</b><b> $t version</b>\n";
    print "    If a PRO version expires, functionality is reduced to the unlimited FREE version\n\n";

    $r=`ps axw | grep /var/web-gui/`;

    # show napp-it status
    #print "    websocket server: ";
    #if ($r=~/socketserver.pl/) { print "running" } else { print "<font style='color:red'>missing</font>"; }


    print "    task server: ";
    if ($r=~/taskserver.sh/) { print "running" } else { print "<font style='color:red'>missing</font>"; }

    my @p=split(/\n/,$r);
#&print_array(@p);

    $t="";
    if ($r=~/\.pl/) {
       print "\n    active agents: ";
       foreach my $p (@p) {
           if ($p=~/server|grep|mhttp|wwwroot/) { next; }

           $p=~s/\'//; $p=~s/\'.*//;      # keep first parameter xx.pl 'cc' 'nn/vvs'
           if ($p=~/\.pl/) {
              $p=~s/.*\///;
              if ($p=~/ \d+$/) {             # remove timestamp
                $p=~s/ \d+$//;
              }
              $p=~s/_\D.*//;
              $t.="$p, ";
           }
       }
    }
    $t=~s/, $//;
    print $t;


    #show extensions
    print "\n<br>";
    $t=&getpd();
    print $t;
    if (!($t=~/\n/s)) { print "<br><br>"; }


    $ant="    OS     :  ";
    $ant.=`uname -a`; $ant=~s/\n|\r//gs;
    chomp $ant;

    $ant.="<br>    uptime : ";
    $ant .=`uptime`;


    print "\n<b style='background-color:#dddddd'>System release:</b>\n\n$ant\n";



    #pool status and service only in osol..
    if (! ($sys{'auto_os'} =~/open|solaris|ill|nexenta|omni/i))  { return; }

   ####
    print "<br>\n\n<b style='background-color:#dddddd'>Server overview:</b>\n";
    $ant="";

    $ant.="    uptime        : ";
    $ant .=`uptime`;


    #afp
    ####
    $ant.="\n    afp-server    :  ";

    #netatalk v3
    if ($sys{'netatalk3'} ne "") {
          $r=`svcs | grep netatalk`;        $r=~s/ .*|\n//gs;
          if ($r eq "") { $r="<font style='color:#e9a47a'>disabled</font>"; }
          $r.=" netatalk V.3";

          if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x netatalk`;  $r.="</p>"; }

    } else {
          $r="<font style='color:#e9a47a'>netatalk3 not installed</font>";
    }
    $ant.=$r."\n";


    # Apache
    #########
    $ant.="    apache-server :  ";
    $r=`svcs | grep apache`;        $r=~s/ .*|\n//gs;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    } else {
      # show Include info ############
      my $i;
      if ($sys{'auto_os_type'} eq "sol_s") {                       # Solaris
         $i=`cat /etc/apache2/2.2/httpd.conf`;
      } else {
         $i=`cat /opt/local/etc/httpd/httpd.conf`;                # ampo
      }
      @t=(); @t=split(/\n/,$i);
      $t="";
      foreach my $i (@t) {
        if ($i=~/^Include/) {
           $i=~s/.*\///;                                          #Include /opt/local/etc/httpd/httpd_owncloud.conf
           $i=~s/.conf//;
           $t.="$i, ";
        }
      }
      $t=~s/, $//;
      if ($t ne "") { $r.=" (Include $t)"; }
    }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x apache`;  $r.="</p>"; }
    $ant.=$r;



    #iscsigt
    #verify if iscsitgt is running (do not us it anymore)
    $r=`svcs | grep iscsitgt`;        $r=~s/ .*|\n//gs;
    if ($r eq "") {
      $t="0";
    } else {
      $t="1";
    }

    # Comstar
    #########
    $ant.="\n    comstar iscsi :  ";
    $r=`svcs | grep stmf`;        $r=~s/ .*|\n//gs;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    } else {
         if ($t) { $r.="<font style='color:#ff0000'>use either target or comstar mode, please disable old iscsitgr</font>"; }
    }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x stmf`;  $r.="</p>"; }
    $ant.=$r;

    # dlna mediatomb
    ############
    $ant.="\n    dlna mediatomb:  ";
    $r=`svcs | grep mediatomb`;          $r=~s/ .*|\n//gs;
    if ($r eq "") { $r="<font style='color:#e9a47a'>disabled</font>"; }
    $ant.=$r;

    # ftp
    #####
    $ant.="\n    ftp-server    :  ";
    $r=`svcs | grep proftpd`;          $r=~s/ .*|\n//gs;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    }  else {
         $r="ProFTPD $r";
    }
    $ant.=$r;

    #mysql
    ######
    $ant.="\n    mysql-server  :  ";
    $r=`svcs | grep mysql`;
    $r=~s/\n/\n                 /gs;
    $r=~s/ +.*//s;
    if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x mysql`;  $r.="</p>"; }
    $ant.=$r;

    # nfs
    #####
    $ant.="\n    nfs-server    :  ";
    $r=`svcs | grep nfs/server`;    $r=~s/ .*|\n//gs;
    $r=~s/\n/\n                 /gs;
    if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }

    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x nfs/server`;  $r.="</p>"; }
    $ant.=$r;

    #rsync
    ######
    $ant.="\n    rsync-server  :  ";
    $r=`svcs | grep rsyncd`;          $r=~s/ .*|\n//gs;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    } else {
       `sudo chmod 755 /var/web-gui/data/tools/rsync/rsync`;
       $t=`/var/web-gui/data/tools/rsync/rsync --version`;                  # show version
       $t=~s/\n.*//s;
       $r.=" $t";
    }
    $ant.=$r;

    #smb
    ####
    $ant.="\n    smb-server    :  ";
    $r=`svcs | grep /smb/server`;
    $r=~s/\n/\n                 /gs;   $r=~s/ .*|\n//gs;
    if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x smb/server`;  $r.="</p>"; }

    $ant.=$r;

    # ssh
    #####
    $ant.="\n    ssh-server    :  ";
    $r=`svcs | grep ssh`;     $r=~s/ .*|\n//gs;
    if ($r eq "") {
        $r="<font style='color:#e9a47a'>disabled</font>";
    } else {
           $t=&read_file('/etc/ssh/sshd_config');
       if ($t=~/\nPermitRootLogin +yes/is) { $r.=" - PermitRootLogin yes"; } else { $r.=" - PermitRootLogin no"; }
    }
    $ant.="$r";

    #tftpd-hpa
    $ant.="\n    tftp-server   :  ";
    $r=`ps axw | grep in.tftpd | grep -v grep`;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    } else {
         $r=~s/.*in.tftpd/tftpd-hpa/;
         $r="online $r";
    }
    $ant.="$r";


    #firewall
    #########
    $ant.="<br>\n    ipf firewall  :  ";
    $r=`svcs | grep network/ipfilter`;     $r=~s/ .*|\n//gs;
    $r=~s/online/enabled/;
    if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }
    $ant.="$r";


    #autostart/ Bonjour
    if (-f "/var/web-gui/_log/bonjour.sh") {
      $r=`cat /var/web-gui/_log/bonjour.sh`;
      $r=~s/\s+//gs;
      if ($r ne "") {
            $ant.="\n    Bonjour/auto :  Service-Bonjour loaded";
      }
    }

    print "\n$ant\n\n\n";


    print "\n<b style='background-color:#dddddd'>Pool overview:</b>";
    print &exe("zpool status",'','oslib 326');
    print "</pre>\n";


    # move oldkeys from /var/web-gui/data/napp-it/_log/appliance.log to /var/web-gui/data/napp-it/_log/appliance.oldkey
    my (@new,@old,@bak,$date,$diff);


}

# end of file
1;
