  #!/usr/bin/perl
  # task to update disk getvalues from agents
  # par ex get-smart.pl

  ############################
  ## (c) Gnther Alka  2010-2014  

    # howto:
    # script is called every 45s from agents during sessions (session-age max 60s)

  #socketagent
       use strict;
       use vars qw(%disk %current %in %sys %zfs %txt %cfg @pools $i $cs $time $m $cm $tm $ctm $tmo $h $ch $ho $par %data @data $data $sec $min $hour $mday $mon $year $wday $ydat $isdst $t $f @t @m $m $r $d $count @v $v);

       use lib "/var/web-gui/data/napp-it/CGI";
       use Fcntl qw(:flock);                                                               # opt filelocking possible
       $|=1;

       my $print=0;     # 0/1 print all to console
       if (-f '/tmp/nappit/console.logall')    { $print="1"; }
       my $print2=0;     # 0/1 print main events to console
       if (-f '/tmp/nappit/console.logmain')  { $print2="1"; }

       # run only once
       $t=`ps axw | grep agent-get-diskvalues.pl`;
       @t=split(/\n/,$t);
       $f="1";
       foreach $t (@t) {
                if ($t=~/grep/) { next; }
                if ($t=~/agent-get-diskvalues.pl/) {
                     if ($f > 1) {
                       if (($print) || ($print2)) {  print "agent-get-diskvalues 29: cancel restart $time\n"; }
                       exit;
                     }
                     $f++;
                }
       }

      # if (($print) || ($print2)) {  print "agent-get-diskvalues 37: run $time\n"; }

       #base lib
       $t="/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";
       require "$t";

       my $par=$ARGV[0];
       my ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst);
       my ($poolstate,$capvalues,$capstate,$cpuvalue,$cpustate,$netstate,$maxbusy,$maxwait,$diskstate,$jobstate,$jobvalues,$netv_in,$netv_out);

       # preload other libs
       my $time=time();

       $t="/var/web-gui/data/napp-it/zfsos/_lib/get-disk.pl";
       if (($print) || ($print2)) {  print "agent-get-diskvalues 42: disk $time\n"; }
       require "$t";

       $t="/var/web-gui/data/napp-it/zfsos/_lib/get-disk-smart.pl";
       if (($print) || ($print2)) {  print "agent-get-diskvalues 46: smart $time\n"; }
       require "$t";

       $t="/var/web-gui/data/napp-it/zfsos/_lib/get-disk-sas2.pl";
       if (($print) || ($print2)) {  print "agent-get-diskvalues 50: sas2 $time\n"; }
       require "$t";
       sleep(10);         # block 30s
       exit;


##
1;
