#!/usr/bin/perl
#
# check joberrors
#


###############################
# part 1 - same for all reports
###############################

use strict;
use vars qw(%zfs %sys @t @par $t $f %r $os $id $alertlist $alertlistf $alertlog $statlog $alertsend $statsend $alertmess $info $alert $message $text $subject $binpath $lpath $spath);

use Fcntl qw(:flock); # filelocking
$|=1;                 # keine Pufferung, no buffering

require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";

#process report and return results
require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/report/report.lib";                                          # load my_report, set message, text and alertmess

print "alertlist_begin=$alertlist"."alertlist_end\nmessage_begin=$message"."message_end\nalert_begin=$alertmess"."alert_end\nstatus_begin=$text"."status_end\n";   # end


###################
# end common part 1
###################


###########################
# part 2, modify per report

###############   executed via require report.lib
sub my_report {
###############
        my ($jid,$j,$tmp,$w);
        # Job status error?

        # if Alert enabled and alert: print alertlog
        # if Status enabled: print statlog

        # Job error ##########
        my $host=&exe("hostname");

        #jobinfos id.par
        $w="/var/web-gui/_log/jobs/";
        @t=();
        &read_dir($w,'t');

        $alertlist="";
        foreach my $t (@t) {

            # check in id.par if status=active
            if (!($t=~/\.par$/))      { next; }

            $jid=$t; $jid=~s/\..*//; chomp($id);                       # jobid

            # check if status=active
            $j=`cat $w$t`;
            if (!($j=~/status=active/s))  { next; }                    # job is not active

            # check laststate
            if (!(-f "$w$jid\.log"))       { next; }                   # no log
            $j=`cat $w$jid\.log`;

            #check if log starts with error
            if ($j=~/^error/) {
               $j=~s/\n.*//s;
               $tmp.="Active Job $jid error:\n$j\n\n";                 # log error fo email
               $alertlist.="$jid,";                                    # log multiple errors per report
            }
        }
        $alertlist=~s/,+$//;

        if ($tmp ne "") {
             $subject.=" Job Alert";
             $alert="1";
             $alertmess="---------\nJob Alert $host\n---------\n$tmp";
        } else {
             $subject="ok";
             $alert="0";
        }

        #Statmess
        $text="jobs.log\n";
        if (-f "/var/web-gui/_log/jobs/jobs.log") {
           $text.=`cat /var/web-gui/_log/jobs/jobs.log`;
        }


        # cli debug?
        # $alert="1"; $subject="test";

        return ($subject);          # use it ex for email subject
}

# eof
1;