#!/usr/bin/bash

# 05 aug 2020

########### init once at boot time
echo "perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/agents/agent-bootinit.pl"
perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/agents/agent-bootinit.pl &

# del /var/web-gui/_log/tmp/*.sh (initiated prior reboot)
rm /var/web-gui/_log/tmp/*.sh 2> /dev/null



########### functions
function monitor()
{
  # monitor process-files without .running and agent updates of get-xx.pl
  # echo "taskserver.sh 12: agent-monitor.pl started"

  # obsolete 8.12.16
  # nice /usr/bin/perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/agent-monitor.pl other >/dev/null 2>&1 &
  echo monitor
}

function requests()
{
  # task request via file /tmp/nappit/agent-xx_id.request -> ../script/agent-xx.pl
  FILES=/tmp/nappit/*.request
  for F in $FILES
  do
    if [ -f $F ]
    then
         # start task
         /usr/bin/perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/taskexec.pl $F >/dev/null 2>&1 &

         # delete request in taskexec
   fi
  done

  if [ -f /var/web-gui/_log/tmp/autolock.request ]
  then
        # start
           rm -f /var/web-gui/_log/tmp/autolock.request
           /usr/bin/perl /var/web-gui/data/scripts/agents/agent_autolock.pl >/dev/null 2>&1 &
  fi

  # check/run /var/web-gui/_log/tmp/*.sh (initiated prior reboot)
  DIR="/var/web-gui/_log/tmp/*.sh"
  for FILE in $DIR
  do
     if [ -f $FILE ]
     then
       sh < $FILE &
       echo "sh $FILE &"
       # next sleep required
       sleep 1
       cat $FILE && rm  $FILE
       echo ''
       # echo "$FILE" >> /var/web-gui/_log/remote.log # debug, ps for interactive test at console
       ps axw | grep repli-send | grep -v grep

     fi
  done
  sleep 1

  echo "----------------";
}


########### taskserver # requests every 1 sec##
while :
do

  requests
  #monitor      # optional

  #################
  # repeat endless
  ################

done
