#!"\xampp\perl\bin\perl.exe"

use strict;
use CGI::Carp qw (fatalsToBrowser);
use IO::Socket::INET;

# auto-flush on socket
$| = 1;

# Erhalte den ersten Parameter aus dem @ARGV-Array
my $par = shift @ARGV;

if ($par eq "") {
 print "Gib einen Befehl ein: client.pl 'meine Frage'\n";
 exit;
}

# Erstelle einen Socket, der mit dem Server auf Port 1234 verbindet
my $socket = IO::Socket::INET->new(
    PeerHost => 'localhost',
    PeerPort => '63000',
    Proto    => 'tcp',
) or die "Kann keine Verbindung herstellen: $!\n";


    # Lese eine Zeile von der Standardeingabe

    my $input = "$par";

    # sende sie an den Server
    $socket->syswrite($input);
    # Warte auf die Antwort vom Server
    my $output;
    $socket->sysread($output, 1024);
    # Gib die Antwort aus
    print "Antwort vom Server: $output";


# Schliee den Socket
$socket->close or die "close: $!";