use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my ($out, $var, $r, $ant, $prod);  # declare all your variables as local or you will get errors

  # header
  print "<script language='javascript'>document.getElementById('hl').innerHTML='Disk remove (Mirror, Cache, Log, Spare)'</script>\n";

  # menue actions
  ###############


  ###############################################
  # part 1: do function, if question is answered
  ##############################################

    if ($in{'answered'}) {      # question was answered
       &my_remove;       # do it
    }



  ##############################
  # or create a form to ask user
  ##############################

  &load_lib('get-disk.pl');   # get required values
  if (($disk{'all_cache'} eq "") && ($disk{'all_logs'} eq "") && ($disk{'all_mirror'} eq "") && ($disk{'all_replacing'} eq "") && ($disk{'all_spares'} eq "") && ($disk{'all_failed'} eq ""))  {
     print "removeabable disks: none";
  } else {


    if ($sys{'auto_os'} eq "Linux") {
       $var=&disklib_list('all_removeable','id,pool,vdev,state,MODEL,SIZE');
    } else {
       $var=&disklib_list('all_removeable','pool,vdev,state,vendor,product,partcap');
    }

#    &mess($var);

    &ask('begin');
    &ask('radio_remove','remove disk<br>(spare, cache, log or mirrormember)',$var);

    #part
    if (!(-f "/var/web-gui/_log/partitions.enabled")) {
      if ($disk{'all_dsk_with_part'} ne "") {
         $t=$disk{'all_dsk_with_part'}; $t=~s/\t/, /g;
         &ask('select_part',"add partition number<br></b>$t<b>",'-,p1,p2,p3,p4,p5,s0');
      }
    }

    &ask('value_pool','force poolname (needed with unavail disks)');
    &ask('confirm',$txt{'remove'},$txt{'proceed'});
  }

  print "<br><br><a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a>\n";
  print "<div class='info'><pre>$txt{'disk_remove_info'}</div><br></pre>";



  #status with disk cap and  model
    if ($cfg{'select_lang'}=~/my|app/i) {
         $prod="Product /Disks";
    } else {
         $prod="Product /napp-it";
    }
    if ($txt{'app_about_pools_product'} =~/\w+/) {
         $prod=$txt{'app_about_pools_product'};
    }
    $prod.=" " x16;
    $prod=substr($prod,0,16);


    $ant.=&exe("zpool status");
    my @l=split(/\n/,$ant);
    my ($s,$t,$k,$id);
    foreach my $l (@l) {
        $t=$l;
        $t=~s/^\s+//;

        if ($l=~/NAME/) { $l.="      CAP            $prod   IOstat mess"; }

        if ($t=~/^c\d|^wwn|^scsi|^ata|^sd|lofi/) {      # is disk Solaris or Linux
             $t=~s/\s.*//;     # id only
             $t=~s/s0$|p0$//;  # no slices

             $id=$t;

             $k="$id"."_partcap";
             $s=15-length($disk{$k});

             $l.="      $disk{$k}"." "x $s;
             $k="$id"."_product";
             $k=~s/p\d//;                        #disk not part
             $l.=$disk{$k};

             $l.="  ";
             $k="$id"."_error";
             $k=~s/p\d//;                        #iostat err

             @t=();
             $t=$disk{$k};
             $t=~s/.://g;
             @t=split(/ /,$t);
             $t=$disk{$k};
             #if ($t ne "") { &mess("-$t-"); }
             if (($t[1] > 9) || ($t[2] > 9))   {
               $t="<font style='color:blue; font-size: 11px'>  $t</font>";   # T:/H: values > 9
             }


             if ($l=~/lofi/) {
                  $k="$id";
                  $t="$disk{$k}";

                  $k="$id"."_options";
                  $t.="  $disk{$k}";
             }

             $l.=$t;

        }

    }
    $ant=join("\n",@l);


    print "<br><table style='width:100%'>\n";
    print "\t<tr>\n";
      print "<td class=\"td1_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<b>zpool status</b></td>";
    print "\t<tr>\n";

    print "\t<tr>\n";
      print "<td class=\"td2_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<pre>$ant</pre></td>";
    print "\t<tr>\n";

    print "</table>\n";


} #/ my_action



######################
sub my_remove {
#######################
   my $r;

  # use partition
  if ($in{'select_part'}=~/\d/) {
        $in{'radio_remove'}.="$in{'select_part'}";
  }

   my $t="$in{'radio_remove'}\_pool";
   my $pool=$disk{$t};   #get pool of disk

   # opt force pool
   $in{'value_pool'}=~s/\s//g;
   if ($in{'value_pool'} ne "") { $pool=$in{'value_pool'}; }

   $t="$in{'radio_remove'}\_vdev";
   my $vdev=$disk{$t};   #get pool of disk

   if (-f "/tmp/nappit/napp-it_disks.txt")  {
     &exe("rm /tmp/nappit/napp-it_disks.txt");      # re-read
   }

   if ($pool eq "") { &mess("Could not detect pool of $in{'radio_remove'}, please add Poolname manually"); }

  my $detach;
  #&mess($vdev);

  if (($vdev=~/mirror/) || ($disk{'all_failed'}=~/$in{'radio_remove'}/)) {  $detach="1"; }
  if ("cache,logs,spares"=~/$vdev/) {  $detach="0"; }

  # replacing -> detach
  if ($disk{'all_replacing'}=~/$in{'radio_remove'}/)                         {  $detach="1"; }

  #detach drive from mirror or detach failed
  if ($detach) {
     print "zpool detach \"$pool\" $in{'radio_remove'}<br>";
     $r=&exe("zpool detach \"$pool\" $in{'radio_remove'}");
     if ($r ne "") { print $r; sleep(2); }

  }  else {
     #remove hot spare or cache drive
     print "zpool remove \"$pool\" $in{'radio_remove'}<br>";
     $r=&exe("zpool remove \"$pool\" $in{'radio_remove'}");
     if ($r ne "") { print "$r"; sleep(2); }
  }

  if (-f "/tmp/acc-format.log") {  &exe("rm /tmp/acc-format.log"); }
  if (-f "/tmp/acc-parted.log") {  &exe("rm /tmp/acc-parted.log"); }
  if (-f "/tmp/acc-sas2.log")   {  &exe("rm /tmp/acc-sas2.log"); }
  if (-f "/tmp/poolstat.log")   {  &exe("rm /tmp/poolstat.log"); }

  $in{'l3'}="";

 sleep(1);
 reload;
}


###############################################
#end of my script, do not delete the line below
1;