###############
sub my_action {
###############

# Extension (c) napp-it.org  2011-2015
# 12.Jun 2015

    my ($out, $ant, @l, $l, @c, $c, $n, $t, $d, @w, $w, $k, $i, $sn, $u, $con, $enc, $slot, $prot, @l, $l, $m, @v);

###############################################################


#load
#&load_lib("get-disk-smart.pl");    # no longer needed
&load_lib("get-disk-sas2.pl");

if ($disk{'force_mpt_sas_detection'} eq "1") {
  $t="mpt_sas detection";
} else {
  $t="sasircu detection";
}
print "<script language='javascript'>document.getElementById('hl').innerHTML='Disk Location and SAS infos (pro feature) $current{'acc_mess'} $t'</script>\n";

#debug
#&print_hash(%disk);

#&print_hash(%disk);
# wwn in use
    print "\n<b>WWN Disks in use on SAS2/3 controller</b> (Enclosure:Controller:Slot to identify)\n";
    $r=&disklib_list('all_lsi_used','header,slot,identify,mdb_sas,mdb_t,sas_sn,proto,stat,state,pool,vdev,product,partcap,error,smart_overview2');               #list with new lines
    $r=&my_sort($r);

    #slot bold
    $t='<b>slot</b>'.'&nbsp;' x 10;
    $r=~s/slot/$t/;

    #long sn
    $t='&nbsp;' x 15;
    $r=~s/sas_sn/sas_sn$t/;

    #long pool
    $t='&nbsp;' x 10;
    $r=~s/pool/pool$t/;

    #long vdev
    $t='&nbsp;' x 10;
    $r=~s/vdev/vdev$t/;

    #long product
    $t='&nbsp;' x 15;
    $r=~s/product/product$t/;

    # bold last 4 wwn numbers
    @l=split(/\n/,$r);            # lines
    foreach my $l (@l) {
         if (!($l=~/c\d/))        { next; }
         @v=split(/\t/,$l);
         $v[1]=&wwn_bold($v[1]);
         $l=join("\t",@v);
    }
    $r=join("\n",@l);
    ## /bold

    $r=~s/FAULTED/<font style='color:red'>FAULTED<\/font>/gs;
    $r=~s/UNAVAIL/<font style='color:red'>UNAVAIL<\/font>/gs;
    $r=~s/REMOVED/<font style='color:red'>REMOVED<\/font>/igs;
    $r=~s/OFFLINE/<font style='color:red'>OFFLINE<\/font>/igs;
    print &list2table($r,'99%');

# wwn available
    print "\n<br><br><b>WWN Disks available on SAS2/3 controller</b> (Enclosure:Controller:Slot)\n";
    $r=&disklib_list('all_lsi_unused','header,slot,identify,mdb_sas,mdb_t,sas_sn,proto,stat,state,pool,vdev,product,partcap,error,smart_overview2');               #list with new lines
    $r=&my_sort($r);

    #slot bold
    $t='<b>slot</b>'.'&nbsp;' x 10;
    $r=~s/slot/$t/;

    #long sn
    $t='&nbsp;' x 15;
    $r=~s/sas_sn/sas_sn$t/;

    #long pool
    $t='&nbsp;' x 10;
    $r=~s/pool/pool$t/;

    #long vdev
    $t='&nbsp;' x 10;
    $r=~s/vdev/vdev$t/;

    #long product
    $t='&nbsp;' x 15;
    $r=~s/product/product$t/;

    # bold last 4 wwn numbers
    @l=split(/\n/,$r);            # lines
    foreach my $l (@l) {
         if (!($l=~/c\d/))        { next; }
         @v=split(/\t/,$l);
         $v[1]=&wwn_bold($v[1]);
         $l=join("\t",@v);
    }
    $r=join("\n",@l);
    ## /bold

    $r=~s/FAULTED/<font style='color:red'>FAULTED<\/font>/gs;
    $r=~s/UNAVAIL/<font style='color:red'>UNAVAIL<\/font>/gs;
    $r=~s/REMOVED/<font style='color:red'>REMOVED<\/font>/igs;
    $r=~s/OFFLINE/<font style='color:red'>OFFLINE<\/font>/igs;
    print &list2table($r,'99%');
    print "<br><br>";

#portbased disks
   if ($disk{'all_lsi'} eq "") { $disk{'all_nlsi'}=$disk{'all'}; }

    print "\n<b>Portbased disks in use:</b>\n";
    $r=&disklib_list('all_nlsi_used','header,ctrl:target,identify,mdb_sas,mdb_t,sn,stat,pool,vdev,product,partcap,error,smart_overview2');               #list with new lines
    $r=~s/FAULTED/<font style='color:red'>FAULTED<\/font>/gs;
    $r=~s/UNAVAIL/<font style='color:red'>UNAVAIL<\/font>/gs;
    $r=~s/REMOVED/<font style='color:red'>REMOVED<\/font>/igs;
    $r=~s/OFFLINE/<font style='color:red'>OFFLINE<\/font>/igs;
    #print &list2table($r,'99%,170px,170px,190px,90px,120px,90px,220px,100px');

    #long sn
    $t='&nbsp;' x 32;
    $r=~s/sn/sn$t/;

    print &list2table($r,'99%');

    print "\n<br><br><b>Portbased disks available:</b>\n";
    $r=&disklib_list('all_nlsi_unused','header,ctrl:target,identify,mdb_sas,mdb_t,sn,stat,pool,vdev,product,partcap,error,smart_overview2');               #list with new lines
    $r=~s/FAULTED/<font style='color:red'>FAULTED<\/font>/gs;
    $r=~s/UNAVAIL/<font style='color:red'>UNAVAIL<\/font>/gs;
    $r=~s/REMOVED/<font style='color:red'>REMOVED<\/font>/igs;
    $r=~s/OFFLINE/<font style='color:red'>OFFLINE<\/font>/igs;

    #long sn
    $t='&nbsp;' x 32;
    $r=~s/sn/sn$t/;

    print &list2table($r,'99%');


#&print_hash(%disk);
# controllerinfo

    # ATTO
    print "\n<br><br><b>Atto HBA Controller</b>\n";
    if (-f "/opt/atto/esas4hba/sbin/atdevinfo") {
      $r=`sudo /opt/atto/esas4hba/sbin/atdevinfo -l`;
      @t=split(/\n/,$r);
      $r="";
      foreach my $t (@t) {
         $t=~s/^ +//;
         if ($t=~/^\d/) {
              $t=~s/ /\t/;  # after nr
              $r.="$t\n";
         }
      }
      $r=~s/  +/\t/gs;
    } else {
      $r="none";
    }
    $t='&nbsp;'x30;
    $r="Index\tModel$t\tPCI Location\tNode Address\n$r";               #list
    print &list2table($r,'99%');


    ## LSI
    print "\n<br><br><b>LSI HBA Controller</b>\n";

    @c=();
    @c=split(/\t/,$disk{'lsi_hba_list'});

    $l="0";  # mpt
    $m="0";  # lsc

    # step 1: set nr
    foreach my $c (@c) {
         @t=();
         @t=split(/  +/,$c);             # nr,driver,producr, class

         # mpt
         if ($t[1]=~/^m/) {
               $t[0]=$m;
               $m++;
         }
         # lsc (Solaris)
         if ($t[1]=~/^l/) {
               $t[0]=$l;
               $l++;
         }
         $c=join("\t",@t);
    }

    #step 2, add driver to nr
    foreach my $c (@c) {
         @t=();
         @t=split(/\t/,$c);             # nr,driver,producr, class
         # mpt
         if ($t[1]=~/^m/) {
               $t[0]="m$t[0]";
         }
         # lsc (Solaris)
         if ($t[1]=~/^l/) {
              $t[0]="l$t[0]";
         }
         $c=join("\t",@t);
    }


    $r=join("\n",@c);

    $r="Index\tPort name\tChip Vendor ID\tMPT rev\tFirmware\tIOC\n$r";   #lit
    print &list2table($r,'99%');


# enclosure-info
    print "\n<br><b>Enclosure Information</b>\n";
    $r="Enclosure\tLogical ID\tNumslots\tStartslot\n";               #list with new lines
    for ($i=1;$i <= $disk{'enclosures'}; $i++) {
          $r.="$i\t";
          $w="enclosure$i\_Logical ID"; $r.="$disk{$w}\t\t\t";
          $w="enclosure$i\_Numslots";   $r.="$disk{$w}\t\t\t";
          $w="enclosure$i\_StartSlot";  $r.="$disk{$w}\t\t\t\n";
    }

    print &list2table($r,'99%');

  # opt show smart details
 if ($in{'list'}=~/show smart details/)  {
     $t=$in{'disk'};
     $t=~s/s0$|p0$//;
     $r="$t\_smart_dtype";
     if ($disk{$r} ne "") {             # has dtype
               $n="$t\_smart_model";
               print "<br><br><hr><b>Smart details of disk $t $disk{$n} </b><hr><pre>";
               $t.="s0";
               print &exe("/usr/sbin/smartctl -a -d $disk{$r} -T permissive /dev/rdsk/$t");
     }
 }



  print <<EoF;
  <br><br><br> <div class="info">
  zpool status
  </div>
EoF


  #status with disk cap and  model
    $ant.=&exe("zpool status");
    my @l=split(/\n/,$ant);
    my ($s,$t,$k);
    foreach my $l (@l) {
        $t=$l;
        $t=~s/^\s+//;

        if ($l=~/NAME/) { $l.="     SLOT           CAP            MODELL";}

        if ($t=~/^c\d/) {      # is disk
             $t=~s/\s.*//;     # id only
             $t=~s/s0$|p0$//;  # no slices

             #slot
             $k=$t."_sas2_slot";
             $s=10-length($disk{$k});
             $l.="     $disk{$k}"." " x $s;

             $k="$t"."_partcap";
             $s=15-length($disk{$k});

             $l.="     $disk{$k}"." "x $s;
             $k="$t"."_product";
             $k=~s/p\d//;            # disk not part
             $l.=$disk{$k};
        }
    }

    $ant=join("\n",@l);

    print "<br><b>zpool status:</b><br>";
    print "<table style='width:100%'>\n";
    print "\t<tr>\n";
      print "<td class=\"td1_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<b>Pool</b></td>";
    print "\t<tr>\n";

    print "\t<tr>\n";
      print "<td class=\"td2_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<pre>$ant</pre></td>";
    print "\t<tr>\n";

    print "</table>\n";
    print "<script language=\"javascript'>document.getElementById('hl').innerHTML='Monitor Extension $disk{'sasircu'} $current{'acc_mess'}\"</script>\n";


   #identidy via dd
   #opt delete dd
   &exe("pkill -f dd");     # always

   if ($in{'list'} eq "identify_dd") {
         &my_dd_blink;   # disk-sas2.lib, end with menu reload
         exit;
   }

   if ($in{'list'} eq "identify_slot") {
         &my_enc_blink;    # with reload afterwards
   }


} #/ my_action
##############


#############
sub my_sort {
#############       1 <> 2
my (@w,$w,$t,$n);
# sort on slots
  my $l=$_[0];
  # return ($l);

  my @l=split(/\n/,$l);
  $n=0;
  foreach $l (@l) {

           @w=();
           @w=split(/\t/,$l);

           # change slot and id
           $t=$w[0]; $w[0]=$w[1]; $w[1]=$t;

           # first line first
           if ($n==0) { $n++;  $w[0]=" $w[0]"; }


           $l=join("\t",@w);
  }

  @l=sort(@l);

  # remove slotinfo at the beginning used for sort
  foreach $l (@l) {
        $l=~s/^.*:=//;
  }

  $l=join("\n",@l);


  # debug
  # &print_array(@l);
  # print "<pre>$l"; exit;

    return ($l);
}


###############################################
#end of my script, do not delete the line below
1;
