###############
sub my_action {
###############

  #override with private functions?
  ##################################
  eval { &mylib_menue_pools_import };                   # create this function in a private mylib.pl to replace this action

  my ($var1, $ant, $free, $type, $d, $r);

  #require "C:/xampp/napp-it/data/napp-it/zfsos/_lib/windows/zfslib.pl";
  #require "C:/xampp/napp-it/data/napp-it/zfsos/_lib/windows/get-sys.pl";
  &gethash_sys_poolnames;

  # header
  print "<script language='javascript'>document.getElementById('hl').innerHTML='$txt{'pool_header'}'</script>\n";


# 1. edited
if ($in{'answered'}) { &my_import; }     # form -> create

# 2. get form
#########################

# form begin
  &ask('begin');

## name of pool
  $d=&zfslib_list_pools('ex,des');
  $r=$d;
  $r=~s/_.*//;  #name of first importable

  &ask('select_pool','importable pools',$d);                                  #show (importable) exported and destryoed pools
  &ask('value_name','import with poolname',$r);

  print "Options";                                 #options (use in case of problems)
  &ask('checkbox_ro','readonly','option -readonly');
  &ask('checkbox_m','without slog','option -m');
  &ask('checkbox_N','without mount','option -N');
  &ask('checkbox_R','mount as /pool','option -R');

  print " <font style='color:red'>$txt{'form_damaged'}</font>";
  &ask('checkbox_F','try a former pool state on problems','option -F');            # import former state?

  print " <font style='color:red'>Requires a system checkpoint</font>";
  &ask('checkbox_CP','restore a system checkpoint','option --rewind-to-checkpoint');            # import former state?

  #
  if ($sys{'auto_os'} eq "Linux") {
      &ask('checkbox_by_id','Import using disk_by_id','option -by_id');
  }

  &ask('confirm','import',$txt{'form_confirm'});


print "<br>detected pools:\n";
print &list2table(&zfslib_list_pools('all,header,state,status'));


 print "<br>$txt{'import_overview'}<br>";

 &log_add("zpool import 53# zpool import");
 $d=&socket("zpool import");  #importable pools
 &log_add("$d");

 if ($d eq "") { $r=" -$txt{'none'}-"; } else { $r="$d";}

 $r.="<br><br>$txt{'destroyed_overview'}<br>\n";

 &log_add("zpool import 61# zpool import -D");
 $d=&socket("zpool import -D");
 &log_add("$d");


 if ($d eq "") { $r.=" -$txt{'none'}-"; } else { $r.="$d";}
 print "$r</pre>";



} #/ my_action
################



##############################################################################
sub my_import {
################
   my ($r,$i,@w,$n,$type,$what,$pool,$d,$ro,$m,$N,$R,$CP);

   # name of pool-> select_pool

   #action
   #######
   # zpool import name
   ####

   if ( $in{'select_pool'} eq "")   { &mess("there is no pool!"); }


   #strict
   $in{'value_name'}=~s/[^a-zA-Z0-9_\.\-:]//g;            # allowed in name

   $in{'value_name'}=~s/^ +| +$//g;
   if ( $in{'value_name'} eq "")   { &mess("choose a name for imported pool!"); }
   if ( $zfs{'allpools'}=~/\b$in{'value_name'}\b/ ) { &mess("a pool, named $in{'value_name'} already exist, choose another name!"); }


   if ($in{'select_pool'}=~/_D/) {
       $i="-D ";
   }
   $in{'select_pool'}=~s/^.*_D*//;

   if ($in{'checkbox_ro'} ne "") {
       $ro=" -o readonly=on";
   } else { $ro=""; }

   if ($in{'checkbox_F'} ne "") {          # force import former working state of a damaged pool
     $ro=" -F $ro";
   }

   # only -R or -N
   if ($in{'checkbox_m'} ne "") {
       $m=" -m";
   } else { $m=""; }

   if ($in{'checkbox_R'} ne "") {
       $R=" -R /";
   } else {
       $R="";
       if ($in{'checkbox_N'} ne "") {
          $N=" -N";
        } else { $N=""; }
   }

   $CP="";
   if ($sys{'auto_os'} eq "Linux") {
    if ($in{'checkbox_by_id'} =~/id/) {
       $d="zpool import$ro$m$N$R -f -d /dev/disk/by-id/ $i\"$in{'select_pool'}\" \"$in{'value_name'}\"";        # use disc-by-id
    } else {
       $d="zpool import$ro$m$N$R -f  $i\"$in{'select_pool'}\" \"$in{'value_name'}\"";
    }

   } else {
       if ($in{'checkbox_CP'} ne "") {
         $CP=" --rewind-to-checkpoint";
       }
       $d="zpool import$CP$ro$m$N$R -f $i\"$in{'select_pool'}\" \"$in{'value_name'}\"";        # poolname can contain spaces
   }


   #&mess($d);
   $i=&socket($d);   # return stderr



   #something wrong but missing key?
   if (!($i=~/cannot load key/s)) {
      if ($i ne "") { print $i; sleep(2); }
   }

   $in{'l2'}="";
   &reload;
}





###############################################
#end of my script, do not delete the line below
1;