use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

 eval { &mylib_menue_help };                   # create this function in a private mylib.pl to replace this action

 my ($out, $var);  # declare all your variables as local or you will get errors
 print <<EoF;

 <script language='javascript'>\$('#hl').html("Auto/User-Lock")</script>
 <pre>
<b>ZFS Encryption as a ZFS property</b>
with a key per filesystem is a feature of Oracle Solaris and newest Open-ZFS

<b>User-Lock/Unlock via SMB and watched folders</b>
User-Lock is a Pro feature to allow a user to lock/unlock a filesystem without access
to the Storage administration software. For User-Lock, you must

- create an encrypted filesystem
- use a file or https based key (keysplit L or W)
- enable User-Lock in ZFS Filesystems >> Encryption

- start the autolock service in menu Services

This creates a ZFS filesystem "pool"/ UserEncryption with a subfolder per encrypted filesystem.
Enable SMB sharing for this filesystem with a wanted ACL setting for the share and a subfolders
per encrypted filesystems with userlock enabled.

Content of these subfolders
Folders:          =lock and =unlock
Controlfile:      =switcher.move
Statusfile:       service-state.xx_yy (xx=service state, yy=lockstate) ex service-state.online_locked

Unlock with userlock=yes: 
To unlock a filesystem: move the file =switcher.move to the folder =unlock
To lock a filesystem: move the file =switcher.move to the folder =lock


Unlock with userlock=smbkey:
The mechanism is the same but the controlfile =switcher.move must contain the smbkey (from ZFS filesystems > Encryption).
Copy the controlfile "=switcher.move" to your local compizer ex to the desktop, open and insert the smbkey.
Copy this file to the =unlock folder to unlock the filesystem. For a filesystem lock the smbkey is not needed.


<b>Auto-Lock</b> (todo)
is a Pro feature to automatically lock/unlock a filesystem based on a timetable




 </pre>
EoF

}

#
1;