###############
sub my_action {
###############

  #override with private functions?
  ##################################
    eval { &mylib_menue_snaps };                   # create this function in a private mylib.pl to replace this action

    my ($var1, $var2, $ant,$l);

   print "If you want to protect snaps and the filesystem from a destroy you can hold them.<br>If you try to destroy, the command is skipped with a busy message<br><br>";

   print "<a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a><br>\n";
   print <<EoF;
<div class='info'><pre>
Holding a ZFS Snapshot
Holding a snapshot (zfs hold) prevents a snap from being destroyed. If a hold exists on a snapshot, you will not be able to destroy
it by using the zfs destroy command but get a snapshot is busy mesasage instead.
Remote replication of ZFS datasets can result in automatic snapshot policies on the two sides of a replication pair where a hold can protect them.

The snapshot hold information is identified through two properties:
 1. The defer_destroy property is on if the snapshot has been marked for deferred destruction by using the zfs destroy -d command.
    Otherwise, the property is off.

  2. The userrefs property is set to the number of holds on this snapshot, which is also referred to as the user-reference count.

Each snapshot has an associated user-reference count, which is initialized to zero. This count increases by one whenever there is a hold
on the snapshot and decreases by one whenever the hold is released. As discussed, a snapshot can be destroyed only if it has no clones.
In the Oracle Solaris 11 release, the snapshot must also have a zero user-reference count before it can be destroyed.

</pre></div>
EoF

 #del selected
    $in{'sel_snaps'}=~s/\.\+$//;
    if (($in{'answered'}) && ($in{'sel_snaps'} ne "")) { &del_myselected; }                     # del selected snaps
    if (($in{'answered'}) && ($in{'submit_ok'} eq "hold selected")) { $in{'answered'}="";  }  # none selected


 print "<br>";
    &load_lib("get-zfs.pl");             # load zfs{'all_clones'} to identify snaps that ar base of a clone
    &zfslib_list_datasnaps('R');


# header
   print "<script language='javascript'>\$('#hl').html('Hold/protect snaps')</script>\n";


} #/ my_action
##############

#############
sub del_myselected {
############
#debug
   #&print_hash(%in);

    my @snaps=split(/\.\+/,$in{'sel_snaps'});
    print "<br>";
    foreach my $s (@snaps) {
            if (!($s=~/\@/)) { next; }
            $r=&exe("zfs hold -r keep \"$s\""); chomp($r);
            print "snap $s set to hold\: %r<br>";

            if ($in{'checkbox_defer'}=~/enable/) {
              $r=&exe("zfs destroy -d \"$s\""); chomp($r);  
              print "enable defer_destroy on snap $s\: $r<br>";
            }
    }

    if (-f "/tmp/acc-snap.log") {  &exe("rm /tmp/acc-snap.log"); }
    sleep(1);
    &reload;
}





###############################################
#end of my script, do not delete the line below
1;
