use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

                        my ($out, $var);  # declare all your variables as local or you will get errors

                         # header
                         print "<script language='javascript'>document.getElementById('hl').innerHTML='$txt{'jobs_header'}'</script>\n";

                        # declare later needed vars ($hour,..), used in auto.pl
                        use vars qw($date $hour $min $sec $src_ip);

                        ##################################################
                        # debug mode:
                        # create file /tmp/debug
                        # stop execution via
                        # print('message');  exit;  # message is displayed
                        ##################################################

                        # menue actions
                        ###############


                        ###############################################
                        # part 1: do function, if question is answered
                        ##############################################

                        if ($in{'sel_job'} ne "") { $in{'submit_ok'}=""; }        # delete selected

                        if ($in{'submit_ok'} ne "") {      # submit
                            &write_job;       # do it
                        }



                        ##############################
                        # or create a form to ask user
                        ##############################

                        &grouplib_source_target;


} #/ my_action



################################################################################################
sub write_job {    # write job to joblist
################
  # call editpar from menu job create
  if ($in{'action'} eq 'editpar') { return; }        #

  my ($var,$id,$port,$host,$hostip,$source,$destination,$send_i,$transport,$port,$recursiv,$send_dedup,$send_opt,$pv_limit,$dest_sharename,$dest_shareguest,$dest_shareabe,$rec_opt,$daisy,$esxi);


  # 1. parse destination
   $in{'value_zfs_name'}=~s/\s//g;
    if ($in{'value_zfs_name'} eq '') {
        $in{'value_zfs_name'} = $in{'select_src_zfs'};
        $in{'value_zfs_name'}=~s/^.*\///;
    } else {
        $in{'value_zfs_name'}=~s/[^a-zA-Z0-9_\.\-:]//g;            # allowed in name
        if ($in{'value_zfs_name'} eq '') { &mess('ERROR: name of dataset; Please enter a valid name of dataset'); }
    }

    $destination="$in{'select_dest_zfs'}/$in{'value_zfs_name'}";


    my $r=&exe("zfs list -H -o name -t filesystem");
    my @w=split(/\n/,$r);
    foreach my $w (@w) {
            if ($w=~/^$zfs{'syspool'}\//) {
                 if ($w=~/$zfs{'syspool'}\/export/) { next; }        # dest rpool/ or user fs
            }
            $w=~s/\s.*//;
            if ($w eq "NAME") { next; }
            if ($w eq $destination) {
                 print "Destination Filesystem [$destination] exists<hr>If you do not want to manually continue a replication, you must delete or rename";
                 sleep (3);
            }
        }

  # 2. id of this job ########
    ############################
    if ($in{'value_force_id'} > 0) {
       $id=$in{'value_force_id'};
    } else {
       $id = time();
    }

    # port from id > 50000
    # $port=((($id / 60) % 55500) + 10000);
    $port=substr($id,-4,4);
    my $sum="";
    my @sum=split(//,$id);
    foreach my $char (@sum) { $sum=$sum+ord($char); }
    $port=$sum+50000+$port;


  # 3. parse input, needed host,hostip,source,destination,transport,port,recursiv,send_dedup,dest_sharename,dest_shareguest
  ################
    $host = $in{'autoselect_host'};     $host=~s/ .*//;  # name ip
    $hostip = $in{'autoselect_host'};   $hostip=~s/.* //;

    $source=$in{'select_src_zfs'};
    $send_i=$in{'select_send_i'};


    $transport="nc";  # default
    if ($in{'select_type'} =~/mbuffer/)  { $transport="mbuffer"; }
    if ($in{'select_type'} =~/ssh/)      { $transport="ssh"; }             # optional later

    if ($in{'checkbox_recursive'} ne "") { $recursiv="yes"; }              # rec
    if ($in{'checkbox_dedup'} ne "")     { $send_dedup="yes"; }            # dedup

    $dest_sharename=$in{'value_zfs_share'};                                # smb share destination as
    if ($in{'checkbox_guest'} ne "")     { $dest_shareguest="yes"; }       # guestok
    if ($in{'checkbox_abe'} ne "")       { $dest_shareabe="yes"; }         # share with ABE

    $send_opt=$in{'value_zfs_sendopt'};                                    # send options like '--raw' or '-w compress'
    $rec_opt=$in{'value_zfs_recopt'};                                      # receive options like '-u' (do not mount)

    $pv_limit=$in{'value_pv_limit'};                                       # limit throughput via pc ex '-L 300k'

    $daisy=$in{'value_zfs_daisy'};                                         # jobid
    $daisy=~s/\D//g;

    $esxi=$in{'value_esxi'};                                               # esxi server with nfs on this filesystem
    $esxi=~s/ +//g;

    # 4. needed variables for this job : host,hostip,source,destination,transport,port,recursiv,send_dedup,dest_sharename,dest_shareguest,status,keep
    ###################################

    $var ="job=replicate\n";
    $var.="host=$host\n";
    $var.="hostip=$hostip\n";
    $var.="source=$source\n";
    $var.="destination=$destination\n";
    $var.="transport=$transport\n";
    $var.="port=$port\n";
    $var.="recursiv=$recursiv\n";
    $var.="send_dedup=$send_dedup\n";
    $var.="send_option=$send_opt\n";
    $var.="rec_option=$rec_opt\n";
    $var.="pv_limit=$pv_limit\n";
    $var.="dest_sharename=$dest_sharename\n";
    $var.="dest_shareguest=$dest_shareguest\n";
    $var.="dest_shareabe=$dest_shareabe\n";
    $var.="esxi_ip=$esxi\n";                              # ip, this is a filesystem -> ESXi NFS
    $var.="send_i=$send_i\n";                             # -i or -I

    $var.="keep=$in{'value_keep'}\n";                     # keep snaps
    if ($in{'value_hold'}=~/s/) {
         $in{'value_hold'}=~s/\D//g;
         $in{'value_hold'}.="s";
    } else {
         $in{'value_hold'}=~s/\D//g
    }
    $var.="hold=$in{'value_hold'}\n";                     # hold snaps in days or with s for snaps


  # 5. create job.par with variables inside
  ###########################################

    $var.="month=$in{'select_month'}\n";
    $var.="day=$in{'select_day'}\n";
    $var.="hour=$in{'select_hour'}\n";
    $var.="min=$in{'select_min'}\n";
    $var.="status=$in{'select_status'}\n";
    $var.="daisy=$daisy\n";
    $var.="last=new\n";


 #debug
 #&mess("<pre>id=$id\n$var");

    my $f="/var/web-gui/_log/jobs/$id.par";     # jobfile
    open (F,">$f");
          print F "$var";
    close (F);


  # reload page
    $in{'l3'}="";
    &reload;
    exit;
} #/ write job
###############









###############################################
#end of my script, do not delete the line below
1;
