#use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

                        my ($out, $var);  # declare all your variables as local or you will get errors

                         # header
                         print "<script language='javascript'>document.getElementById('hl').innerHTML='$txt{'jobs_header'}'</script>\n";

                        # declare later needed vars ($hour,..), used in auto.pl
                        use vars qw($date $hour $min $sec $source_ip);

                        ##################################################
                        # debug mode:
                        # create file /tmp/debug
                        # stop execution via
                        # print('message');  exit;  # message is displayed
                        ##################################################

                        # menue actions
                        ###############


                        ###############################################
                        # part 1: do function, if question is answered
                        ##############################################

                        if ($in{'sel_job'} ne "") { $in{'submit_ok'}=""; }        # delete selected

                        if ($in{'submit_ok'} ne "") {      # submit
                            &write_job;       # do it
                        }



                        ##############################
                        # or create a form to ask user
                        ##############################

                        &my_ask;     # source target of sync


} #/ my_action



################################################################################################
sub write_job {    # write job to joblist
################

  # call editpar from menu job create
  if ($in{'action'} eq 'editpar') { return; }        #

  # 1. parse input
  ################

    $in{'value_action'}=~s/^ +//;
    $in{'value_action'}=~s/ +$//;

    if ($in{'value_action'} eq '') {
        &mess('enter your action!');
    }


    # 2. needed variables for this job :  pool=syspool \n keep=3 \n name=snapname, (predefined are id=sec from 1970),
    ###################################

    my $var="job=other\n";
    $var.="action=$in{'value_action'}\n";
    $var.="name=$in{'value_name'}\n";
    $var.="condition=$in{'select_type'}\n";
    $var.="noerr=$in{'value_noerr'}\n";
    $var.="err=$in{'value_err'}\n";

  # date
    $var.="month=$in{'select_month'}\n";
    $var.="day=$in{'select_day'}\n";
    $var.="hour=$in{'select_hour'}\n";
    $var.="min=$in{'select_min'}\n";
    $var.="status=$in{'select_status'}\n";
    $var.="last=new\n";
  ############################


  # 2. id of this job ########
  ############################
  my $id=time();


  # 3. create job.pre with variables inside
    my $f="/var/web-gui/_log/jobs/$id.par";     # jobfile
    open (F,">$f");
          print F "$var";
    close (F);

  # reload page
  $in{'l3'}="";
  reload;
    exit;
} #/ write job
###############



############### auto_job begin ######### do not remove or rename this line
sub auto_job {   # set needed variables as =variable= - they are stored via sub write_job when creating a job
##############

    # parameter from rewrite/create

    my $id           = "=id=";
    my $name         = "=name=";
    my $action       = "=action=";
    my $condition    = "=condition=";
    my $err          = "=err=";
    my $noerr        = "=noerr=";

    #run action
    my $r=`$action`;


    if ($condition eq "never")  { return(); }
    if ($condition eq "always") { return($r); }

    #condition
    my ($e,$n);
    if ($r=~/$err/s)   { $e="1"; }           # error found
    if ($r=~/$noerr/s) { $n="1"; }           # noerror found

    if ($err eq "")    { $e=""; }
    if ($noerr eq "")  { $n=""; }

    if ($n eq "1")     { return (); }        # is noerror
    if ($e eq "1")     { return ($r); }      # is error

    return();                                # noerror not found and error not found

} #/auto job





###########################
sub my_ask {   #  get job actions
###########################
    my (@source,@target,$s,$t,@g,$g,$r,@w,$w,$hostname,@h,$v);


        print "<div class='info'>$txt{'jobs_sync_info'}</div><br>";

        &ask('begin','b');
        print " <b style='background-color:#dddddd'>other Jobs:</b><br><br>";

        &ask('value_name','Name, ex set time via ntpdate',$in{'value_name'});

        print "<br> <b style='background-color:#dddddd'>Action:</b><br><br>";
        print "<b>example: ntpdate pool.ntp.org or sh /path/script.sh or init 5 for shutdown<br>or to remotely power up a backup server: perl /var/web-gui/_log/jobs/other_job_examples/remote_up_down_ipmi.pl</b>";
        &ask('value_action','CLI Command (runs as root)',$in{'value_action'});

        print "<br> <b style='background-color:#dddddd'>Errormanagement</b><br><br>";
        &ask('select_type','A return value is treated as error:','always,never,condition',$in{'select_type'});

        print "<br><b>Conditions (when you set both, both must be true):</b>";
        &ask('value_noerr','No-error if action returns',$in{'value_noerr'});
        &ask('value_err','Error only if action returns',$in{'value_err'});

        print "<br><br><b style='background-color:#dddddd'> Timetable</b><br><br>\n";


        &ask('select_month','Month (1..12)','every,every-2,every-3,every-4,every-6,1,2,3,4,5,6,7,8,9,10,11,12','every');
        &ask('select_day','Day (1..31 sun..sat)',',every,every-2,every-3,every-7,every-14,every/0,mon-fri,mon-sat,sat-sun,first-sat,first-sun,sun,mon,tue,wed,thu,fri,sat,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31','every');
        &ask('select_hour','Hour (0..23)','every,every-1BC,every-2,every-2BC,every-3BC,every-4,every-6,every-6BC,every-12,every/0,every/23;0;1,0,3,6,7,8,9,10,11,12,13,14,15,16,17,18,19,22,23,8;12;16,8;10;12;14;16;18,8;11;14;17;20,0;6;12;18','23');
        &ask('select_min','Minute',',every,every-5,every-15,every-20,every-30,every/0,15;45,0,15,30,45,once','0');

        &ask('select_status','Status','manual,active','active');

        print "<a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a>\n";
        print "<div class='info'>Info: 0-3-5 means 0, 3 and 5<br>every-2 (hour) means every two hours<br>every-1BC (hour) means every hour between 7-12 and 13-19 hour (ABCD, each 6 hours from 0..23)";
        print "<br>every month can be every, every-2";
        print "<br>every day can be every, every-2, every-3, every-7, every-14";
        print "<br>every hour can be  every, every-2, every-3, every-4, every-6, every-12, opt followed by ABCD - A=0..5, B=6..11, C=12..17, D=18..23";
        print "<br>every minute can be every, every-3, every-5, every-10, every-15, every-20, every-30";
        print "<br>minute=once means: execute job once after each reboot";

        print "</div><br><br>";

        &ask('end');    # create job , start it manually

}


###############################################
#end of my script, do not delete the line below
1;
