use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my ($out, $var, $color, @c);  # declare all your variables as local or you will get errors

   # header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='$txt{'jobs_header'}'</script>\n";

# monitorfile 1>>2>>3>>4>>5

if (!(-f '/var/web-gui/_log/monitor.log')) { &exe('touch /var/web-gui/_log/monitor.log'); &exe("chmod 666 /var/web-gui/_log/monitor.log"); }

my @l;
  open (F,"</var/web-gui/_log/monitor.log");
        flock(F, LOCK_EX);
        @l=<F>;
  close (F);

print "Job Monitor<br>";

print "<table border='1' style='width:100%'><tr>";
print "<td width='20%' style='border: 1px solid; padding:2px'><b>agent/ script</b></td>";
print "<td width='20%' style='border: 1px solid; padding:2px'><b>task</b></td>";
print "<td width='20%' style='border: 1px solid; padding:2px'><b>details</b></td>";
print "<td width='20%' style='border: 1px solid; padding:2px'><b>ask remote</b></td>";
print "<td width='20%' style='border: 1px solid; padding:2px'><b>reply remote</b></td>";

foreach $t (@l) {

  @c=();         # colums
  @c=split(/\|/,$t);

  if ($c[0] eq "") { $c[0]="\"; }
  if ($c[1] eq "") { $c[1]="\"; }
  if ($c[2] eq "") { $c[2]="\"; }
  if ($c[3] eq "") { $c[3]="\"; }
  if ($c[4] eq "") { $c[4]="\"; }

  # repli script && .. ||  ..
  if (($c[5] eq "") && ($c[6] ne "")) {
       $c[4].=" || $c[6]";
  } else {
       if ($c[5] ne "")  {
          $c[4].=" | $c[5]";
       }
  }

  #remote req ;; -> <br>
     $c[3]=~s/;;/<br>/g;
     $c[4]=~s/;;/<br>/g;

  # alert
  $c[4]=~s/timeout/<font style='color:red'>timeout<\/font>/s;

  $c[2]=~s/cannot/<font style='color:red'>cannot<\/font>/s;

  # separator ;;
  $c[4]=~s/;;/<br>/gs;
  $c[4]=~s/sudo //gs;        # shorten output
  $c[4]=~s/\/usr\/s?bin\///gs;

  $color="white";

  if ($c[0]=~/error/)                       { $color="#efd9cc"; }  # red
  if ($c[1]=~/start|\bend\b|finished/)      { $color="#ccd8ef"; }  # blue

  #if ($c[0]=~/agent-request|post-replication/) { $color="#e4efcc"; }  # green
  #if ($c[0]=~/agent-cancel/)                   { $color="#efd9cc"; }  # red
  #if ($c[0]=~/ccc/)                  { $color="#ccd8ef"; }  # blue
  #if ($c[0]=~/\*/)                             { $color="#ddc750"; }  # orange warning       ddc750
  #if ($c[0]=~/\*\*|cannot/)                    { $color="#f98383"; }  # red alert

  #shorten long logs
          $c[0]=substr($c[0],0,1000);
          $c[1]=substr($c[1],0,1000);
          $c[2]=substr($c[2],0,1000);

          $c[3]=substr($c[3],0,1000);
          if (length($c[3]) > 999)  {
             $c[3].=" ....";
          }
          $c[4]=substr($c[4],0,1000);
          if (length($c[4]) > 999)  {
             $c[4].=" ....";
          }


  print "<tr style=\"background-color:$color\">\n";

  print "<td width='20%' style='border: 1px dashed; padding:2px'>$c[0]</td>\n";
  print "<td width='20%' style='border: 1px dashed; padding:2px'>$c[1]</td>\n";

  #highlight col1
  if ($c[2]=~/start/) {
    print "<td width='20%' style='background-color:#ccd8ef; border: 1px dashed; padding:2px'>$c[2]</td>\n";      # blue receiver   start(ed)
  } else {
    print "<td width='20%' style='border: 1px dashed; padding:2px'>$c[2]</td>\n";
  }


  ## colspan if 3 ="" and 4 ne ""
  if (($c[3] eq "\") && ($c[4] ne "\")) {
      if ($c[4]=~/zfs receive/) {
           print "<td style='background-color:#ccd8ef; border: 1px dashed; padding:2px' colspan='2'>$c[4]</td>\n";
      } else {
           print "<td colspan='2' style='border: 1px dashed; padding:2px'>$c[4]</td>\n";
      }

  } else {
       ## colspan if 4 ="" and 3 ne ""
     if (($c[3] ne "\") && ($c[4] eq "\")) {
           print "<td colspan='2' style='border: 1px dashed; padding:2px'>$c[3]</td>\n";

     } else {

          ## pipe -> zfs receive
           if ($c[4]=~/zfs receive/) {
              print "<td style='background-color:#ccd8ef; padding:2px; border: 1px dashed' colspan='2'>$c[3] | $c[4]</td>\n";
           }  else {

                     if ($c[3]=~/zfs.send/) {
                       print "<td  colspan='2' style=\"background-color:#ccd8ef; padding:2px; border: 1px dashed\" width='20%'>$c[3] | $c[4]</td>\n";      # blue sender
                     } else {
                       print "<td width='20%' style='border: 1px dashed; padding:2px'>$c[3]</td>\n";
                       print "<td width='20%' style='border: 1px dashed; padding:2px'>$c[4]</td>\n";
                     }

          }
     }
  }

  print "</tr>\n";
}
print "</table>\n";
print "<br>In case of problems, check this monitor and activity log on sender and receiver side <br>";
if ($cfg{'select_lang'}=~/my|app/i) {
   print "Eventually start job manually as root from console via:  perl ./job-replicate.pl run_123 <br>";
} else {
   print "Eventually start job manually as root from console via:  perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/job-replicate.pl run_123 <br>";
}
print "(Replace 123 with your jobid). This may show additional console error and debugging messages";

} #/ my_action





###############################################
#end of my script, do not delete the line below
1;
