use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my ($out, $var);  # declare all your variables as local or you will get errors

   # header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='User menus'</script>\n";

print <<EoF;
<pre><b style="background-color:#dddddd">How to create Menues or Add-Ons</b>

If you want to extend napp-it with a special menue or a add-on

<b style="background-color:#dddddd">1. Create always private submenues (or opt. main-menue) by adding ' to the name !!!</b>

example:
create a level-2 submenue below apps named 01_mediaserver'
create level-3 submenues below 01_mediaserver example:
  - 01_about'    ( include a short description with your name and email )
  - 02_help'     ( infopage or link)
  - 03_setup'
  - 04_settings'

if you need common functions for your actions, create a
private function-library in your private level2-folder ex
in your 01_media -folder named mymedialib.pl

begin all names of included functions with libname ex
  sub mymedialib_list      { .. }
  sub mymedialib_setup     { .. }
  sub mymedialib_setup_mp3 { .. }

  if you use a function now, the corresponding lib is autoloaded


<b style="background-color:#dddddd">2. If you have created a menue to modify system-settings (no extra software is needed)</b>
  create a zipped folder with your private submenue below _my ex _my/sunos/21_apps and add-ons/01_mediaserver/..
  i will eventually publish these add-ons on napp-it.org for free downloading

  please add a textfile readme.txt with the following:

  1. Name and Version of the Add-On: (ex. Mediaserver Version 0.1c, Jan 2011)
  2. Tested on: (ex. NexentaCore3, OpenIndiana, Solaris Express)
  3. Features or Description
  3. miniHowto and Remarks
  4. Your Name and Email (for Bug-reports or suggestions)


<b style="background-color:#dddddd">3. If you have created a add-on that needs extra-software</b>

  add a perl-setup script ex mediaabc ( similar to my afp setupscript www.napp-it.org/afp )
  you can test your script locally by calling it via perl ./mediaabc
  if it works, include it in your zipped folder and add to your readme.txt

  5. Setupscript: Infos about your setup

  The setup-script should also work, when called online via wget (like my afp ar amp Add-Ons)

 <b style="background-color:#dddddd">4. send a mail with your attached zipped-folder together with the readme.txt</b>
 in the mailbody to community\@napp-it.org. i will eventually publish it on napp-it.org

</pre>
EoF


} #/ my_action






###############################################
#end of my script, do not delete the line below
1;