#!iblib.pl
# napp-it library for Infiniband
# 04.12.2014


# global settings
#url -> all sub
    $current{'ib_url'}="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;action==action=\&amp;zfs==zfs=\&amp;list==list=\&amp;link==link=\&amp;prop==prop=\&amp;old==old=\">=text=</a>";

# use testdata (1=use testdata)
#$current{'testdata'}="1";


###################
sub ask_ib_properties {
###################
    my ($ask,$form,$info,$t,$opt,$r,$ip,$m,$gw,@w,$w,$k);

    # answered?
    if ($in{'answered'}) { &change_ib_properties; exit; }

    # popwindow only one
    if($current{'ask_shown'} >1) {  return; }


    ################################
    # add partition and link (ibip menu)
    ################################
    if ($in{'prop'} =~/create_partition/) {

        # allow one plink on one link ex pFFF.ibp0 on ibp0
        # get list if "free" links
        # use ib_port_pkeys_ipb0=FFFF
        $t="";
        @w=();
        @w=split(/\t/,$current{'ib_links'});
        foreach my $w (@w) {
                if ($current{'ib_plinks'}=~/$w\b/) { next; }
                $t.="$w,";
        }
        $t=~s/,+$//;

        $form ="Create partition on/over &nbsp; ";
        if ($t eq "") { $t="-none-"; }
        $form.= &select('over',$t);
        $info="Create a partition and a interface<br><br>dladm create-part -f -l ibp0 -P 0xFFFF pFFFF.ibp0  with pkey from dladm show-ib<br>";
        $info.="ipadm create-if pFFFF.ibp0";
    }

    #################################
    # create ip interface/ addrobj (ibip menu)
    ################################
    if ($in{'prop'} =~/create_ip_interface/) {
        # allow one addrobj (interface) on one plink
        # plinks: $current{'plinks'}
        # interfaces: $current{'ib_ip_addrobj'}
        $t="";
        @w=();
        @w=split(/\t/,$current{'ib_plinks'});
        foreach my $w (@w) {
                if ($current{'ib_ip_addrobj'}=~/$w\b/) { next; }
                $t.="$w,";
        }
        $t=~s/,+$//;

        $form ="<table><tr><td>Create interface/ addrobj &nbsp; </td><td>";
        if ($t eq "") { $t="-none-"; }

        $form.= &select('over',$t);
        $form.=" / <input type='text' class='input' name='ident' value='v4' style='width: 30px'> (identifier like v4, v6, dhcp)";

        $form.="</td></tr><tr><td>";
        $form.="IP (dhcp or ip/netmask)</td><td><input type='text' class='input' name='ip' value='dhcp' style='width: 250px'></td></tr></table>";
        $info="cmd ex: <br>ipadm create-addr -T dhcp pFFF.ibp0/v4<br>ipadm create-addr -T static -a 192.168.1.3/24 pFFF.ibp0/v4";
    }


    ########################
    # how to set target_info
    ########################
    if ($in{'prop'} =~/set_target_info/) {
        $form="<br>You can set IB targets either in:<br><br>";
        $form.=" - menu zfs filesystems (fc/ib/iscsi) or <br>";
        $form.=" - menu comstar (optional) <br>";
        $info="";
    }

    # only one ask window
    $current{'ask_shown'}++;

    ### form ###
     $ask=&ask_pop("$form","$info","$opt");

#&mess($ask);

     return ($ask);

}




###################
sub change_ib_properties {
###################
   my ($r,$s,$t,$l,$a,@details,$opt,$ip,$m,$ipf,$par,$k,$ip,$mask,$ok);
   print "<br>$txt{'set_mess'}";    # please wait up to ...

   # stupid s11 thing
   ##################
        if ($sys{'auto_os_type'} eq "sol_s") {     # Solaris 11
                        $ipf="ip";                             # use ipadm create/delete-ip

                        #switch from automatic to manual configuration
                        &exe("netadm enable -p ncp DefaultFixed");
        } else {                                   # Illumos based, Solaris 11 Express
                        $ipf="if";                             # use ipadm create/delete-if
        }

   #parse prop  ex e1000g1:ip-adress
        $in{'prop'}=~s/[^a-zA-Z0-9\:\-\ ]//g;
        $opt=$in{'prop'};
        $opt=~s/ .*//;                 # ex e1000g1:1 LINK   -> e1000g1:1
        $opt=~tr/A-Z/a-z/;
        $opt=~s/[^a-z0-9\:]//g;        # option ex linkname



  ###################################
  # create ib partition and interface
  ###################################
    if ($in{'action'} eq "create_ip_interface") {

         if ($in{'over'}=~/^-/) { return; }

         #parse ident like v4
         $in{'ident'}=~s/[^a-zA-Z0-9]//;
         if ($in{'ident'} eq "") { &mess("please add an identifier like v4"); }

         # parse ip settings
         $in{'ip'}=~s/[^a-zA-Z0-9\/\.]//;
         if ($in{'ip'} eq "") { &mess("please set ip to dhcp or ip/netmask"); }

         # parse manual
         if ($in{'ip'} ne "dhcp") {
            ($ip,$mask)=split(/\//,$in{'ip'});

            #ip
            $ok="1";
            if ($ip=~/\d+\.\d+\.\d+\.\d+/)      {  $ok="0";  }        #v4
            if ($ip=~/\w+::\w+::\w+::\w+::\w+/) {  $ok="0";  }        #v6
            if ($ok)     { &mess("please set ip to ip/netmask, ex 192.168.1.1/24 or 192.168.1.1/255.255.255.0"); }              # simple test

            #mask
            $ok="1";
            if ($mask=~/\d+\.\d+\.\d+\.\d+/)    {  $ok="0";  $mask=&netmask2n($mask);  }        # 255.255.255.0 -> 24
            if ($mask=~/^\d\d$/)                {  $ok="0";   }        # /24
            if ($ok)     { &mess("please set netmask to ip/netmask, ex 192.168.1.1/24 or 192.168.1.1/255.255.255.0"); }
         }


         # create if
         if ($in{'ip'} eq "dhcp") {
                $t="ipadm create-addr -T dhcp $in{'over'}/$in{'ident'}";
         } else {
                $mask=

                $t="ipadm create-addr -T static -a $ip/$mask $in{'over'}/$in{'ident'}";
         }

         #debug
         # &mess($t);

         print "$t<br>";
         print &exe($t);
         sleep(3);
    }

  #####################
  # delete ip interface
  #####################
    if ($in{'action'} eq "dele_ip_interface") {

       # ipadm delete-$ipf pFFFF.ibp0
       # dladm delete-part pFFFF.ibp0

       #debug
       #&print_hash(%in);


       if (!($in{'old'}=~/ibp/)) { &mess("error: invalid partition $in{'old'}");  }

       $t="/usr/sbin/ipadm delete-$ipf $in{'old'}";

       # debug
       # &mess($t);

       print "$t<br>";
       print `sudo $t`;

       sleep(3);
  }

  ###################################
  # create ib partition and interface
  ###################################
    if ($in{'action'} eq "create_partition") {


       if ($in{'over'}=~/^-/) { return; }


       # get pkey of link
       # ib_port_pkeys_ibp3 -> FFFF
       $k="ib_port_pkeys_$in{'over'}";

       # command: dladm create-part -f -l ibp0 -P 0xFFFF pFFFF.ibp0  && ipadm create-if pFFFF.ibp0
       $k=$current{$k};        # ex: FFFF

       $t="/usr/sbin/dladm create-part -f -l $in{'over'} -P 0x$k p$k\.$in{'over'} && /usr/sbin/ipadm create-$ipf pFFFF\.$in{'over'}";

       # debug
       # &mess($t);

       print "$t<br>";
       print `sudo $t`;

       sleep(3);
  }

  #####################
  # delete if + ib partition
  #####################
    if ($in{'action'} eq "dele_partition") {

       # ipadm delete-$ipf pFFFF.ibp0
       # dladm delete-part pFFFF.ibp0

       #debug
       #&print_hash(%in);


       if (!($in{'old'}=~/ibp/)) { &mess("error: invalid partition $in{'old'}");  }

       $t="/usr/sbin/ipadm delete-$ipf $in{'old'} && /usr/sbin/dladm delete-part $in{'old'}";

       # debug
       # &mess($t);

       print "$t<br>";
       print `sudo $t`;

       sleep(3);
  }


  #&print_hash(%in);

  #############
  # xx
  #############
  if ($in{'action'} eq "xx") {

       if ($in{'over'}=~/^-/) { return; }
       $in{'vlan_id'}=~s/\D//g;
       if ( (!($in{'vlan_id'} > 0)) || ($in{'vlan_id'}>4096) ) { &mess('vlan id 1..4096 !'); }
       $in{'text'}=~s/\s//g;  if ($in{'text'} eq "")    { &mess('Linkname? '); }
       if (!($in{'text'}=~/\d$/))  { $in{'text'}.="0"; }
       $r=&exe("dladm create-vlan -f  -l $in{'over'} -v $in{'vlan_id'} $in{'text'}");
       if ($r eq "") { $r="ok"; }
       print "<br><br>dladm create-vlan -f -l $in{'over'} -v $in{'vlan_id'} $in{'text'}<hr>$r";
       sleep(4);
  }

  ######################
  #ok
  $in{'action'}="";
  &reload;

}


###################
sub show_ib_port_device {
###################
  my ($t,$r,$k,@p,@h,$h,$p,$url);

  $r=&exe('cfgadm -als "select=type(IB-PORT)"');
  $r=~s/  +/\t/gs;
  $r=&list2table($r);
  return("<b>IB Port device</b>$r");
}

###################
sub show_ib_vppa_device {
###################
  my ($t,$r,$k,@p,@h,$h,$p,$url);

  $r=&exe('cfgadm -als "select=type(IB-VPPA)"');
  $r=~s/  +/\t/gs;
  $r=&list2table($r);
  return("<b>IB VPPA device</b>$r");
}

###################
sub show_ib_kernel_clients {
###################
  my ($t,$r,$k,@p,@h,$h,$p,$out);

  @h=split(/\t/,$current{'ib_hca'});
  foreach my $h (@h) {
       $out.="<br><b>cfgadm -x list_clients hca:$h</b><br>";
       $r=&exe("cfgadm -x list_clients hca:$h");
       $r=~s/  +/\t/gs;
       $out.=$r=&list2table($r);
  }
  return("<b>IB HCA kernel clients</b><br>$out");
}

###################
sub show_ib_pseudo_devices {
###################
  my ($t,$r,$k,@p,@h,$h,$p,$url);

  $r=&exe('cfgadm -als "select=type()"');
  $r=~s/  +/\t/gs;
  $r=&list2table($r);
  return("<b>IB pseudo devices</b>$r");
}

###################
sub show_ib_ports {
###################
  my ($t,$r,$k,@p,@h,$h,$p,$url);

  # Port-GUID             ipib         srp
  # 1A4BFFFF0C629D        aktiv        aktiv
  # 1A4BFFFF0C629E        aktiv        aktiv

  @h=split(/\t/,$current{'ib_hca'});
  @h=sort(@h);

  $r="<b>HCA-GUID</b>    <b>Port-GUID</b>             <b>ibip (IPoIB services)</b>         <b>srp client service</b>   <b>srpt target service</b>\n";
  foreach my $h (@h) {

        # add ports
        @p=();
        $k="ib_hca_ports_$h";
        @p=split(/\t/,$current{$k});
        @p=sort(@p);

        foreach $p (@p) {

              # add HCA GUID
              $r.="$h   ";

              # add PORT
              $r.="$p   ";

              #add ipib condition:  ib_ibip_cond_1A4BFFFF0C629D=ok
              $k="ib_ibip_cond_$p";

              if ($current{$k} eq "") {
                $r.="na  ";
              } else {
                $r.="$current{$k}  ";
              }

              #add srp condition:  ib_srp_cond_1A4BFFFF0C629D=ok
              $k="ib_srp_cond_$p";
              if ($current{$k} eq "") {
                $r.="na  ";
              } else {
                $r.="$current{$k}  ";
              }

              #add srpt condition:  ib_srpt_cond_1A4BFFFF0C629D=ok
              $k="ib_srpt_cond_$p";
              if ($current{$k} eq "") {
                $r.="na  ";
              } else {
                $r.="$current{$k}  ";
              }

              #
              $r.="\n";
        }
  }

  if (@p eq "0") {
    $r.="none";
  }

  $r=~s/  +/\t/gs;
  $r=&list2table($r);

  # ask property
  if ($in{'action'} =~/_/) {                          #change_setting
      if (($in{'prop'}=~/_/) && ($in{'answered'} ne "1")) { $r.= &ask_ib_properties; }
  }

  return("<b>IB HCA and Port settings</b>$r");
}


###################
sub show_ib_hca {
###################
 my ($t,$r,@w,$k,$url);

  if ($current{'ib_devices'} eq "")      {
      $t.="none";
  } else {
     @w=split(/\t/,$current{'ib_devices'});
     foreach my $w (@w) {
          $t.="$w\n";

     }
     $t=~s/  +/\t/gs;
     $t=&list2table($t);
   }
    return("<b>IB devices</b>\n$t");

}



###################
sub show_ib_partlinks {
###################
  my ($t,$r,@w,$k,$url);
  # IB Partition Links        dladm show-part         IB partition data links can be created on top of IB physical links, one per each P_Key on the port. The partition data links are used for data transfers.

  # Link           P_Key       Over        State        Flags       delete IB Partition Links
  # pFFFF.ibp0     FFFF        ibp0        unknown      f---        dladm delete-part pFFFF.ibp0

  # add IB Partition Link        dladm create-part -f -l ibp0 -P 0xFFFF pFFFF.ibp0                                                                                        The force option (-f) allows you to create an IB partition link even when the P_Key is not present or the port is down.

  my ($t,$r,@w,$k,$url);

  if ($in{'answered'}) {
     &change_ib_properties;
  }

  if ($in{'action'} eq "dele_partition") {
     &change_ib_properties;
  }

  # headline
  $t="<b>IF PART LINK</b>  <b>P_KEY</b>  <b>OVER</b>   <b>PART STATE</b>  <b>FLAGS</b>     <b>IF-STATE</b>  <b>IF-CURRENT</b>  <b>IF-PERSISTENT</b>  <b>ACTION</b>\n";


  # add delete:  dladm delete-part pFFFF.ibp0
  @w=split(/\t/,$current{'ib_plinks'});                   # p8000.ibp0 p9000.ibp1
  if (@w ==0) {
       $t.="-none-";
  } else {
    foreach my $w (@w) {

       $w=~s/^\s+$//;
       if ($w=~/^Link/) {  next; }

       # add plink
       $t.="$w   ";

       # add pkey
       $k="ib_port_pkey_$w";
       if ($current{$k} eq "") {
            $t.="-   ";
       } else {
            $t.="$current{$k}   ";
       }

       # add over
       $k="ib_port_pover_$w";
       if ($current{$k} eq "") {
            $t.="-  ";
       } else {
            $t.="$current{$k}  ";
       }

       # add p state
       $k="ib_port_pstate_$w";
       if ($current{$k} eq "") {
            $t.="-  ";
       } else {
            $t.="$current{$k}  ";
       }

       # add p flags
       $k="ib_port_pflags_$w";
       if ($current{$k} eq "") {
            $t.="-  ";
       } else {
            $t.="$current{$k}  ";
       }

       # add if state
       $k="ib_port_ifstate_$w";
       if ($current{$k} eq "") {
            $t.="-  ";
       } else {
            $t.="$current{$k}  ";
       }


       # add if current
       $k="ib_port_ifcurrent_$w";
       if ($current{$k} eq "") {
            $t.="-  ";
       } else {
            $t.="$current{$k}  ";
       }

       # add if persistent
       $k="ib_port_ifpersistent_$w";
       if ($current{$k} eq "") {
            $t.="-  ";
       } else {
            $t.="$current{$k}  ";
       }

       # add action
       $url=$current{'ib_url'};
       $url=~s/=text=/delete $w/;
       $url=~s/=old=/$w/g;         # name of part to del
       $url=~s/=action=|=prop=/dele_partition/g;
       $url=~s/=zfs=|=link=|=old=|=list=//g;
       $t.="$url\n";

    }
  }

   # add partition
         $url=$current{'ib_url'};
         $url=~s/=text=/++ create partition/;
         $url=~s/=action=|=prop=/create_partition/g;
         $url=~s/=zfs=|=link=|=old=|=list=//g;
         $t.="\n$url";

  $t=~s/  +/\t/gs;
  $t=&list2table($t);

   # ask property
  if ($in{'action'} =~/_/) {                          #change_setting
      if (($in{'prop'}=~/_/ ) && ($in{'answered'} ne "1")) { $t.= &ask_ib_properties; }
  }

  return("<b>IB partition links</b>\n$t");
}


###################
sub show_ib_iplinks {
###################
 my ($t,$r,@w,$k,$url);

 # IB physical data links        dladm show-phys |grep Infiniband        dladm show-ib                                                                                The physical links can be used as administrative and observability data points. Physical data links are not used for data transfers, so plumbing and assigning an IB address is not supported on these links.
 # Link  Device HCAGUID               PORTGUID           PORT       Media           State       Speed        Duplex
 # ibp0  ibp0  1A4BFFFF0C629C        1A4BFFFF0C629D        1        Infiniband        up        16000        unknown
 # ibp1  ibp1  1A4BFFFF0C629C        1A4BFFFF0C629E        2        Infiniband        down        2000        unknown
 # ibp2  ibp2  1A4BFFFF0CE10C        1A4BFFFF0CE10D        1        Infiniband        down        2000        unknown
 # ibp3  ibp3  1A4BFFFF0CE10C        1A4BFFFF0CE10E        2        Infiniband        down        2000        unknown


 # headline
 $t="<b>LINK</b>  <b>Device</b>  <b>HCAGUID</b>   <b>PORTGUID</b>  <b>PORT</b>      <b>Media</b>    <b>STATE</b>   <b>SPEED</b>  <b>Duplex</b>  <b>PKEYS</b>\n";

 if ($current{'ib_links'} eq "")      {
      $t.="none";
 } else {
     @w=split(/\t/,$current{'ib_links'});

     foreach my $w (@w) {

         # add link
         $t.="$w  ";

         # add device
         $t.="$w  ";

         # add HCA of link
         $k="ib_port_hca_$w";
         $t.="$current{$k}  ";

         # add Portguid of link
         $k="ib_port_guid_$w";
         $t.="$current{$k}  ";

         # add port
         $t.="-  ";

         # add media
         $t.="Infiniband  ";

         # add state of link
         $k="ib_port_state_$w";
         $t.="$current{$k}  ";

         # add speed of link
         $k="ib_port_speed_$w";
         if ($current{$k} eq "") {
            $t.="-  ";
         } else {
            $t.="$current{$k}  ";
         }

         # add duplex of link
         $k="ib_port_duplex_$w";
         if ($current{$k} eq "") {
            $t.="-  ";
         } else {
            $t.="$current{$k}  ";
         }


         # new line
         $t.="\n";
     }

 }

 $t=~s/  +/\t/gs;
 $t=&list2table($t);

 # ask property
  if ($in{'action'} =~/_/) {                          #change_setting
      if (($in{'prop'}=~/_/ ) && ($in{'answered'} ne "1")) { $r.= &ask_ib_properties; }
  }

 return("<b>ipib/IPoIB links</b>\n$t");
}

###################   addr-obj=ip devices on interfaces
sub show_ib_ipaddrobj {
###################
 my ($t,$r,@w,$k,$url,$if,$u);

# IPIB interfaces        ipadm show-if |grep ibp
# IFNAME        STATE (aus ipadm show-if)  CURRENT PERSISTENT  DHCP (vorerst nur statisch)        IP/NETMASK        ipib-MAC (aus ifconfig?)                               MTU (aus ifconfig?)  ADDR STATE (aus ipadm show-addr) OVER LINK   delete if
# pFFFF.ibp0        ok                      -      -           static        192.168.6.81        255.255.255.0        80:0:0:4c:fe:80:0:0:0:0:0:0:0:1a:4b:ff:ff:c:62:9d    65520                ok                               ibp0        dladm delete-part pFFFF.ibp0
# pFFFF.ibp1        down                    -           -        -        -
# add IPoIB interface        ipadm create-if pFFFF.ibp0


 if ($in{'answered'}) {
     &change_ib_properties;
 }


 # headline
 $t="<b>IP-IF/ ADDROBJ</b>  <b>IF LINK</b>   <b>ADDR STATE</b>   <b>DHCP</b>   <b>IP</b>   <b>NETMASK (CIDR)</b>  <b>MAC</b>    <b>MTU</b>   <b>ACTION</b>\n";

 if ($current{'ib_ip_addrobj'} eq "")      {
      $t.="none";
 } else {
     @w=split(/\t/,$current{'ib_ip_addrobj'});

     foreach my $w (@w) {

         # add link
         $t.="$w  ";


         # add interface
         $if="$w";
         $if=~s/\/.*//;
         $t.="$if  ";


         # if state
         $k="ib_port_obj_ipstate_$w";
         if ($current{$k} eq "") {
            $t.="-  ";
         } else {
            $t.="$current{$k}  ";
         }

         # add obj dhcp/static
         $k="ib_port_obj_iptype_$w";
         if ($current{$k} eq "") {
            $t.="-  ";
         } else {

            $t.="$current{$k}  ";
         }

         # add obj ip
         $k="ib_port_obj_ipaddr_$w";
         if ($current{$k} eq "") {
            $t.="-  ";
         } else {
            $t.="$current{$k}  ";
         }

         # add obj ip netmask
         $k="ib_port_obj_ipmask_$w";
         if ($current{$k} eq "") {
            $t.="-  ";
         } else {
            $t.="$current{$k}";
            $k="ib_port_obj_ipmask2_$w";
            $t.=" ($current{$k})  ";
         }

         # add mac   todo
         $k="ib_port_obj_mac_$w";
         if ($current{$k} eq "") {
            $t.="-  ";
         } else {
            $t.="$current{$k}  ";
         }

         # add mtu todo
         $k="ib_port_obj_mtu_$w";
         if ($current{$k} eq "") {
            $t.="-  ";
         } else {
            $t.="$current{$k}  ";
         }

         # add action: dele ip int
         $url=$current{'ib_url'};
         $url=~s/=text=/delete $w/;
         $url=~s/=action=|=prop=/dele_ip_interface /g;
         $url=~s/=zfs=|=link=|=old=|=list=//g;
         $t.="$url";

         # new line
         $t.="\n";
     }

 }

 # add addrobj
         $url=$current{'ib_url'};
         $url=~s/=text=/++ create interface/;
         $url=~s/=action=|=prop=/create_ip_interface/g;
         $url=~s/=zfs=|=link=|=old=|=list=//g;
         $t.="\n$url";

 $t=~s/  +/\t/gs;
 $t=&list2table($t);

 # ask property
  if ($in{'action'} =~/_/) {                          #change_setting
      if (($in{'prop'}=~/_/ ) && ($in{'answered'} ne "1")) { $t.= &ask_ib_properties; }
  }

 return("<b>ipib/IPoIB interfaces</b>\n$t");
}



###################
sub getpar_ib_services {
################### write values to %current
   my ($t,$r,@r,$i,$l,$cond,$k,@w,$w,$g,@l,$l);


   # 1. identify adapter name

        # prtconf -d | grep instance
        $r=<<EoF;
                    pci15b3,634a (pciex15b3,634a) [Mellanox Technologies MT25418 [ConnectX VPI PCIe 2.0 2.5GT/s - IB DDR / 10GigE]], instance #0
                ibport, instance #0
                ibport, instance #1
EoF

        # use testdata
        if ($current{'testdata'} ne "1") {
          $r=&exe("prtconf -d | grep instance");
        }

        @r=();
        @r=split(/\n/,$r);
        for ($i=0;$i<@r;$i++) {
               $r[$i]=~s/^ +//;    # remove leading spaces
               $l=$i-1;            # last line
               if (($r[$i]=~/ibport,/) && ($r[$l]=~/pci/)) {
                     $current{'ib_devices'}.="$r[$l]\t";        # use tab to divide entries
               }
        }
        $current{'ib_devices'}=~s/\t+$//;



   # 2. identify adapter IB-HCA, IB-PORT and Condition
   ###############################

         #
         # root@san:~# cfgadm -al
         $r=<<EoF;
         Ap_Id                          Type         Receptacle   Occupant     Condition

         hca:1A4BFFFF0C629C             IB-HCA       connected    configured   ok
         hca:1A4BFFFF0CE10C             IB-HCA       connected    configured   ok
         ib                             IB-Fabric    connected    configured   ok
         ib::1A4BFFFF0C629D,0,ipib      IB-PORT      connected    configured   ok
         ib::1A4BFFFF0C629D,0,srp       IB-PORT      connected    configured   ok
         ib::1A4BFFFF0C629E,0,ipib      IB-PORT      connected    configured   ok
         ib::1A4BFFFF0C629E,0,srp       IB-PORT      connected    configured   ok
         ib::1A4BFFFF0CE10D,0,ipib      IB-PORT      connected    configured   ok
         ib::1A4BFFFF0CE10D,0,srp       IB-PORT      connected    configured   ok
         ib::1A4BFFFF0CE10E,0,ipib      IB-PORT      connected    configured   ok
         ib::1A4BFFFF0CE10E,0,srp       IB-PORT      connected    configured   ok
EoF

         # -> $current{'ib_hca'}="1A4BFFFF0C629C tab .."

         # use testdata
         if ($current{'testdata'} ne "1") {
           $r=&exe("cfgadm -al | grep IB-");
         }

         @r=();
         @r=split(/\n/,$r);
         foreach my $t (@r) {

                 $t=~s/^ +//;                          # remove leading spaces

                 # HCA (Adapter)
                 if ($t=~/IB\-HCA/) {
                       $t=~s/ .*//;
                       $t=~s/^hca:+//;
                       $current{'ib_hca'}.="$t\t";     # use tab to divide entries
                       next;
                 }

                 if (!($t=~/IB\-PORT/)) { next; }      # only PORTs

                 # get PORT GUID
                 $g=$t;
                 $g=~s/^ib:+//;
                 $g=~s/,.*//;

                 # IB-Port ibip                        -> $current{'ib_ports_ipib'}=1A4BFFFF0C629D tab 1A4BFFFF0C629E"
                 if ($t=~/,ipib/) {
                       $w=$t;
                       $w=~s/ .*//;
                       $w=~s/^ib:+//;
                       $w=~s/,.*//;                    # keep id
                       $current{'ib_ports_ipib'}.="$w\t";

                       # condition
                       $k="ib_ibip_cond_$g";
                       $w=$t;
                       $w=~s/ +$//;
                       $w=~s/.* //;
                       $current{$k}=$w;             # ib_ibip_cond_1A4BFFFF0C629D=ok

                       # all ibports
                       if (!($current{'ib_ports'}=~/$g/)) {
                          $current{'ib_ports'}.="$g\t";
                       }
                 }

                 # IB-Port srp                        -> $current{'ib_ports_srp'}=1A4BFFFF0C629D tab 1A4BFFFF0C629E"
                 if ($t=~/,srp /) {
                       $w=$t;
                       $w=~s/ .*//;
                       $w=~s/^ib:+//;
                       $w=~s/,.*//;                    # keep id
                       $current{'ib_ports_srp'}.="$w\t";

                       # condition
                       $k="ib_srp_cond_$g";
                       $w=$t;
                       $w=~s/ +$//;
                       $w=~s/.* //;
                       $current{$k}=$w;                # ib_srp_cond_1A4BFFFF0C629D=ok

                       # all ibports
                       if (!($current{'ib_ports'}=~/$g/)) {
                          $current{'ib_ports'}.="$g\t";
                       }
                 }

                 # IB-Port srpt                        -> $current{'ib_ports_srpt'}=1A4BFFFF0C629D tab 1A4BFFFF0C629E"
                 if ($t=~/,srpt/) {
                       $w=$t;
                       $w=~s/ .*//;
                       $w=~s/^ib:+//;
                       $w=~s/,.*//;                    # keep id
                       $current{'ib_ports_srpt'}.="$w\t";

                       # condition
                       $k="ib_srpt_cond_$g";
                       $w=$t;
                       $w=~s/ +$//;
                       $w=~s/.* //;
                       $current{$k}=$w;                # ib_srtp_cond_1A4BFFFF0C629D=ok

                       # all ibports
                       if (!($current{'ib_ports'}=~/$g/)) {
                          $current{'ib_ports'}.="$g\t";
                       }
                 }

         }
         $current{'ib_hca'}=~s/\t+$//;                  # remove last tab
         $current{'ib_ports_ipib'}=~s/\t+$//;
         $current{'ib_ports_srp'}=~s/\t+$//;
         $current{'ib_ports'}=~s/\t+$//;

    # 3. Get PORT-GUIDs of a HCA


         # root@san-03:~# cfgadm -als "cols=ap_id:info" hca
         $r=<<EoF;
         Ap_Id                          Information
         hca:1A4BFFFF0C629C             VID: 0x15b3, PID: 0x634a, #ports: 0x2, port1 GUID: 0x1A4BFFFF0C629D, port2 GUID: 0x1A4BFFFF0C629E
         hca:1A4BFFFF0CE10C             VID: 0x15b3, PID: 0x634a, #ports: 0x2, port1 GUID: 0x1A4BFFFF0CE10D, port2 GUID: 0x1A4BFFFF0CE10E
EoF

         # use test data
         if ($current{'testdata'} ne "1") {
           $r=&exe('cfgadm -als "cols=ap_id:info" hca');
         }

         @l=();
         @l=split(/\n/,$r);
         foreach my $l (@l) {

                 $l=~s/^\s+//;            # no leading spaces
                 if (!($l=~/GUID:/))      {  next; }

                 # get hca GUID
                 $g=$l;
                 $g=~s/^hca:+//;
                 $g=~s/ .*//;

                 # get PORTS
                 @w=();
                 @w=$l;
                 @w=split(/GUID: /,$l);

                 foreach my $w (@w) {
                         if ($w=~/hca/)  { next; }
                         $w=~s/,.*//;                   # 0x1A4BFFFF0C629D, port2 '
                         $w=~s/0x//;
                         $k="ib_hca_ports_$g";
                         $current{$k}.="$w\t";
                 }
                 $current{$k}=~s/\t+$//;
         }
}


###################
sub getpar_ib_ipoib {
################### write values to %current
   my ($t,$r,@r,@w,$w,$k,$p);

   # root@san-03:~# dladm show-ib
   # example: ib status

   $r=<<EoF;
   LINK         HCAGUID         PORTGUID        PORT STATE  PKEYS
   ibp0         1A4BFFFF0C629C  1A4BFFFF0C629D  1    up     FFFF
   ibp1         1A4BFFFF0C629C  1A4BFFFF0C629E  2    down   FFFF
   ibp2         1A4BFFFF0CE10C  1A4BFFFF0CE10D  1    down   FFFF
   ibp3         1A4BFFFF0CE10C  1A4BFFFF0CE10E  2    down   FFFF
EoF


   # use sample data
   if ($current{'testdata'} ne "1") {
      $r=&exe("dladm show-ib");
   }

         @r=();
         @r=split(/\n/,$r);

         if (@r==0) { $current{'ib_links'}=''; }

         foreach my $t (@r) {
                $t=~s/^\s+//;                           # no leading spaces
                $t=~s/\s+/ /gs;                         # one space between values
                @w=();
                @w=split(/ /,$t);

                if ($w[0] eq "LINK")    {  next; }

                $k="ib_port_hca_$w[0]";                 # ib_port_hca_ipb0=1A4BFFFF0C629C
                $current{$k}=$w[1];

                $k="ib_port_guid_$w[0]";                # ib_port_guid_ipb0=1A4BFFFF0C629D
                $current{$k}=$w[2];

                $k="ib_port_port_$w[0]";               # ib_port_port_ipb0=1
                $current{$k}=$w[3];

                $k="ib_port_state_$w[0]";               # ib_port_state_ipb0=up
                $current{$k}=$w[4];

                $k="ib_port_pkeys_$w[0]";               # ib_port_pkeys_ipb0=FFFF
                $current{$k}=$w[5];

                $current{'ib_links'}.="$w[0]\t";
         }
         $current{'ib_links'}=~s/\t+$//;


   # dladm show-phys
        $r=<<EoF;
        LINK         MEDIA                STATE      SPEED  DUPLEX    DEVICE
        nge0         Ethernet             up         1000   full      nge0
        nge2         Ethernet             down       0      unknown   nge2
        ibp0         Infiniband           up         32000  unknown   ibp0
        ibp1         Infiniband           up         32000  unknown   ibp1
        nge3         Ethernet             down       0      unknown   nge3
        nge1         Ethernet             down       0      unknown   nge1
EoF

   #  use sample data
   if ($current{'testdata'} ne "1") {
      $r=&exe("dladm show-phys");
   }

         @r=();
         @r=split(/\n/,$r);
         foreach my $t (@r) {
                $t=~s/^\s+//;                           # no leading spaces
                $t=~s/\s+/ /gs;                         # one space between values
                @w=();
                @w=split(/ /,$t);

                # only Infiniband
                if ($w[1] ne "Infiniband")  { next; }

                $k="ib_port_state_$w[0]";                # ib_port_state_ipb0=up
                $current{$k}=$w[2];

                $k="ib_port_speed_$w[0]";                # ib_port_speed_ipb0=32000
                $current{$k}=$w[3];

                $k="ib_port_duplex_$w[0]";                # ib_port_duplex_ipb0=full
                $current{$k}=$w[4];

                $k="ib_port_device_$w[0]";               # ib_port_device_ipb0=ibp0
                $current{$k}=$w[5];

         }


        # dladm show-part
        $r=<<EoF;
        LINK           P_Key      OVER       STATE      FLAGS
        pFFFF.ibp0       FFFF      ibp0      unknown     ----
        pFFFF.ibp1       FFFF      ibp1      unknown     f---
        p8000.ibp2       8000      ibp2      unknown     f---
EoF
        #  use sample data
        if ($current{'testdata'} ne "1") {
           $r=&exe("dladm show-part");
        }

        @r=();
        @r=split(/\n/,$r);
        foreach my $t (@r) {
                $t=~s/^\s+//;                           # no leading spaces
                $t=~s/\s+/ /gs;                         # one space between values
                @w=();
                @w=split(/ /,$t);

                # only Infiniband
                if ($w[0] eq "LINK")      { next; }

                $current{'ib_plinks'}.="$w[0]\t";

                #port
                $p=$w[0];
                $p=~s/.*\.//;                           # phys link ex ibp0

                # partition.link
                $k="ib_port_plink_$p";                  # ib_port_plink_ipb0=p8000.ibp0
                $current{$k}=$w[0];

                $k="ib_port_pkey_$w[0]";                # ib_port_pkey_p8000.ipb0=8001
                $current{$k}=$w[1];

                $k="ib_port_pover_$w[0]";               # ib_port_pover_p8000.ipb0=ibp0
                $current{$k}=$w[2];

                $k="ib_port_pstate_$w[0]";              # ib_port_pastate_p8000.ipb0=unknown
                $current{$k}=$w[3];

                $k="ib_port_pflags_$w[0]";              # ib_port_pflags_p8000.ipb0=f---
                $current{$k}=$w[4];

         }
         $current{'ib_plinks'}=~s/\t+$//;


         # ipadm show-if | grep ibp
        $r=<<EoF;
        IFNAME       STATE    CURRENT      PERSISTENT
        pFFFF.ibp0   ok       -m-v------46  ---
        pFFFF.ibp1   ok       bm--------46  -46
EoF

        #  use sample data
        if ($current{'testdata'} ne "1") {
           $r=&exe("ipadm show-if | grep ibp");
        }

        @r=();
        @r=split(/\n/,$r);
        foreach my $t (@r) {
                $t=~s/^\s+//;                           # no leading spaces
                $t=~s/\s+/ /gs;                         # one space between values
                @w=();
                @w=split(/ /,$t);

                if ($w[0] eq "IFNAME")      { next; }

                $k="ib_port_ifstate_$w[0]";             # ib_port_ifstate_p8000.ipb0=ok
                $current{$k}=$w[1];

                $k="ib_port_ifcurrent_$w[0]";           # ib_port_ifcurrent_p8000.ipb0=bm--.-46
                $current{$k}=$w[2];

                $k="ib_port_ifpersistent_$w[0]";       # ib_port_ifpersistent_p8000.ipb0=bm--.-46
                $current{$k}=$w[3];
        }


        #add state
        # ipadm show-addr | grep ipb
        $r=<<EoF;
        ADDROBJ           TYPE     STATE        ADDR
        pFFFF.ibp0/v4     static   ok           172.16.1.22/16
        pFFFF.ibp1/v4     static   ok           172.17.1.22/16
EoF

         #  use sample data
        if ($current{'testdata'} ne "1") {
           $r=&exe("ipadm show-addr | grep ipb ");
        }

        @r=();
        @r=split(/\n/,$r);
        foreach my $t (@r) {
                $t=~s/^\s+//;                           # no leading spaces
                $t=~s/\s+/ /gs;                         # one space between values
                @w=();
                @w=split(/ /,$t);

                if ($w[0] eq "ADDROBJ")      { next; }


                $current{'ib_ip_addrobj'}.="$w[0]\t";

                $k="ib_port_obj_iptype_$w[0]";           # ib_port_obj_iptype_p8000.ipb0/v4=static
                $current{$k}=$w[1];

                $k="ib_port_obj_ipstate_$w[0]";           # ib_port_obj_ipstate_p8000.ipb0/v4=ok
                $current{$k}=$w[2];

                $k="ib_port_obj_fipaddr_$w[0]";           # ib_port_obj_ipaddr_p8000.ipb0/v4=172.17.1.22/16
                $current{$k}=$w[3];

                $k="ib_port_obj_ipaddr_$w[0]";           # ib_port_obj_ipaddr_p8000.ipb0/v4=172.17.1.22
                $current{$k}=$w[3];
                $current{$k}=~s/\/.*//;                  # remove netmask

                $k="ib_port_obj_ipmask_$w[0]";           # ib_port_obj_ipmask_p8000.ipb0/v4=255.255.255.0
                $current{$k}=&n2netmask($w[3]);          # -> 255.255.255.0

                $k="ib_port_obj_ipmask2_$w[0]";           # ib_port_obj_ipaddr_p8000.ipb0/v4=172.17.1.22/16
                $current{$k}=$w[3];
                $current{$k}=~s/.*\///;                  # remove ip - > 16
        }

        $current{'ib_ip_addrobj'}=~s/\t+$//;
}


#####################
sub getpar_ib_targets {
#####################
   my (@w,@r,$w,$r,$t,@t,$k);

   # srptadm list-target
        $r=<<EoF;
        Target HCA 1A4BFFFF0C629C:
            Enabled             : true
            SRP Target Name     : eui.001A4BFFFF0C629C
            Operational Status  : -

        Target HCA 1A4BFFFF0CE10C:
            Enabled             : true
            SRP Target Name     : eui.001A4BFFFF0CE10C
            Operational Status  : -
EoF

   # use sample data
   if ($current{'testdata'} ne "1") {
     $r=&exe("srptadm list-target");
   }

   #get on  Target per line

   $r=~s/\n/  /gs;
   @t=split(/Target HCA /,$r);

   # list is now like
   # [0] -> '        '
   # [1] -> '1A4BFFFF0C629C:                Enabled               : true             : SRP Target Name        eui.001A4BFFFF0C629C              Operational Status    : -            '
   # [2] -> '1A4BFFFF0CE10C:                Enabled               : true             : SRP Target Name        eui.001A4BFFFF0CE10C              Operational Status    : -

   if (@t==0) { return; }         # no data

   #debug
   # &print_array(@t);

   foreach my $t (@t) {
        if (!($t=~/:/))  { next; }
        $t=~s/: / /gs;
        $t=~s/  +/\t/gs;

        @w=();
        @w=split(/\t/,$t);

        # list example
        #[0] -> '1A4BFFFF0C629C'
        #[1] -> 'Enabled'
        #[2] -> 'true'
        #[3] -> 'SRP Target Name'
        #[4] -> 'eui.001A4BFFFF0C629C'
        #[5] -> 'Operational Status'
        #[6] -> '-'

         # ib_targets
        $current{'ib_targets'}.="$w[0]\t";

        # ib_target_enabled_1A4BFFFF0C629C
        $k="ib_target_enabled_".$w[0];
        $current{$k}=$w[1];

        # ib_target_name_1A4BFFFF0C629C
        $k="ib_target_name_".$w[0];
        $current{$k}=$w[4];

         # ib_target names
        $current{'ib_target_names'}.="$w[4]\t";

        # ib_target_status_1A4BFFFF0C629C
        $k="ib_target_status_".$w[0];
        $current{$k}=$w[6];

        # debug
        #&print_array(@w);

   }
   $current{'ib_targets'}=~s/\t+$//;
   $current{'ib_target_names'}=~s/\t+$//;
}

##########################
sub show_ib_targets {
##########################
   my ($h,@t,$t,$r,@r,$w,@w,$url,$tn);

   $r="<b>Target HCA</b>   <b>Enabled</b>   <b>SRP Target Name</b>   <b>Operational Status</b>   <b>Comstar Target</b>\n";

   # targets
   @t=split(/\t/,$current{'ib_targets'});
   if (@t==0) { $r.="none"; }
   foreach my $t (@t) {
            # hca
            $r.= "$t  ";

            # enabled?
            $k="ib_target_enabled_".$t;
            $r.="$current{$k}  ";

            # Target Name
            $k="ib_target_name_".$t;
            $r.="$current{$k}  ";
            $tn=$current{$k};

            # operational status?
            $k="ib_target_status_".$t;
            $r.= "$current{$k}  ";

            # comstar target
            $url=$current{'ib_url'};        # set begin of script
            $url=~s/=action=|=prop=/set_target_info/g;
            $url=~s/=list=|=link=|=old=//g;
            $url=~s/=text=/SRP-Target wizard/;  $url=~s/=zfs=/$tn/;
            $r.= "$url  ";

            $r.= "\n";
   }

  $r=~s/  +/\t/gs;
  $r=&list2table($r);


  # ask property
  if ($in{'action'} =~/set_target_/) {                          #change_setting
       $r.= &ask_ib_properties;
  }

  return ("<b>IB-SRP targets</b><br><br>$r");

}

##########################
sub show_ib_service_state {
##########################
 my ($t,$r,@w,$k,$url);

  my $t="<br><br><b>IB service state</b><br>";
  my $r=`echo | svcs  2>/dev/null`;
  $r=`sudo svcs '*ib*' 2>/dev/null`;


  my @w=split(/\n/,$r);
  $r="<b>STATE</b>  <b>STIME</b>  <b>FMRI</b> \n";
  foreach my $w (@w) {
      if ($w=~/^STATE/)     {  next; }
      $r.="$w\n";
  }

  $r=~s/ +/\t/gs;
  $r=&list2table($r);

  # ask property
  if ($in{'action'} =~/_/) {                          #change_setting
      if (($in{'prop'} ) && ($in{'answered'} ne "1")) { $r.= &ask_ib_properties; }
  }

  return ("$t$r");
}
#
1;
