#!/usr/bin/perl
## shebang needed only for tests !! calling only via at now not via cgi !!
## auto.pl  parameter opt jobid -> run now

## (c) Gnther Alka  2013

# this script is called from acllib to reset acl in background


#define global var and settings
       use strict;
       use vars qw($p $u $a $in $ad @fo $fi @fi $rec $i @p @w $par $os $auto_os $path $logpath $log $date_all $ydat $date_us $date_and_time $isdst $sec $min $hour $mday $mon $year $wday $dow $date $t $f @t %t @m %m $r %zfs %sys %cfg %current %disk %txt %in);

       $par=$ARGV[0];
       if (!(defined($par))) { print "15 missing parameter\n"; exit; }                  # parameter ex: aclreset_1366367452.txt
       if ($par=~/\/|\\/)    { print "16 path not allowed\n"; exit; }
       $par=~s/\.\./\./g;
       $par="/tmp/nappit/$par";                                                      # parameter ex: /tmp/nappit/aclreset_1366367452.txt
       if (!(-f "$par"))     { print "19 missing parameterfile\n"; exit; }

####### presets

use lib "/var/web-gui/data/napp-it/CGI";
use Fcntl qw(:flock);                                                               # filelocking
$|=1;                                                                               # keine Pufferung, no buffering

require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";                           # common used functions of napp-it
require "/var/web-gui/data/napp-it/zfsos/_lib/acllib.pl";

#read_ahfile(file,hash/arrayname,art,aufruf), art =h/b/+ (hash,array,beides, anfgen
 &read_ahfile($par,'in','h');

#debug or delete
#exit;
`rm $par`;

 # Illumos/ Solaris
     $current{'ls'}='/usr/bin/ls';
     $current{'chmod'}='/usr/bin/chmod';

#debug = print messages to console 0/1
$current{'debug'}="0";
if ($ARGV[1] eq "debug") {$current{'debug'}="1";  }                                # debug via console call


##################################################### go ###############################
&getmydate;

$path=$in{'path'};
$t="";
if ($in{'onfiles'})   { $t.=" onfiles"; }
if ($in{'onfolders'}) { $t.=" onfiles"; }
if ($in{'onfiles'})   { $t.=" onfolders"; }
if ($in{'recursiv'})  { $t.=" recursiv"; }

if ($in{'aclreset'} ne "")  {

        ####### reset is a backgroundtask, (>  maxtime of cgi)

        ### acl ##
        #recursiv to included folders
        if ($in{'recursiv'}) {
                &log_reset("read dirlist $path..\n");

                $r=`find \'$path\' -type d`;                  # find folders
                #&log_reset("$r\n");                          # debug only

                chomp($r);
                @fo=split(/\n/,$r);

                if ($current{'debug'}) { print $r; }

        } else {
                $fo[0]="$path";
                $fo[0]=~s/^ +|\'//g;                          # 'path' added
        }

        $r="";
        foreach $f (@fo) {                                    # folders
            if ($f=~/\/\./) { next; }                         # not on hidden folders

            $f=&fn2fn($f);
            $f="\'$f\'";

            ###########
            # onfolders
            ###########
            if ($in{'onfolders'} eq "1") {

                &log_reset("\nfolder: $f\n");
                ## current ##
                if ($in{'aclreset'}=~/current/) {                # use current folder settings

                     $r=`$current{'chmod'} A- $f`;          # remove old ACL

                     # ex  $r.= `$current{'chmod'} A1+everyone\@:modify_set:file_inherit/dir_inherit:allow $f`;
                     for ($i=0;$i<$current{'acl-count'};$i++) {
                        if ($i eq "0") { $t="A="; } else { $t="A$i+"; }
                        $u="acl$i"."-user2";                                     # Unix-user
                        $a="acl$i"."-acl";                                       # acl
                        $in="acl$i"."-inherit";                                  # file and dir inherit
                        $ad="acl$i"."-type";                                     # allow/deny

#print "$current{'chmod'} $t$current{$u}\:$current{$a}\:$current{$in}\:$current{$ad} $f\n";
                        $r.= `$current{'chmod'} $t$current{$u}\:$current{$a}\:$current{$in}\:$current{$ad} $f`;
                     }

                     &log_reset("set ACL to current Folder on $f\n");
                }

                ## perm on folder ##
                if ($in{'aclreset'}=~/^\d+/) {                # unix perm
                     $r=`$current{'chmod'} A- $f`;
                     $r=`$current{'chmod'} $in{'aclreset'} $f`;
                     &log_reset("set perm $in{'aclreset'} on $f\n$r\n");
                }

                #owner on folder
                if ($in{'aclreset'} eq "owner=root") {                               # owner=root
                     $r=`chown root:root $f`;
                     &log_reset("change owner to root:root on $f\n$r\n");
                }


                ### acl on folder  ##
                if ($in{'aclreset'} eq "remove") {
                      $r=`$current{'chmod'} A- $f`;
                      &log_reset("remove ACL on $f\n$r\n");
                }

                if ($in{'aclreset'} eq "modify") {
                     $r= `$current{'chmod'} A=user:root:full_set:file_inherit/dir_inherit:allow $f`;
                     $r.= `$current{'chmod'} A1+everyone\@:modify_set:file_inherit/dir_inherit:allow $f`;
                     &log_reset("modify ACL on $f $r\n");
                }

                if ($in{'aclreset'} eq "root") {
                     $r= `$current{'chmod'} A=user:root:full_set:file_inherit/dir_inherit:allow $f`;
                     &log_reset("modify ACL (root only) on $f $r\n");
                }

                if ($in{'aclreset'} eq "owner") {
                     $r= `$current{'chmod'} A=user:root:full_set:file_inherit/dir_inherit:allow $f`;
                     $r.= `$current{'chmod'} A1+owner\@:full_set:file_inherit/dir_inherit:allow $f`;
                     &log_reset("modify ACL (root + owner) on $f $r\n");
                }

                if ($in{'aclreset'} eq "owner+read") { # owner + read
                     $r= `$current{'chmod'} A=user:root:full_set:file_inherit/dir_inherit:allow $f`;
                     $r.= `$current{'chmod'} A1+owner\@:full_set:file_inherit/dir_inherit:allow $f`;
                     $r.= `$current{'chmod'} A2+everyone\@:read_set:file_inherit/dir_inherit:allow $f`;
                     &log_reset("modify ACL (root + owner +read) on $f $r\n");
                }
                if ($in{'aclreset'} eq "owner+readx") { # owner + read execute
                     $r= `$current{'chmod'} A=user:root:full_set:file_inherit/dir_inherit:allow $f`;
                     $r.= `$current{'chmod'} A1+owner\@:full_set:file_inherit/dir_inherit:allow $f`;
                     $r.= `$current{'chmod'} A2+everyone\@:r-x---a-R-c---:file_inherit/dir_inherit:allow $f`;
                     &log_reset("modify ACL (root + owner +read) on $f $r\n");
                }
            }

            #########
            # onfiles
            #########
            if ($in{'onfiles'} eq "1") {

                 @fi=();
                 $p=$f;                                        # current folder
                 $p=~s/^\'|\'$//g;                             # remask
                 $p=~s/\/$//;

                 $p=&fn2fn($p);                                # allow '

                 $r=`/usr/bin/ls -1AlU --time-style=full-iso \'$p\'`;

                 # debug only
                 #&log_reset("read files: ls -1AlU --time-style=full-iso \'$p\'\n$r\n\n");


                 # one line per file like
                 # 'total 270070'
                 # 'drwxrwxrwx+  2 root     root           2 2013-02-19 10:15:23.152443377 +0100 Neuer Ordner'
                 # '-rwxrwxrwx+  1 root     root           0 2013-02-19 09:29:11.134576933 +0100 b.txt'


                 @fi=split(/\n/,$r);                         # ", \n"  or ", " is delimiter
                 $r="";
                 foreach $fi (@fi) {

                          #debug
                          # &log_reset("debug: $fi\n");                       # only for debugging

                          chomp($fi);
                          if ($fi=~/^\./)       { next; }                   # not on hidden files
                          if ($fi=~/^d/)        { next; }                   # not on folders
                          if (!($fi=~/^\-/))    { next; }                   # not a file like total

                          $fi=~s/.*\d+ \+\d+ //;                            # keeps filename

                          $fi="$p/$fi";

                          $fi=&fn2fn($fi);                                  # allow ' in name
                          $fi="\'$fi\'";                                    # needed for chmod

                          #&log_reset("file: $fi\n");

                          ## current ##
                          if ($in{'aclreset'}=~/current/) {                 # use current folder settings
                                   $r=`$current{'chmod'} A- $fi`;           # remove old ACL

                                   # ex  $r= `$current{'chmod'} A=user:root:full_set:allow $fi`;
                                   for ($i=0;$i<$current{'acl-count'};$i++) {
                                                 if ($i eq "0") { $t="A="; } else { $t="A$i+"; }
                                                 $u="acl$i"."-user2";                                     # Unix-user
                                                 $a="acl$i"."-acl";                                       # acl
                                                 $ad="acl$i"."-type";                                     # allow/deny

#print "$current{'chmod'} $t$current{$u}\:$current{$a}\:$current{$ad} $fi\n";
                                                $r.= `$current{'chmod'} $t$current{$u}\:$current{$a}\:$current{$ad} $fi`;
                                   }

                                   &log_reset("set ACL to current Folder on $f\n");

                          }



                         #set perm on files
                         ## perm ##
                         if ($in{'aclreset'}=~/^\d+/) {                # unix perm
                                              $rec="";
                                              $r=`$current{'chmod'} $in{'aclreset'} $fi`;
                                              &log_reset("set perm $in{'aclreset'} on $fi <hr>$r\n");
                          }

                          #owner on files
                          if ($in{'aclreset'} eq "owner=root") {                               # owner=root
                                              $r=`chown root:root $fi`;
                                              &log_reset("change owner to root:root on file $fi <hr>$r\n");
                          }


                          ### remove acl on files ##
                          if ($in{'aclreset'} eq "remove") {
                                               $r=`$current{'chmod'} A- $fi`;
                                               &log_reset("remove ACL on file $fi $r\n");
                          }

                          if ($in{'aclreset'} eq "modify") {
                                              $r= `$current{'chmod'} A=user:root:full_set:allow $fi`;
                                              $r.= `$current{'chmod'} A1+everyone\@:modify_set:allow $fi`;
                                              &log_reset("modify ACL on file $fi $r\n");
                          }

                          if ($in{'aclreset'} eq "root") {
                                              $r= `$current{'chmod'} A=user:root:full_set:file_inherit/dir_inherit:allow $fi`;
                                              &log_reset("modify ACL (root only) on file $fi $r\n");
                          }

                          if ($in{'aclreset'} eq "owner") {
                                              $r= `$current{'chmod'} A=user:root:full_set:allow $fi`;
                                              $r.= `$current{'chmod'} A1+owner\@:full_set:allow $fi`;
                                              &log_reset("modify ACL (root + owner) on file $fi $r\n");
                          }

                          if ($in{'aclreset'} eq "owner+read") { # owner + read
                                              $r= `$current{'chmod'} A=user:root:full_set:allow $fi`;
                                              $r.= `$current{'chmod'} A1+owner\@:full_set:allow $fi`;
                                              $r.= `$current{'chmod'} A2+everyone\@:read_set:allow $fi`;
                                              &log_reset("modify ACL (root + owner +read) on file $fi $r\n");
                          }

                          if ($in{'aclreset'} eq "owner+readx") { # owner + read execute
                                              $r= `$current{'chmod'} A=user:root:full_set:allow $fi`;
                                              $r.= `$current{'chmod'} A1+owner\@:full_set:allow $fi`;
                                              $r.= `$current{'chmod'} A2+everyone\@:r-x---a-R-c---:allow $fi`;
                                              &log_reset("modify ACL (root + owner +read) on file $fi $r\n");
                          }

                 } #/for files
             } #/onfiles

        } # /onfolders
 }

 #ok
 &log_reset("\nfinished: $date_all\n");

 #kill current jobs
 if ($in{'acl_reset'} ne "") {
   $r=`ps axw | grep aclreset`;
   @t=split(/\n/,$r);
   foreach my $t (@t) {
      $t=~s/^ +//;
      chomp($t);
      if ($t=~/$in{'acl_reset'}/) {
         $t=~s/ .*//;
         &log_reset("kill -9 $t");
        `kill -9 $t >/dev/null 2>&1`;
      }
   }
 }

 exit;

 ###############
 sub log_reset {
 ###############

  my $l=$_[0];
  $l=~s/\n+$//s;
  $l.="\n";

  if ($current{'debug'}) { print "$l"; }

  #log
  my $log="/tmp/nappit/aclreset20.log";
  my (@data,$t);
  open (F,"<$log");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);

  #unshift   $l=ok/error
  unshift(@data,"$l");       # new value top

  if (@data > 20) {
             $t=@data-20;
             splice(@data,20,$t);                 # delete from 20+
  }

 $t=join("",@data);
 open (PF, ">$log");
    flock(PF, LOCK_EX);
    print PF "$t";
 close (PF);

 ################################
 # complete log
 $log="/tmp/nappit/aclreset.log";
 open (PF, ">>$log");
    flock(PF, LOCK_EX);
    print PF "$l";
 close (PF);

 }

 sub getmydate {                # setzt datumsvariablen
###########
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 $mon++;
 if ($sec < 10) { $sec = "0$sec"; }
 if ($min < 10) { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10) { $mon = "0$mon"; }
 $year=1900+$year;
 $date_all="$year\.$mon\.$mday\.$hour\.$min\.$sec";
}

###############################################
#end of my script, do not delete the line below
1;