# job functions for napp-it    Copyright (c) 2009 Gnther Alka

################################

#########
sub smartbenchlib {  #17.12.2010
###########################  user in disk-benchmark via bonnie
}

###############      ##############################################
sub smartbenchlib_smart_overview  {     #hide:
###############      #
                     #############################################
  print "todo";
  exit;
}

#############################################################
sub smartbenchlib_bench_iozone  {     #hide:
################
      my (@a,@w,$p,$i,$n,$f,@l,@b,$url,$myurl,$do);
      my $size=$_[1];     # ex 1g

      $url="<a href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;action=runbench\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;zfs==pool=\">start</a>";
      &log_end;

      if ($in{'action'} eq "runbench") {

             # not allowed if encrypred
             $t=&exe("/usr/sbin/zfs get encryption $in{'zfs'}");
             if ($t=~/\son\s/) {
                   $t=&exe("/usr/sbin/zfs get -H keystatus $in{'zfs'}");
                   $t=~s/^.*\skeystatus\s+//gs;
                   $t=~s/\s.*//s;
                   if ($t ne 'available') {
                     if ($t ne "bad") {
                        &mess('not allowed on locked pools');
                     }
                   }
              }


              $do=&exe("ps axw | grep iozone",'','smartbench 46');
              if ($do=~/iozone \-R/s) { &mess("there is a iozone-benchmark already running, please try again later"); }

              $do=&exe("rm /$in{'zfs'}/iozone.*");    # delete opt old files
              &exe("chmod 755 /var/web-gui/data/tools/iozone/iozone");

              # call iozone par
              # ex $var="/var/web-gui/data/tools/iozone/iozone -R -l 5 -u 5 -r 4k -s 100m -F /$in{'zfs'}/iozone.1 /$in{'zfs'}/iozone.2 /$in{'zfs'}/iozone.3 /$in{'zfs'}/iozone.4 /$in{'zfs'}/iozone.5 | tee  /$in{'zfs'}/iozone.log";
              $p=$_[0];
              $do=`echo "$p" | sudo at -s now`;
              sleep (1);
      }

      $r=&exe("zpool list -o name,size");

      my ($v1,$v2,$v3,$v4,$v5,$v6,$v7,$v8,$v9,$v10,$v11);

      @a=split(/\n/,$r);
      foreach $t (@a) {  # all pools
             if ($t=~/^syspool|^rpool/) { next; }
             if ($t=~/^NAME/) {
                  $t.= "\tFilesize\tIozone\tInitial Write\tRe-write\tRead\tRe-read\tReverse Read\tStride read\tRandom read\tmixed workload\tRandom Write\tFwrite\tFread\t&nbsp;";
                  push (@w,$t); next;
             }


             $f="$t"; $f=~s/ .*//;
             $myurl=$url; $myurl=~s/=pool=/$f/;
             $f="/$f";
             $p=$f;        #pool

             $f.="/iozone$size.log";
#&mess($f);
                if (-f $f) {
                        $r=&exe("cat $f");

                        if ($r=~/iozone test complete/s) {

                                $r=~s/.*Initial write/ Initial write/s;
                                @l=();
                                @l=split(/\n/,$r);
                                foreach my $l (@l) {

                                    #initial write
                                    if ($l=~/Initial write/)   { $v1=$l; $v1=~s/.*\"\s+//; next; }

                                    #Rewrite
                                    if ($l=~/  Rewrite/)       { $v2=$l; $v2=~s/.*\"\s+//; next; }

                                    #Read
                                    if ($l=~/  Read/)          { $v3=$l; $v3=~s/.*\"\s+//; next; }

                                    #Re-read
                                    if ($l=~/  Re-read/)       { $v4=$l; $v4=~s/.*\"\s+//; next; }

                                    #Reverse Read
                                    if ($l=~/Reverse Read/)    { $v5=$l; $v5=~s/.*\"\s+//; next; }

                                    #Stride read
                                    if ($l=~/Stride read/)     { $v6=$l; $v6=~s/.*\"\s+//; next; }

                                    #Random read
                                    if ($l=~/Random read/)     { $v7=$l; $v7=~s/.*\"\s+//; next; }

                                    #mixed workload
                                    if ($l=~/Mixed workload/)  { $v8=$l; $v8=~s/.*\"\s+//; next; }

                                    #random write
                                    if ($l=~/Random write/)    { $v9=$l; $v9=~s/.*\"\s+//; next; }

                                    #fwrite
                                    if ($l=~/Fwrite/)          { $v10=$l; $v10=~s/.*\"\s+//; next; }

                                    #fread
                                    if ($l=~/Fread/)           { $v11=$l; $v11=~s/.*\"\s+//; next; }
                                }

                                #add values in MByte/s
                                $v1=$v1/1000; $v1=sprintf ("%.1f", $v1); $v1.=" MB/s";
                                $v2=$v2/1000; $v2=sprintf ("%.1f", $v2); $v2.=" MB/s";
                                $v3=$v3/1000; $v3=sprintf ("%.1f", $v3); $v3.=" MB/s";
                                $v4=$v4/1000; $v4=sprintf ("%.1f", $v4); $v4.=" MB/s";
                                $v5=$v5/1000; $v5=sprintf ("%.1f", $v5); $v5.=" MB/s";
                                $v6=$v6/1000; $v6=sprintf ("%.1f", $v6); $v6.=" MB/s";
                                $v7=$v7/1000; $v7=sprintf ("%.1f", $v7); $v7.=" MB/s";
                                $v8=$v8/1000; $v8=sprintf ("%.1f", $v8); $v8.=" MB/s";
                                $v9=$v9/1000; $v9=sprintf ("%.1f", $v9); $v9.=" MB/s";
                                $v10=$v10/1000; $v10=sprintf ("%.1f", $v10); $v10.=" MB/s";
                                $v11=$v11/1000; $v11=sprintf ("%.1f", $v11); $v11.=" MB/s";

                                $t.="\t$size\t$myurl  $v1  $v2  $v3  $v4  $v5  $v6  $v7  $v8  $v9  $v10  $v11";

                        } else {
                                $do=&exe("ps axw | grep iozone",'','smartbench 98');
                                if ($do=~/iozone \-R/) {
                                  $do=~s/^\s+//;
                                  $do=~s/ .*//s;        #pid
                                  if (-f "$p/iozone.1") {
                                    $t.="  running ";
                                  } else {
                                    $t.="  $myurl  - ";
                                  }
                                } else {
                                    $t.="  $myurl  error";
                                }
                        }
                } else {
                        $t.="   $myurl  -";
                }

                push (@w,$t);
      }



#     $r=~s/\n\s+/\n/gs; $r=~s/ +/\t/gs;


@p=@w;
#&show_array('p',__LINE__);

$r=join("\n",@p);
$r=~s/  +/\t/gs;

print &list2table($r,'','sort2');
print <<EoF;
<pre>All values are in Mbyte/s with 4 KB Record Size and 5 processes<br><b>Please disable monitoring (topmenu Mon) and do not start multiple benchmarks and wait until a benchmark is done</b>
Benchmarks with filesize > 1g can run for a long time.
EoF


}


#############################################################
sub smartbenchlib_bench_overview  {     #hide:
################


      my (@a,@w,$p,$i,$n,$f,@l,@b,$url,$myurl,$do);
      $url="<a href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;action=runbench\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;zfs==pool=\">start</a>";
      &log_end;

      if ($in{'action'} eq "runbench") {

             # not allowed if encrypred
             $t=&exe("/usr/sbin/zfs get encryption $in{'zfs'}");
             if ($t=~/\son\s/) {
                   $t=&exe("/usr/sbin/zfs get -H keystatus $in{'zfs'}");
                   $t=~s/^.*\skeystatus\s+//gs;
                   $t=~s/\s.*//s;
#&mess($t);
                   if ($t ne 'available') {
                     if ($t ne "bad") {
                        &mess('not allowed on locked pools');
                     }
                   }
              }


              $do=&exe("ps axw",'','smartbench 46');
              if ($do=~/bonnie/s) { &mess("there is a bonnie-benchmark already running, please try again later"); }
              $do=&exe("rm /$in{'zfs'}/Bonnie.*");    # delete opt old files
             # &exe("touch /$in{'zfs'}/Bonnie.log");
             # &exe("chmod 666 /$in{'zfs'}/Bonnie.log");

              #se11: /usr/bin/bonnie
              #nex: /usr/sbin/bonnie++

              `chmod 755 /var/web-gui/data/tools/bonnie/bonnie++`;
              $p="/var/web-gui/data/tools/bonnie";                     # included

              if (-f "/usr/sbin/bonnie++") { $p="/usr/sbin"; }
              if (-f "/usr/bin/bonnie++") { $p="/usr/bin";  }




              $do=`echo "$p/bonnie++ -m $sys{'year'}.$sys{'mon'}.$sys{'mday'} -d /$in{'zfs'} -u root > /$in{'zfs'}/Bonnie.log" | sudo at -s now`;
              sleep (1);
      }

      $r=&exe("zpool list -o name,size");

      @a=split(/\n/,$r);
      foreach $t (@a) {
                if ($t=~/^syspool|^rpool/) { next; }
                if ($t=~/^NAME/) {
$t.= "  Bonnie  Date(y.m.d)  File   Seq-Wr-Chr   \%CPU  <b class='font_darkblue'>Seq-Write</b>  \%CPU  Seq-Rewr  \%CPU  Seq-Rd-Chr  \%CPU   <b class='font_darkblue'>Seq-Read</b>   \%CPU   Rnd Seeks  \%CPU   Files  Seq-Create  Rnd-Create";
push (@w,$t); next;
               }


             $f="$t"; $f=~s/ .*//;
             $myurl=$url; $myurl=~s/=pool=/$f/;
             $f="/$f";
             $p=$f;        #pool

             $f.="/Bonnie.log";
                if (-f $f) {
                        $r=&exe("cat $f");
                        if ($r=~/^Version/) {
                                @l=();
                                @l=split(/\n/,$r);
                                @b=();                                                         #                                                                               x(15)                                x (21)
                                @b=split(/,/,$l[8]);                                  # example :17.2.10,8G,202325,83,10674,4,4436,5,135971,87,761110,93,2769.9,15,16,26355,100,+++++,+++,+++++,+++,17918,96,+++++,+++,+++++,+++
                                $b[2]=$b[2]/1000;   if ($b[2] > 10 ) { $b[2]=int($b[2]); }    $b[2].=" MB/s";  #seq out char
                                $b[4]=$b[4]/1000;   if ($b[4] > 10 ) { $b[4]=int($b[4]); }    $b[4].=" MB/s";  #seq out block
                                $b[6]=$b[6]/1000;   if ($b[6] > 10 ) { $b[6]=int($b[6]); }    $b[6].=" MB/s";  #seq out rewrite
                                $b[8]=$b[8]/1000;   if ($b[8] > 10 ) { $b[8]=int($b[8]); }    $b[8].=" MB/s";  #seq in char
                                $b[10]=$b[10]/1000; if ($b[10] > 10 ) { $b[10]=int($b[10]); } $b[10].=" MB/s"; #seq in block

                                $t.="  $myurl  $b[0]  $b[1]  $b[2]  $b[3]  $b[4]  $b[5]  $b[6]  $b[7]  $b[8]  $b[9]  $b[10]  $b[11]  $b[12]/s  $b[13]  $b[14]  $b[15]/s  $b[21]/s ";

#print $r;
#exit;


                        } else {
                                $do=&exe("ps ax | grep bonnie",'','smartbench 98');
                                if ($do=~/bonnie/) {
                                  $do=~s/^\s+//;
                                  $do=~s/ .*//s;        #pid
#&mess("$p"."/Bonnie.$do.000");
                                  if (-f "$p/Bonnie.$do.000") {

                                    $t.="  $myurl  running ";
                                  } else {
                                    $t.="  $myurl  - ";
                                  }
                                } else {
                                    $t.="  $myurl  error";
                                }

                        }
                } else {
                        $t.="   $myurl  -";
                }

                push (@w,$t);
      }



#     $r=~s/\n\s+/\n/gs; $r=~s/ +/\t/gs;


@p=@w;
#&show_array('p',__LINE__);

$r=join("\n",@p);
$r=~s/  +/\t/gs;
print &list2table($r,'','sort2');

print <<EoF;
<pre><b>Please disable monitoring (topmenu Mon) and do not start multiple benchmarks and wait until a benchmark is done</b>

Reload Page to see if a benchmark is done. <b>Bench will fail if Diskspace < 2 x memory-size.</b>
<b class='font_darkblue'>Most important values are:</b> Sequential read and write values (Block)

Bonnie ++ 1.03e:

"Bonnie Results
Bonnie runs six tests, three that perform writes, and three that perform reads.
Here's the description provided by the benchmark's author for each of these tests:

Write Tests (Out)

    * Per-Character: The file is written using the putc() stdio macro. The loop that does the writing should be small enough to fit into any reasonable I-cache.
      The CPU overhead here is that required to do the stdio code plus the OS file space allocation.
    * Block: The file is created using write(2). The CPU overhead should be just the OS file space allocation.
    * Rewrite: Each Chunk (currently, the size is 16384) of the file is read with read(2), dirtied, and rewritten with write(2), requiring an lseek(2).
      Since no space allocation is done, and the I/O is well-localized, this should test the effectiveness of the filesystem cache and the speed of data transfer.

Read Tests (In)

    * Per-Character: The file is read using the getc() stdio macro. Once again, the inner loop is small. This should exercise only stdio and sequential input.
    * Block: The file is read using read(2). This should be a very pure test of sequential input performance.
    * Random Seeks: This test runs SeekProcCount (currently 4) processes in parallel, doing a total of 4000 lseek()s to locations in the file computed using
      by random() in bsd systems, drand48() on sysV systems. In each case, the block is read with read(2). In 10% of cases, it is dirtied and written back with write(2).
      The idea behind the SeekProcCount processes is to make sure there's always a seek queued up."


from http://www.extremetech.com/article2/0,2845,1150788,00.asp
see also http://www.coker.com.au/bonnie++/readme.html
</pre>
EoF



exit;

}




#EoF ######################
# do not remove line below (return true)
1;
