# system lib
###############################
# system functions for napp-it    Copyright (c) 2010-2013 napp-it
################################
# functions are autoloaded if action contains &thislib_xx() ex &zfslib_list() will autoload zfslib via require

#########
sub systemlib {  #07.02.2013
###########################
}

######### net ##########

 ######################
 sub systemlib_net_change_property {                 #hide:
 #######################    set net details
 my ($r,$s,$t,$l,$a,@details,$opt,$ip,$m,$ipf,$par);


   print "<br>$txt{'set_mess'}";    # please wait up to ...

   #parse prop  ex e1000g1:ip-adress
        $in{'prop'}=~s/[^a-zA-Z0-9\:\-\ ]//g;
        $opt=$in{'prop'};
        $opt=~s/ .*//;                 # ex e1000g1:1 LINK   -> e1000g1:1
        $opt=~tr/A-Z/a-z/;
        $opt=~s/[^a-z0-9\:]//g;        # option ex linkname


   # stupid s11 thing
   ##################
        if ($sys{'auto_os_type'} eq "sol_s") {     # Solaris 11
                        $ipf="ip";                             # use ipadm create/delete-ip

                        #switch from automatic to manual configuration
                        &exe("netadm enable -p ncp DefaultFixed");
        } else {                                   # Illumos based, Solaris 11 Express
                        $ipf="if";                             # use ipadm create/delete-if
        }


  #############
  # create aggr
  #############
  if ($in{'action'} eq "create_aggr") {
       $in{'text'}=~s/ +//g;
       if (!($in{'text'}=~/^\d+$/)) { &mess("Please enter a number only like 1 or 2"); }

       $in{'over'}=~s/ +//g;
       $in{'over'}=~s/,+$//; $in{'over'}=~s/^,+//;
       @t=();
       @t=split(/,/,$in{'over'});
       if (!(@t > 1)) { &mess('Need 2+ phys devices!'); }
       $p="";
       foreach my $t (@t) {
           if (!($current{'device_phys'}=~/\b$t\b/)) { &mess("Link $t is not a physical device"); }
           $p.=" -d $t";
       }

       $r=&exe("dladm create-aggr $p $in{'text'}");
       if ($r eq "") { $r="ok"; }
       print "<br><br>dladm create-aggr $p $in{'text'}<hr>$r";
       sleep(4);
  }

  #############
  # create vlan
  #############
  if ($in{'action'} eq "create_vlan") {

       if ($in{'over'}=~/^-/) { return; }
       $in{'vlan_id'}=~s/\D//g;
       if ( (!($in{'vlan_id'} > 0)) || ($in{'vlan_id'}>4096) ) { &mess('vlan id 1..4096 !'); }
       $in{'text'}=~s/\s//g;  if ($in{'text'} eq "")    { &mess('Linkname? '); }
       if (!($in{'text'}=~/\d$/))  { $in{'text'}.="0"; }
       $r=&exe("dladm create-vlan -f  -l $in{'over'} -v $in{'vlan_id'} $in{'text'}");
       if ($r eq "") { $r="ok"; }
       print "<br><br>dladm create-vlan -f -l $in{'over'} -v $in{'vlan_id'} $in{'text'}<hr>$r";
       sleep(4);
  }

  #############
  # create vnic
  #############
  if ($in{'action'} eq "create_vnic") {
       if ($in{'over'}=~/^-/) { return; }
       $in{'vlan_id'}=~s/\D//g;

       if ($in{'vlan_id'} ne "") {
          if ( (!($in{'vlan_id'} > 0)) || ($in{'vlan_id'}>4096) ) { &mess('vlan id 1..4096 !'); }
       }
       $in{'text'}=~s/\s//g;  if ($in{'text'} eq "")    { &mess('Linkname? '); }
       if (!($in{'text'}=~/\d$/))  { $in{'text'}.="0"; }

       #mac and vlan?
       $t="";
       if ($in{'vlan_id'} ne "")  { $t =" -f -v $in{'vlan_id'}";  }
       if ($in{'mac'}=~/:.*:/)    { $t.=" -m $in{'mac'}";  }


       $r=&exe("dladm create-vnic -l $in{'over'}$t $in{'text'}");
       if ($r eq "") { $r="ok"; }
       print "<br><br>dladm create-vnic -l $in{'over'}$t $in{'text'}<hr>$r";
       sleep(4);
  }

  ######################
  # set manual ip-adress
  ######################
  if ($in{'action'} =~/set_ip/) {          #ip,mask

        $in{'ip'}=~s/[^0-9\.]//g;
        $in{'mask'}=~s/[^0-9\.]//g;

        if (!($opt=~/\w+/))                         { &mess("invalid Linkname $opt") ; }

        if (!($in{'ip'}=~/\d+\.\d+\.\d+\.\d+/))     { &mess("invalid ip $in{'ip'} : must be n.n.n.n (n from 0 to 254) example 192.168.1.10"); }
        if ($in{'ip'}=~/\.0$|\.255$/)               { &mess("invalid ip $in{'ip'} : last number cannot be 0 or 255; example 192.168.1.10"); }

        if (!($in{'mask'}=~/\d+\.\d+\.\d+\.\d+/))   { &mess("invalid netmask $in{'mask'}: must be n.n.n.n (example 255.255.255.0)"); }

        if ($in{'gateway'}=~/\d+\./) {
           if (!($in{'gateway'}=~/\d+\.\d+\.\d+\.\d+/))     { &mess("invalid gateway $in{'gateway'} : must be n.n.n.n (n from 0 to 254) example 192.168.1.10"); }
        }

        # phase 1 nwam > default?
        if ($sys{'network'} eq 'nwam') {
                print "disable nwam<br>";
                &exe("svcadm disable network/physical:nwam");
                &exe("svcadm disable network/physical:upgrade");
                $sys{'network'}="default";
                print "enable default<br>";
                &exe("svcadm enable network/physical:default");
        }




         #
         # first step delete old interface to avoid error like cannot create adress: Persistent operation on temporary object
         # $in: zfs=link, ip=ip,  mask=netmask

                    $in{'link'}=$in{'prop'}; $in{'link'}=~s/ .*//;    # get link from prop

                    #opt if down
                    #$r=&exe("ifconfig $in{'link'} down");

                    #opt if delete
                    $r=&exe("ipadm delete-$ipf $in{'link'}");
                    # print "<br><br>ipadm delete-$ipf $in{'link'}  -> ";
                    # print "$r<br><br>";

                    #create interface
                    $r=&exe("ipadm create-$ipf $in{'link'}");
                    # print "ipadm create-$ipf $in{'link'} -> ";
                    # print "$r<br><br>";

                    # use dns
                    $r.=&exe("cp /etc/nsswitch.dns /etc/nsswitch.conf");
                    #print "cp /etc/nsswitch.dns /etc/nsswitch.conf -> ";
                    #print "$r<br><br>";


                    # needed in Illumian, otherwise not needed
                    if ($sys{'auto_os'} =~/illumian/i) {
                                        # /etc/hostname.link ??
                                         print "echo $in{'ip'} | tee /etc/hostname.$in{'link'}";

                                        # delete dhcp entry
                                        if (-f "/etc/dhcp.$in{'link'}") {
                                             &exe("rm /etc/dhcp.$in{'link'}");
                                        }
                                        $t=&exe("echo \'$in{'ip'}\' | tee /etc/hostname.$in{'link'}");
                                        # print "$r<br><br>";
                    }

                    #convert netmask like 255.255.255.0 to/24 value
                    use Socket;
                    $t=unpack('B*', inet_aton($in{'mask'}));
                    $t=~s/0//g;
                    $t=length($t);

                    #create persistent object
                    $r.=&exe("ipadm create-addr -T static -a $in{'ip'}/$t $in{'link'}/v4");
#print "117 ipadm create-addr -T static -a $in{'ip'}/$t $in{'link'}/v4 ->\n$r";     exit;


                    #update gateways
                    # print "gateway: $in{'gateway'}<br>";
                    if ($in{'gateway'}=~/\d+\.\d+\.\d+\.\d+/) {
                        $t=&exe("echo $in{'gateway'} | tee /etc/defaultrouter");
                        #print "echo $in{'gateway'} | tee /etc/defaultrouter  ->";
                        #print "$r<br><br>";

                        $r.=&exe("route flush");
                        $r.=&exe("route -p add default $in{'gateway'}");
                        #print "route -p add default $in{'gateway'} -> ";
                        #print "$r<br><br>";
                    }


                    #update /etc/host??
                    #..

                    if ($sys{'network'} eq '') {
                      &exe("svcadm enable network/physical:default");
                      $sys{'network'}="default";
                    }
                    sleep(1);
  }


  ######
  # addr state
  ############
  if ($in{'action'} =~/link_astate/) {

    $p=$in{'temp'};
    if ($p eq "") { $p=""; } else { $p=" -t"; }  #temporary/persistent

    #addrobj
    $t="adr_$in{'list'}\_addrobj";
    $t=$current{$t};

    if ($in{'text'} =~/delete/) {
            $r=&exe("ipadm disable-addr -t $t");
            $r.=&exe("ipadm delete-addr $t");
            if ($r eq "") { $r="ok"; }
            print "<br><br>ipadm delete-addr $t<hr>$r";
            sleep(4);
    }

    if ($in{'text'} =~/disable/) {
            $r=&exe("ipadm disable-addr -t $t");
            if ($r eq "") { $r="ok"; }
            print "<br><br>ipadm disable-addr $t<hr>$r";       sleep(4);
    }
    if ($in{'text'} =~/enable/) {
            $r=&exe("ipadm enable-addr -t $t");  if ($r eq "") { $r="ok"; }
            print "<br><br>ipadm enable-addr $t<hr>$r";       sleep(4);
    }
    if ($in{'text'} =~/up/) {
            $r=&exe("ipadm up-addr$p $t");  if ($r eq "") { $r="ok"; }
            print "<br><br>ipadm up-addr$p $t<hr>$r";       sleep(4);
    }
    if ($in{'text'} =~/down/) {
            $r=&exe("ipadm down-addr$p $t");  if ($r eq "") { $r="ok"; }
            print "<br><br>ipadm down-addr$p $t<hr>$r";       sleep(4);
    }

  }

  ######
  #state
  ######
  if ($in{'action'} =~/link_state/) {      # behavior too indifferent, decided to always delete/ recrete

        $r="";
        $in{'text'}=~s/[^a-z]//g;
        if ($in{'text'} eq "") {  &mess('up or disable'); }     #get name


        # get dhcp
        $ip="net_".$in{'list'}."_addr";
        $ip=$current{$ip};                                  # current data

        $t="net_".$in{'list'}."_type";
        if ($current{$t} eq "static") {
            $par="ipadm create-addr -T static -a $ip $in{'list'}/v4";
        } else {
            $par="ipadm create-addr -T dhcp $in{'list'}/v4";
        }

        if ($in{'text'} =~/disable/) {
                $r=&exe("ipadm disable-if -t $in{'list'}");        # temporary
                if ($r eq "") { $r="ok"; }
                print "<br><br>ipadm disable-if -t $in{'list'} (temporary)<hr>$r";
        }

        if ($in{'text'} eq "enable")  {
                    $r=&exe("ipadm delete-$ipf $in{'list'}");
                    $r=&exe("ipadm create-$ipf $in{'list'}");         # without enable
                    $r.=&exe("$par");                                  # create addr
                    if ($r eq "") { $r="ok"; }
                print "<br><br>enable if $in{'list'}<hr>$r";
        }


        if ($in{'text'} =~/delete/) {
             $r=&exe("ipadm delete-$ipf $in{'list'}");
             if ($r eq "") { $r="ok"; }
             print "<br><br>ipadm disable-if -t $in{'list'}<hr>$r";
        }
        #
        sleep(2);
  }

  #########
  #LINK name     ex dladm rename-link e1000g0 eth0
  ##########

  if ($in{'action'} =~/link_name/) {
     $in{'text'}=~s/ //g;
     if ($in{'text'} eq "") { &mess('Linkname?'); }
     if (!($in{'text'}=~/\d$/)) { $in{'text'}.="0"; }

     $r=&exe("dladm rename-link $in{'list'} $in{'text'}");
     print "<br><br>dladm rename-link $in{'list'} $in{'text'}<hr>$r";
     sleep(3);


  }


  ##################
  #manual -> dhcp   #
  ###################
  if ($in{'action'} =~/dhcp/) {

        ################
        # static -> dhcp

        if ($in{'text'} eq "dhcp")    {
             # delete adress
              $r=&exe("ipadm delete-$ipf $in{'list'}");
              $r=&exe("ipadm create-$ipf $in{'list'}");
              $r=&exe("ipadm create-addr -T dhcp $in{'list'}/v4");
              sleep(1);
        }

        #################
        # dhcp -> static

        if ($in{'text'} eq "static")    {

              $r=&exe("ipadm delete-$ipf $in{'list'}");
              $r=&exe("ipadm create-$ipf $in{'list'}");

              #set to old dhcp adress
              $ip="adr_".$in{'list'}."_ip";                                 # ex 192.168.1.10/24
              $ip=$current{$ip};
              $r.=&exe("ipadm create-addr -T static -a $ip $in{'list'}/v4");

              # set gateway from dhcp
                        $t=&exe("echo $current{'net_gateway'} | tee /etc/defaultrouter");

                        $r.=&exe("route flush");
                        $r.=&exe("route -p add default $current{'net_gateway'}");

              sleep(2);                                                      #needed to dispolay correct value?
        }
       &exe("svcadm restart network/physical:default");
  }


  ####
  #mtu
  ####
  if ($in{'action'} =~/set_mtu/) {          #dladm set-linkprop -p mtu=2000 bge0

     $in{'text'}=~s/\D//g;
     if (!($in{'text'}=~/\d\d\d\d+$/)) { &mess("invalid mtu $in{'text'}"); }

     $r=&exe("dladm set-linkprop -p mtu=$in{'text'} $in{'list'}");
     print "<br><br>dladm set-linkprop -p mtu=$in{'text'} $in{'list'}<hr>$r";
     sleep(3);

     &exe("svcadm restart network/physical:default");

  }
  ##########################

  #ok
  $in{'action'}="";
  &reload;

 }  #/sub



 ##################
 sub systemlib_get_link_array {        # hide:
 ##################
  my ($r,@l,@t,$t);
  $r=&exe("dladm show-phys");
  @t=split(/\n/,$r);
  foreach $t (@t) {
    if ($t=~/^LINK/) { next; }
    $t=~s/ .*//;   chomp($t);
    push (@l,$t)
  }
  return ("@l");

#  value in $current{'link_phys'} as tablist
 }

#########################
 sub systemlib_net_aggr {
########################
  my ($r,@v,$v,@link,$l,$u,$url,$link);

  #change zfs property
    if ($in{'answered'}) { &systemlib_net_change_property; }

  # del link
    if ($in{'action'} eq "del_aggr") {

        #del link
        if ($sys{'auto_os_type'} eq "sol_s") {     # Solaris 11
           $r=&exe("ipadm delete-ip $in{'link'} 2>&1");
        } else {
           $r=&exe("ipadm delete-if $in{'link'} 2>&1");
        }

        # del aggr
        $r.=&exe("dladm delete-aggr $in{'link'}");
        if ($r eq "") { $r="ok"; }
        print "<br><br>dladm delete-aggr $in{'link'}<hr>$r";
        sleep(3);
        $in{'action'}="";
        &reload;
    }

  #url
    $url="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;action==action=\&amp;zfs=LINK\&amp;list==list=\&amp;link==link=\&amp;prop==prop=\&amp;old==old=\">=text=</a>";


  #header
  my @links;
  $t="Aggr   \tOver      \tPolicy\tAdr-Policy\tLACP-Activity\tLACP-Timer\tFlags\tState    \tDEL\t&nbsp;";
  push(@links,"$t");

  # get links
   @v=split(/\t/,$current{'link_aggr'});
   push(@links,@v);

  # generate list
  foreach my $tmp (@links) {

            # link-> details
            if (!($tmp =~/\w+\d/)) { next; }

            $link=$tmp;
            $tmp="";

            # 0. linkname -> details
              $u=&systemlib_net_linkdetails($link);
              $tmp.="$u\t";

            # 1. over
              $t="link_over_$link";
              $t=$current{$t}; $t=~s/\t/<br>\&nbsp;/g;
              $tmp.="$t\t";

            # 2. policy
              $t="aggr_$link\_policy";
              $tmp.="$current{$t}\t";

            # 3. addr policy
              $t="aggr_$link\_adrpolicy";
              $tmp.="$current{$t}\t";

            # 4.lacpactivity
              $t="aggr_$link\_lacpactivity";
              $tmp.="$current{$t}\t";


            # 5.lacptimer
               $t="aggr_$link\_lacptimer";
               $tmp.="$current{$t}\t";

            # 6. flags
               $t="aggr_$link\_flags";
               $tmp.="$current{$t}\t";

            # 7.state
              $t="link_$link\_state";
              $tmp.="$current{$t}\t";


            # 10. del
              $u=&systemlib_net_linkdel($link,'aggr');
              $tmp.="$u\t";

  }

  #add link
  $t=&systemlib_net_create('aggr');      #++ create
  push (@links,"<br>$t");

  print "<br><br><b>Aggregation/ monitor extension</b>";
  $r=join("\n",@links);
  print &list2table($r,'','sort2');


  ################
  # aggr ip details
  ################
  print "<br><br><b>Aggregation IP details/ monitor extension</b>";

  if ($current{'link_aggr'} ne "") {

      #header
      $t="Link   \tPortstate\tState\tSpeed\tDuplex\tDHCP\tIP&nbsp;&nbsp;\tNETMASK\tMAC&nbsp;\tMTU\t\t&nbsp;";

      @t=split(/\t/,$current{'link_aggr'});
      unshift(@t,$t);

      # add aggr members
      foreach my $ag (@t) {
         $t="link_$ag\_over";
         $t=$current{$t}; $t=~s/\s/\n/g;
         $ag="$ag\n$t";
      }

      $t=join("\n",@t);

      my @t=();
      @t=split(/\n/,$t);                  # new array aggr + member
#&print_array(@t);

      # agg + member
      foreach my $tmp (@t) {

               if (!($tmp =~/\w+\d/)) { next; }

               # linkname
                     $link=$tmp;
                     $tmp.="\t";


               #portstate
                     $t="aggr_$link\_portstate";
                     $tmp.="$current{$t}\t";

              # linkportstate
                     $t="link_$link\_state";
                     $tmp.="$current{$t}\t";

              # speed
                     $t="aggr_$link\_speed";
                     $tmp.="$current{$t}\t";

              # duplex
                     $t="aggr_$link\_duplex";
                     $tmp.="$current{$t}\t";


              # dhcp
             ##########

                if ($link=~/^aggr/) {
                    $u=&systemlib_net_linkdhcp($link);
                    $tmp.="$u\t";
                } else {
                    $tmp.="-\t";
                }

             ########
             #  ip
             ########
                if ($link=~/^aggr/) {
                    $u=&systemlib_net_linkip($link);
                    $tmp.="$u\t";
                } else {
                    $tmp.="-\t";
                }

             ############
             # netmask
             ############
                if ($link=~/^aggr/) {
                    $u=&systemlib_net_linkmask($link);
                    $tmp.="$u\t";
                } else {
                    $tmp.="-\t";
                }

             #####
             # mac
             #####
                   $t="aggr_$link\_adress";
                   $tmp.="$current{$t}\t";

             #mtu

                   $u=&systemlib_net_linkmtu($link);
                   $tmp.="$u\t";

       }

       $r=join("\n",@t);
       print &list2table($r,'','bold');


    #######
    #add -L
    #######
         print "<br><br><b>Aggregation details/ monotor extension</b>";
         $r=&exe("dladm show-aggr -L");
         $r=~s/ +/\t/gs;
         $r=~s/\n/\n\n/;
         print &list2table($r,'','bold');

  }
  print "<br><br><br>";

}


#########################
 sub systemlib_net_vlans {
########################
  my ($r,@v,$v,@link,$l,$u,$url,$link);

  #change zfs property
    if ($in{'answered'}) { &systemlib_net_change_property; }

  # del link
    if ($in{'action'} eq "del_vlan") {

        #del link
        $r.=&exe("dladm delete-vlan $in{'link'}");
        if ($r eq "") { $r="ok"; }
        print "<br><br>dladm delete-vlan $in{'link'}<hr>$r";
        sleep(3);
        $in{'action'}="";
        &reload;
    }

  #url
    $url="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;action==action=\&amp;zfs=LINK\&amp;list==list=\&amp;link==link=\&amp;prop==prop=\&amp;old==old=\">=text=</a>";


  #header
  my @links;
  $t="VLAN        \tVLAN ID\tOVER\tSTATE\tDHCP\tIP&nbsp;&nbsp;\tNETMASK\tMAC&nbsp;\tMTU\tADDR STATE\tDEL\t&nbsp;";
  push(@links,"$t");

  # get links
   @v=split(/\t/,$current{'link_vlan'});
   push(@links,@v);

  # generate list
  foreach my $tmp (@links) {

            # link-> details
            if (!($tmp =~/\w+\d/)) { next; }

            $link=$tmp;
            $tmp="";

            # 0. linkname -> details
              $u=&systemlib_net_linkdetails($link);
              $tmp.="$u\t";

            # 1. vlan-id
              $t="vlan_$link\_id";
              $tmp.="$current{$t}\t";

            # 2. link over
              $t="vlan_$link\_over";
              $tmp.="$current{$t}\t";

            # 3.state
              $t="link_$link\_state";
              $tmp.="$current{$t}\t";


            # 4.dhcp
               $u=&systemlib_net_linkdhcp($link);
               $tmp.="$u\t";

            # 5. ip
               $u=&systemlib_net_linkip($link);
               $tmp.="$u\t";

            # 6. mask
               $u=&systemlib_net_linkmask($link);
               $tmp.="$u\t";

            # 7. mac
               $u=&systemlib_net_linkmac($link);
               $tmp.="$u\t";

            # 8. mtu
               $u=&systemlib_net_linkmtu($link);
               $tmp.="$u\t";

            # 9. address state
               $u=&systemlib_net_linkastate($link);     # address state
               $tmp.="$u\t";

            # 10. del
              $u=&systemlib_net_linkdel($link,'vlan');
              $tmp.="$u\t";

  }

  #add link
  $t=&systemlib_net_create('vlan');      #++ create
  push (@links,"<br>$t");

  print "<br><br><b>Vlan Links/ monitor extension</b>";
  $r=join("\n",@links);
  print &list2table($r,'','sort2');

}


#########################
 sub systemlib_net_vnics {
########################
  my ($r,@v,$v,@link,$l,$u,$url,$link);

  #change zfs property
    if ($in{'answered'}) { &systemlib_net_change_property; }

  # del link
    if ($in{'action'} eq "del_vnic") {

        #del link
        if ($sys{'auto_os_type'} eq "sol_s") {     # Solaris 11
           $r=&exe("ipadm delete-ip $in{'link'} 2>&1");
        } else {
           $r=&exe("ipadm delete-if $in{'link'} 2>&1");
        }
        $r=&exe("dladm delete-vnic $in{'link'}");
        if ($r eq "") { $r="ok"; }
        print "<br><br>dladm delete-vnic $in{'link'}<hr>$r";
        sleep(3);
        $in{'action'}="";
        &reload;
    }

  #url
    $url="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;action==action=\&amp;zfs=LINK\&amp;list==list=\&amp;link==link=\&amp;prop==prop=\&amp;old==old=\">=text=</a>";


  #header
  my @links;
  $t="VNIC        \tVLAN ID\tOVER\tSTATE\tDHCP\tIP    \tNETMASK\tMAC \tMTU\tADDR STATE\t ";
  push(@links,"$t");

  # get links
   @v=split(/\t/,$current{'link_vnic'});
   push(@links,@v);

  # generate list
  foreach my $tmp (@links) {

            # link-> details
            if (!($tmp =~/\w+\d/)) { next; }

            $link=$tmp;
            $tmp="";

            # 0. linkname -> details
              $u=&systemlib_net_linkdetails($link);
              $tmp.="$u\t";

            # 1. vid (vlan id)
              $t="vnic_$link\_vid";
              $tmp.="$current{$t}\t";

            # 2. link over
              $t="vnic_$link\_over";
              $tmp.="$current{$t}\t";

            # 3.state
              $t="link_$link\_state";
              $tmp.="$current{$t}\t";


            # 4.dhcp
               $u=&systemlib_net_linkdhcp($link);
               $tmp.="$u\t";

            # 5. ip
               $u=&systemlib_net_linkip($link);
               $tmp.="$u\t";

            # 6. mask
               $u=&systemlib_net_linkmask($link);
               $tmp.="$u\t";

            # 7. mac
               $u=&systemlib_net_linkmac($link);
               $tmp.="$u\t";

            # 8. mtu
               $u=&systemlib_net_linkmtu($link);
               $tmp.="$u\t";

            # 9. address state
               $u=&systemlib_net_linkastate($link);     # address state
               $tmp.="$u\t";

            # 10. del
              $u=&systemlib_net_linkdel($link,'vnic');
              $tmp.="$u\t";
  }

  #add link
  $t=&systemlib_net_create('vnic');      #++ create
  push (@links,"<br>$t");

  print "<br><br><b>Vnic Links/ monitor extension</b>";
  $r=join("\n",@links);
  print &list2table($r,'','sort2');

}

##############################   address state
sub systemlib_net_linkastate {
##############################
     my $link=$_[0];
     my $t="adr_$link\_state";
     $t=$current{$t};

     my $u=$current{'url'};
     $u=~s/=text=/$t/g;
     $u=~s/=action=/link_astate/g;   $u=~s/=prop=/$link ADDRSTATE/g;
     $u=~s/=list=/$link/g;          $u=~s/=old=/$t/g;           $u=~s/=link=/$link/g;
     if ($sys{'network'} eq "nwam") { $u="$t"; }
     return ($u);
}

##############################   physical
sub systemlib_net_linkpstate {
##############################
     my $link=$_[0];
     my $t="phys_$link\_state";
     $t=$current{$t};
     if ($t eq "inaccessible") { $t="down"; }                # unplugged/inaccessible ->  down

     # delete always, disable when up, enable when disabled
     my $u=$current{'url'};
     $u=~s/=text=/$t/g;
     $u=~s/=action=/link_state/g;   $u=~s/=prop=/$link STATE/g;
     $u=~s/=list=/$link/g;          $u=~s/=old=/$t/g;           $u=~s/=link=/$link/g;
     if ($sys{'network'} eq "nwam") { $u="$t"; }
     return ($u);
}



#################
sub systemlib_net_linkdetails {
#################
     my $link=$_[0];
     my $text=$_[1];
     if ($text eq "") { $text=$link; }

     my $u=$current{'url'};
     if ($sys{'network'} eq "nwam") { $u="=text="; }
     $u=~s/=text=/$text/g;  $u=~s/=link=/$link/g;                               # =list=   -> show details of net
     $u=~s/=prop=//g;       $u=~s/=action=/details/g;  $u=~s/=old=//g;          # =net= -> edit =prop=    (property)
     return ($u);
}

#################
sub systemlib_net_linkdhcp($link) {
################
     my $link=$_[0];
     my $t;
     my $r=&exe("ifconfig $link dhcp status");

     if ($r=~/not under DHCP control/s) { $t="static"; } else { $t="call"; }
     if ($r=~/Began, Expires/s) {  $r=~s/.*$link\s+//s; $r=~s/,* +.*//s; $t=$r;  }     #dhcp state

     my $u=$current{'url'};
     $u=~s/=text=/$t/g;               $u=~s/=link=/$link/g;   $u=~s/=list=/$link/g;
     $u=~s/=prop=/$link dhcp/g;       $u=~s/=old=/$t/g;
     $u=~s/=action=/change_dhcp/g;
     return($u);
}

################
sub systemlib_net_linkip {
################
     my $link=$_[0];
     my $t;
     my $u=$current{'url'};

     $t="adr_$link\_type";
     if (($current{$t} eq "static") || ($current{$t} eq "")) {
         $t="adr_$link\_ip";
         $t=$current{$t};
         if ($t eq "") { $t="unset"; }
         $u=~s/=text=/$t/g;              $u=~s/=link=/$link/g;   $u=~s/=list=/$link/g;
         $u=~s/=prop=/$link ip-adress/g; $u=~s/=old=/$t/g;       $u=~s/=action=/set_ip/g;
     } else {
         $t="adr_$link\_ip";
         $u=$current{$t};
        if ($u eq "") { $u="-"; }  # state unknown
    }
    return($u);
}

#################
sub systemlib_net_linkmask {
#################
   my $link=$_[0];
   my $t="if_$link\_netmask";
   my $u;
   if ($current{$t} eq "") {
         $u="-";
   } else {
         $u="$current{$t}";
   }
   return($u);
}

#################
sub systemlib_net_linkmac {
#################
   my $link=$_[0];
   my $t="if_$link\_ether";
   my $u;
   if ($current{$t} eq "") {
         $u="-";
   } else {
         $u="$current{$t}";
   }
   return($u);
}

#################
sub systemlib_net_linkmtu {
#################
   my $link=$_[0];
   my $t="link_$link\_mtu";
   $t=$current{$t};

   my $u=$current{'url'};
   $u=~s/=text=/$t/g;        $u=~s/=link=/$link/g;   $u=~s/=list=/$link/g;
   $u=~s/=prop=/$link mtu/g; $u=~s/=old=/$t/g;       $u=~s/=action=/set_mtu/g;
   return($u);
}

#################
sub systemlib_net_create {
#################
   my $add=$_[0];
   my $u=$current{'url'};

   $u=~s/=text=/add $add/g;    $u=~s/=link=//g;  $u=~s/=list=//g;
   $u=~s/=prop=/create_$add/g; $u=~s/=old=//g;   $u=~s/=action=/create_$add/g;
   return("++ $u");
}

#################
sub systemlib_net_linkdel {
#################
   my $link=$_[0];
   my $ref=$_[1];
   if ($ref eq "") { $ref="link"; }

   my $u=$current{'url'};
   $u=~s/>=text=/=ask=>=text=/;
   my $ask=" onclick=\"return(confirm('delete $link?'))\"";
   $u=~s/=ask=/$ask/;

   $u=~s/=text=/delete $link/g; $u=~s/=link=/$link/g;  $u=~s/=list=/$link/g;
   $u=~s/=prop=//g;             $u=~s/=old=//g;        $u=~s/=action=/del_$ref/g;           # del link, vnic, vlan
   return($u);
}


#################
 sub systemlib_net_overview {            # print zfs overview
 ############### print overview if user zfs
    my ($net,@z,$url,$u,$r,@w,@net,$link,@w,$l,$d,$dhcp,$m,$n,$i,$dev);

    #change zfs property
    if ($in{'answered'}) { &systemlib_net_change_property; }

  #url -> sub
    $current{'url'}="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;action==action=\&amp;zfs=LINK\&amp;list==list=\&amp;link==link=\&amp;prop==prop=\&amp;old==old=\">=text=</a>";

    # add info about use of first physical nic
     $t=`hostname`;
     $txt{'network_info2'}=~s/=h=/$t/;
     print "<pre>$txt{'network_info2'}</pre>";

   #header
   $t="DEVICE        \tLINK  \tMEDIA    \tSTATE\tSPEED\tDUPLEX\tDHCP\t\IP&nbsp;\tNETMASK\tMAC&nbsp;\tMTU\tADDR STATE\tOVER LINK";
   push(@net,"$t");


   # get nics
   my @w=split(/\t/,$current{'device_phys'});
   @w=sort(@w);
   if (@w ==0) { push (@net,"-none-"); } else { push (@net,@w);}


   #add editoptions      Device, LINK, Media, State, Speed, Duplex , DHCP/man, IP, mask, mac, mtu, vlan
   foreach $tmp (@net) {

            if (!($tmp=~/\w+\d/)) { next; }

            $dev=$tmp;                                                                         # device name
            $t="phys_$dev\_link";
            $link=$current{$t};                                                                # link name
            $tmp="";                                                                           # rebuild line

            ####################
            # 0. device details/name
            ####################

              $u=&systemlib_net_linkdetails($link,$dev);
              $tmp.="$u\t";

            ##########
            # 1. link name of device
            ##########

              $u=$current{'url'};
              if ($sys{'network'} eq "nwam") { $u=$link; }
              $u=~s/=text=/$link/g;         $u=~s/=link=/$link/g;     $u=~s/=action=/link_name/g; # =list=   -> show details of net
              $u=~s/=prop=/$link LINK/g;    $u=~s/=list=/$link/g;     $u=~s/=old=/$link/g;        # =net= -> edit =prop=    (property)
              $tmp.="$u\t";

            #########
            #2. Media
            #########

             $t="phys_$link\_media";
             $tmp.="$current{$t}\t";

            ###########
            # 3. physstate    (phys disabled, ok or down=inaccessable)
            ###########

               $u=&systemlib_net_linkpstate($link);     # pstate!!
               $tmp.="$u\t";

            ###########
            # 4. speed
            ##########

               $t="phys_$link\_speed";
               $tmp.="$current{$t}\t";

            ############
            # 5. duplex
            ############

               $t="phys_$link\_duplex";
               $tmp.="$current{$t}\t";

            ##########
            # 6. dhcp
            ##########

              $u=&systemlib_net_linkdhcp($link);
              $tmp.="$u\t";

            ########
            # 7. ip
            ########

             $u=&systemlib_net_linkip($link);
             $tmp.="$u\t";

            ############
            # 8. netmask
            ############

             $u=&systemlib_net_linkmask($link);
             $tmp.="$u\t";

            ########
            # 9. mac
            ########

              $u=&systemlib_net_linkmac($link);
              $tmp.="$u\t";

            #########
            # 10. mtu
            #########

               $u=&systemlib_net_linkmtu($link);
               $tmp.="$u\t";

            #########
            # 11. address state
            #########

               $u=&systemlib_net_linkastate($link);     # address state
               $tmp.="$u\t";

            ##################
            ## 12. vlan, vnics
            ##################

              $t="vlan_over_$link";
              $u=$current{$t};

              $t="vnic_over_$link";
              $u.=" $current{$t}";

              $t="aggr_over_$link";
              $u.=" $current{$t}";

              $u=~s/\t/ /g;
              $tmp.="$u\t";
    }

    $net=join("\n",@net);
    $net=&list2table($net,'','sort2');

    print "<br><br><b>Physical Nics</b><br>\n$net";


    #ask property
    if ($in{'action'} =~/_/) {                         #get_ip change_state..
      if (($in{'prop'} ) && ($in{'answered'} ne "1")) { print &systemlib_net_ask_property; }
    }


    #add extended settings
    if ($cfg{'ver'}=~/m|c/) {
      &systemlib_net_vnics;
      &systemlib_net_vlans;
      &systemlib_net_aggr;
    } else {
      print "<br><br><b>VLAN, VNIC, Link Aggregation settings</b>";
      print &list2table("use CLI or monitor extension");
    }


    #add details as table
      if ($in{'action'} eq "details") {
             $r=&exe("dladm show-linkprop $in{'link'}");
             $r=~s/VALUE/\tVALUE/;
             $r=~s/  +/\t/gs;
             $r=&list2table($r,'','');
             print "<br><br><b>Link details $in{'link'}</b>\n$r";
      }

    print "\n</body></html>";
    return;

 }


 #####################
 sub systemlib_net_ask_property {       #hide: ask for property
 #####################        (div window in front)

    if ($in{'answered'}) { &systemlib_net_change_property; &net_overview; exit; }

    my ($ask,$form,$info,$t,$opt,$r,$ip,$m,$gw);

    # create aggr
    if ($in{'prop'} =~/create_aggr/) {
        $form  ="AGGR name <input type='text' name='text' value='' style='width: 200px'> Number like 1 <br>";
        $form .="AGGR over <input type='text' name='over' value='' style='width: 200px; margin-left: 7px'> devices ex e1000g1,e1000g2";
        $info="<br>Select devices with state 'deleted' <br>$txt{'info_create_aggr'}";
    }

    # create vlan
    if ($in{'prop'} =~/create_vlan/) {
        $form ="LINK name <input type='text' name='text' value='' style='width: 100px'> ";
        $form.="vlan id <input type='text' name='vlan_id' value='' style='width: 40px'> ";
        $t=$current{'link_phys'}; $t=~s/\t/,/g;
        if ($t eq "") { $t="-none-"; }
        $form.="over ". &select('over',$t);
        $info="<br>Name: lan, wan, san, vlan1,.. <br>$txt{'info_create_vlan'}";
    }
    # create vnic
    if ($in{'prop'} =~/create_vnic/) {
        $form ="LINK name <input type='text' name='text' value='' style='width: 120px; margin-left: 3px'> ";
        $form.="vlan id <input type='text' name='vlan_id' value='' style='width: 40px'>";
        $t=$current{'link_phys'}; $t=~s/\t/,/g;
        if ($t eq "") { $t="-none-"; }
        $form.="over ". &select('over',$t);
        $form.="<br>MAC Addr <input type='text' name='mac' value='' style='width: 120px; margin-left:10px'> empty=random";
        $info="<br>Name: lan, wan, san, vlan1,.. <br>$txt{'info_create_vlan'}";
    }

    #link name
    if ($in{'prop'} =~/LINK/) {
        $form="LINK name $in{'dev'} <input type='text' name='text' value='$in{'link'}' style='width: 100px'> ";
        $opt= "onclick=\"return(confirm('$txt{'changeprop'} LINK name $txt{'of'} $in{'link'}?'))\"";
        $info="$txt{'rename'} link ex e1000g0 $txt{'to'} eth0 $txt{'or'} san0 $txt{'or'} vlan3<br>$txt{'modify_problem'}";
    }


    #ask addr state:
    if ($in{'prop'} =~/ADDRSTATE/) {

      #current=ok
      $p="enable,disable";

      $t="adr_$in{'list'}\_state"; $t=$current{$t};
      if ($t eq "disabled") { $p="enable,delete"; }
      if ($t eq "enable")   { $p="disabled,delete"; }
      if ($t eq "down")     { $p="up,delete"; }
      if ($t eq "ok")       { $p="disable,down,delete"; }


      # up,down,enable,disable

          $form="state = ". &select('text',$p);
          $form.=" temporary <input type='checkbox' name='temp' value='p'> (only up/down)";

          $opt= "onclick=\"return(confirm('modify $in{'list'}?'))\"";
          $info="disable $in{'link'} $txt{'state_disable_info'}";

          $info=~s/=link=/$in{'list'}/gs;
    }

    #ask physical adapter state:
    if ($in{'prop'} =~/\bSTATE/) {

      if ($in{'old'} eq "up") {       #disable/enable
          $form="state = ". &select('text','disable,delete_if');
          $opt= "onclick=\"return(confirm('modify $in{'list'}?'))\"";
          $info="disable $in{'link'} $txt{'state_disable_info'}";
      } else {                        #enable/delete if on phys, enable on logical
          $form="state = ". &select('text','enable,delete_if');
          $info="$txt{'state_enable_info'} $in{'link'}";
      }
      $info=~s/=link=/$in{'list'}/gs;
    }

    #dhcp
    if ($in{'prop'} =~/dhcp/) {
      if ($in{'old'} eq "static") {
        $form="$txt{'set'} $in{'link'} $txt{'to'}: <input type='text' name='text' value='dhcp' style='width: 150px' readonly> ";
        $opt= "onclick=\"return(confirm(\'$txt{'activate'} DHCP $txt{'of'} $in{'link'}?\'))\"";
        $info="$txt{'dhcp_info'}";
      } else {

        $form="$txt{'set'} $in{'link'} $txt{'to'}: <input type='text' name='text' value='static' style='width: 120px' readonly>&nbsp;";
        $opt= "onclick=\"return(confirm('$txt{'activate'} DHCP $txt{'of'} $in{'link'}?'))\"";
        $info="$txt{'dhcp_static_info'}";
      }
    }

    #ip adress
    if ($in{'prop'} =~/ip-adress/) {
        #$r=&systemlib_get_linkdetails("$in{'link'}");        #i,n,m,t


        if (-f '/etc/defaultrouter') {
           $gw=&exe("cat /etc/defaultrouter");
           $gw=~s/^\s.*//s; $gw=~s/\s.*//s;
        } else { $gw=""; }

        #ip
        $t="adr_$in{'list'}\_ip";
        $t=$current{$t};
        if ($t eq "") { $t="192.168.1."; }

        #mask
        $m="if_$in{'list'}\netmask";
        $m=$current{$t};

        if ($m eq "") { $m="255.255.255.0"; }

        if ($t=~/^192\.168/)   { $m="255.255.255.0"; }      # private c
        if ($t=~/^172/)        { $m="255.255.0.0"; }        # private b
        if ($t=~/^10\./)       { $m="255.0.0.0"; }          # private a

        $form="ip-adress&nbsp;<input type='text' name='ip' value=\"$t\" style='width: 120px'> ";
        $form.="netmask  <input type='text' name='mask' value=\"$m\" style='width: 120px'> <br>";
        $form.="gateway&nbsp;&nbsp;&nbsp;<input type='text' name='gateway' value=\"$gw\" style='width: 120px'> ";

        $opt= "onclick=\"return(confirm('change ip-settings of $in{'link'}?'))\"";
        $info=$txt{'set_ip_info'};
    }

    #mto state  1500 or 9000
    if ($in{'prop'} =~/mtu/) {
        $r=&exe("dladm show-linkprop $in{'link'} | grep mtu");        #link property perm value default possible
        $r=~s/\s+/\t/g;
        @t=();
        @t=split(/\t/,$r);
        $form="mtu $in{'link'}: <input type='text' name='text' value=\'$t[3]\' style='width: 150px'> ";
        $opt= "onclick=\"return(confirm('change mtu of $in{'link'}?'))\"";
        $info="possible values: $t[5]<br><pre>$txt{'mtu_info'}</pre>";
    }


     ### form ###
     $ask=&ask_pop("$form","$info","$opt");
     return ($ask);
 }




########## snaps ######

##########################  sorted list of root snaps parameter -> return sorted list
sub systemlib_rootsnaps {       #hide:
####################

  my ($r,@s,$d,$n,@n);
  if ($_[0] eq "") {
    $r="SNAP\tDATE\tSTATUS\n";
  }
  $r.=&exe('apt-clone -list');

  # A C  name
  # o o  rootfs...
#&mess($r);

    @s=split(/\n/,$r);
    foreach $t (@s) {
     $d="1";

     if ($t=~/^o /)    { $t.="\t<b class=\"font_darkred\">active=bootdefault</b>";    $d="0"; }    # active
     if ($t=~/^o* +o/) { $t.="\t<b class=\"font_darkred\">current</b>";       $d="1"; }    # current

     $t=~s/^o* +o* +//;
     $t=~s/^ +//;
     $t=~s/^A .*//;

     if ($d)  {
           $t.=" $_[0]";           # option
     }

     $t=~s/\[/\t\[/;
    #$t=~s/\] //g;

     if ($t=~/\d|SNAP/) { push (@n,$t); }
  }

  @n=sort(@n);

  #test
  #push (@n,$r);
  #print_array(@n);

  return (@n);
}


 ################### delete rootfs parameter name, cannot be active or current
sub systemlib_activate_sys_snap {     #hide:
#######################
  my ($r,@s,$d,$n);

  ########## delete was called ######################
    if ($in{'delrootsnap'}=~/rootfs.*/) {
       $n=&exe("apt-clone -a $in{'delrootsnap'} -y ");
       if ($n ne "") { print " apt-clone -r $in{'delrootsnap'}<br>$n<br><br>"; }
    }
  ####################################################


  #1. print list if snaps

  $url=" \t\t<a class='font_darkred' style='font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;delrootsnap==f=\" onclick=\"return(confirm('activate system snap =f= ?'))\">activate</a>";

  print "<b>Activate System Snapshot: </b>";

  @s=&systemlib_rootsnaps('=do=');;
  foreach $t (@s) {
          $n=$t; $n=~s/ .*//;
          if (!($t=~/active/)) {
             $t=~s/=do=/$url/;
          } else {
             $t=~s/=do=//;
          }
          $t=~s/=f=/$n/g;
  }

  $r=join("\n",@s);
  $r=&list2table($r);
  print "<pre class='tt'>$r</pre></body></html>";
return;
}

################### delete rootfs parameter name, cannot be active or current
sub systemlib_del_sys_snap {          #hide:
#######################
  my ($r,@s,$d,$n);

  ########## delete was called ######################
    if ($in{'delrootsnap'}=~/rootfs.*/) {
       $n=&exe("apt-clone -r $in{'delrootsnap'} -y ");
       if ($n ne "") { print " apt-clone -r $in{'delrootsnap'}<br>$n<br><br>"; }
    }
  ####################################################


  #1. print list if snaps

  $url=" \t<a style='color:red; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;delrootsnap==f=\" onclick=\"return(confirm('delete system snap =f= ?'))\">delete</a>";

  print "<b>Delete System Snapshot: </b>";
  print " <b style='color:red'>be careful!</b>";

  @s=&systemlib_rootsnaps('=do=');;
  foreach $t (@s) {
         $n=$t; $n=~s/ .*//;
         $t=~s/=do=/$url/;
         $t=~s/=f=/$n/g;
  }

  $r=join("\n",@s);
  $r=&list2table($r);
  print "<pre class='tt'>$r</pre></body></html>";
return;
}


# end of file
##############
1;