# job functions for napp-it    Copyright (c) 2009-2013 Gnther Alka
################################
# functions are autoloaded if action contains &thislib_xx() ex &zfslib_list() will autoload zfslib via require


#########
sub userlib {  # 06.06.2013
###########################
}

####################
sub userlib_del_map {
####################
  my ($r);
  my $m=$in{'sel_map'};
  $m=~s/\.\+$//;
  if ($m eq "") { return; }             # nothing selected

  my @m=split(/\.\+/,$m);
  foreach my $t (@m) {
     print &exe("idmap remove \'$m\'")."<br>";
  }
  sleep(2);
  return;

&print_array(@m);
&print_hash(%in);

}

########################
sub userlib_idmap_overview {
########################
       my ($r,$i,@i,@v,$v,$l,@l);

       my $url="<a title='add idmapping' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;prop==prop=\">=text=</a>";
       my $sel="<input type=\"checkbox\" name=\"sel_map\" value=\"Z.+\">";

       #set property -> answered
       if ($in{'answered'}) {
            if ($in{'submit_ok'} eq "delete selected") {
                 &userlib_del_map;
            } else {
                 # add idmap
                 &userlib_change_property;
            }
       }


       print "<br><br><b>SMB-Unix Idmapping</b>";
       $r=&exe("idmap list");

       # add [-d] win/unixuser:..  unix/winiuser:..

       #rearrange
       @l=split(/\n/,$r);
       foreach $l (@l) {
          $l=~s/  +/\t/g;
          @v=();
          @v=split(/\t/,$l);   # =>, smb, unix

          # unixuser = winuser
          $v[4]="= ";

          if ($v[0] =~/\-d/) {
               $v[4]="=>";
          }

          if ($cfg{'ver'}=~/c|a/) {
           $t=$sel;
           $t=~s/Z/$v[1]/;
          } else {
           $t="";
          }

          $i="$v[1]\t$v[4]\t$v[2]\t$t\t&nbsp;";
          $i=~s/\"//g;
          push(@i,$i);

       }
       @i=sort(@i);

       $t=$url; $t=~s/=prop=/add-idmapping/; $t=~s/=ask=//; $t=~s/=text=/add idmapping/;
       if ($cfg{'ver'}=~/c|a/) { push(@i,"<br>++ $t"); } else { push(@i,"<br>use acl extension or CLI to edit"); }  # add idmap

       $i=join("\n",@i);

       # del selected
       if ($cfg{'ver'}=~/c|a/) {
       &ask('begin_sel');
       print "\n<div id='chb'>\n";   # select all input
       }

       if (@i ==1) {          # only add
            $i="-none-\n$i";
       } else {
            $t="<b>Map user/group</b>\t<b>=/=></b>\t<b>to user/group</b>";
            if ($cfg{'ver'}=~/c|a/) { $t.="\t<input type='checkbox' style='margin:0 0 0 4px' onclick='toggleChecked(this.checked)'>\t&nbsp;"; }
            $i="$t\n$i";

       }



       print &list2table($i);

###############################
       if ($cfg{'ver'}=~/c|a/) {
       print "</div><br>\n"; # /chb      #/del
       &ask('confirm','delete selected','delete selected mappings?');
  # js for select all
  print <<EoF;
  <script type="text/javascript">
      function toggleChecked(status) {
      \$(".checkbox").each( function() {
      \$(this).attr("checked",status);
      })
      }

      function toggleChecked(status) {
      \$("#chb input").each( function() {
      \$(this).attr("checked",status);
      })
      }
</script>

EoF
}
#############################



       # popup/ edit-window
       if ($in{'prop'} eq "add-idmapping")  {
              &userlib_ask_property;
       }
       print "<div class='info'><pre>$txt{'user_idmap_add'}</pre></div> <br><br><br>";

}

#######################
 sub userlib_linuxuser_overview {                    # print group overview (smb-groups only)
############### print overview if user
    my ($n,$r,$s,$t,@l,@u,$u,@w,$out,$url,$ask,@g,$g,@m,$m,$i,@lu);

    #hide user:
    my $hide=",admin,avahi,mysql,nfs,napp-it,";                         # hide user ex ",a,b,c," -> comma at begin and end!!

    # do not offer delete
    my $noedit=",admin,root,";

    #header of list
    $u[0]="<b>smb-user names</b> \tuserid \tgroupid \tgroupname \tunix-info \tpassword\toption";

    @w=&userlib_get_my_user('a');                  # smb user
#&print_array(@w);

    foreach $t (@w) {
       $u=$t; $u=~s/\s.*//;
       if ($hide=~/,$u,/) { next; }                #hide user
       push (@u,$t);
    }
#&print_array(@u);

    #set property -> answered
            if ($in{'answered'}) { &userlib_change_property; }

    #delete -> answered
            if ($in{'old'} ne "") { &userlib_change_property; }

    #url
    $url="<a title='=title=' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action==action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list==list=\&amp;prop==prop=\&amp;old==old=\"=ask=>=text=</a>";
    $ask=" onclick=\"return(confirm('=ask2=?'))\"";


#&print_hash(%current);
#&print_array(@u);

    foreach $u (@u) {                              # smb user

        if ($u=~/\t/) { next; }                    # headline

        @w=();

        #0 name
               $w[0]="$u";

        # 1 uid
                $t=$u."_uid";
                $w[1]=$current{$t};

        # 2 member of unix-group                   #
                $t=$u."_gid";
                $w[2]=$current{$t};

        # 3 unix-group name                   #
                $t=$w[2]."_gid2name";
                $w[3]=$current{$t};

        # 4 info
                $t=$u."_c";
                $w[4]=$current{$t};

        # 5 set pw
                  if ($noedit=~/,$w[0],/) {
                        $w[5]="use passwd";
                  } else {
                      $r=$url;
                      $n="set pw for $w[0]";
                        $w[5]=$url;
                        $w[5]=~s/=text=/$n/;
                        $w[5]=~s/=prop=/set-userpw/;
                        $w[5]=~s/=title=/$n/;
                        $w[5]=~s/=old=//;
                        $w[5]=~s/=ask=//;
                        $w[5]=~s/=action=/set_pw/;
                        $w[5]=~s/=list=/$w[0]/;
                  }
                $t=join("\t",@w);

        # 8 option delete
             if ($noedit=~/,$w[0],/) {
                       $w[6]="-"
             } else {

                        $r=$url;
                        $n="delete user";
                        $w[6]=$url;
                        $w[6]=~s/=text=/$n/;
                        $w[6]=~s/=title=/$n $w[0]/;
                        $w[6]=~s/=prop=/del-user/;
                        $w[6]=~s/=old=/$w[0]/;
                        $w[6]=~s/=ask=/$ask/;
                        $w[6]=~s/=ask2=/delete user $w[0]?/;
                        $w[6]=~s/=list=/$w[0]/;

             }

             #wg sort (++ last entry)
             $w[0]=" $w[0]";
             $u=join("\t",@w);

    }
#&print_array(@u);

    #add new user
                $r=$url;                        #intarectiv add user -> expect-module, next version
                $r=~s/=text=/add local user/;
                $r=~s/=title=/add local user/;
                $r=~s/=list=//;
                $r=~s/=prop=/add-smbuser/;
                $r=~s/=action=/add-smbuser/;
                $r=~s/=old=//;
                push(@u,"<br>++ $r");


    $out=join("\n",@u);

    #show as table
    $out=&list2table($out,'100%,180px,70px,70px,70px,150px,110px,110px','');
    #print "<pre class='tt'>$out</pre><div class='info'>$txt{'user_info'}</div>";
    print "<b>Local User with SMB password</b><br>$out<div class='info'><pre>$txt{'user_info'}</pre></div>";

    #popup/ edit-window
    if (($in{'action'} eq "add-smbuser") || ($in{'action'} eq "set_pw")) {
              &userlib_ask_property;
    }

    return;


}

##################
sub userlib_setpw {    #name, pass
###################
        # join domain via Expect
        print "set pw at console";
        sleep(3);

        
}

###############
sub userlib_get_my_user {        # return str of my SMB users
######################
    my ($r,$s,$t,@l,@u,@m,$m);
    $m=&exe("pdbedit -L -v | grep 'Unix username'");               # all user with smb pass
    @m=split(/\n/,$m);
    foreach $m (@m) {
              # Unix username:  username
              $m=~s/Unix username: +//;
              push (@u,$m);
    }

    @u=sort(@u);
    $current{'smbuser'}=join("\t",@u);                           # smbuser

    # add unix infos
    $r=&exe('cat /etc/passwd');
    @l=split(/\n/,$r);
    foreach my $l (@l) {
            @m=();
            @m=split(/:/,$l);   # name x uid gid c home shell

            $t=$m[0]."_uid";    $current{$t}=$m[2];
            $t=$m[0]."_gid";    $current{$t}=$m[3];
            $t=$m[0]."_c";      $current{$t}=$m[4];
    }

    # add groupinfo
    # add unix infos
    $r=&exe('cat /etc/group');
    @l=split(/\n/,$r);
    foreach my $l (@l) {
            @m=();
            @m=split(/:/,$l);   # name x gid

            $t="$m[0]"."_name2gid"; $current{$t}=$m[2];
            $t="$m[2]"."_gid2name"; $current{$t}=$m[0];

    }

    $r=join("\n",@u);
    if ($_[0] eq "a") { return (@u); }                  # return my user as array
    return ($r);                                        # return my user as string
}

 ######################
 sub userlib_change_property {                 #hide:
 #######################    set zfs details
 my ($r,$s,$t,$do,$h,$u,$g);


 #### create user
 ###################

  if ($in{'action'} eq "add-smbuser") {
       $do="1";
       $u="";
       print "please wait..\n";

        #parse input
        #$in{'text'}=~tr/A-Z/a-z/;  # A.. erlaubt

         $in{'text'}=~s/[^A-Za-z0-9\.\-\_ ]//g;  # space erlaubt
         $in{'text'}=~s/  +/ /g;             # only single space
         $in{'text'}=~s/^\s+//g;
         $in{'text'}=~s/\s+$//g;

         $in{'pw'}=~s/\s//g;

        $in{'pw2'}=~s/\s//g;
        if ($in{'pw2'} ne $in{'pw'}) { &mess($txt{'repeat_pw_err'}); }

        $in{'uid'}=~s/\D//g;
        if ($in{'uid'} ne "") {
            # if ($in{'uid'} < 100) { &mess('please use a UID > 100'); }     # allow creation of system user
            $u=" -u $in{'uid'}";
        }

        if ($in{'text'} eq "") { &mess('please enter a valid username [Aa-z,0-9.-_ ]'); }

        #group
        $in{'gid'}=~s/ +//g;
        $g="staff";

        if ($in{'gid'} ne "") {
           $g=$in{'gid'};
        }

       # 1. useradd, nur user, keinen ordner in /export
       # `adduser napp-it --shell /bin/false --no-create-home --disabled-password --gecos ''
       #     $r=&exe("useradd -g $g$u -c \'$in{'info'}\' -s /bin/false \'$in{'text'}\'");

       $r=&exe("useradd -g $g$u -c \'$in{'info'}\' -s /bin/false --no-create-home \'$in{'text'}\'");

            if ($r ne "") {
          #       if (!($r=~/should be/))  {
                     &mess($r);                            # erromess with 'Peter Paul' but ok
           #      }
            }

 #&print_hash(%in);
        # 2. set pw
             sleep(2);
             &userlib_setpw("\'$in{'text'}\'","$in{'pw'}");


        $in{'action'}="";
        &reload;
  }

 #### delete local user
 ##########
  if ($in{'prop'} eq "del-user") {
       $do="1";
       print "please wait..\n";

               # disable ??
               $r.=&exe("smbpasswd -d \'$in{'old'}\'");

               # delete
               $r.=&exe("smbpasswd -x \'$in{'old'}\'");

               $r.=&exe("deluser \'$in{'old'}\'");
               print "$r<br>";

               sleep(2);
        &reload;
  }


 #### set user-pw
  if ($in{'action'} eq "set_pw") {


        $in{'pw'}=~s/\s//g;
        $in{'pw2'}=~s/\s//g;
        if ($in{'pw2'} ne $in{'pw'}) { &mess($txt{'repeat_pw_err'}); }

            &userlib_setpw("\'$in{'list'}\'","$in{'pw'}");

            $in{'action'}="";
            &reload;
  }


#&mess('ok');
} #/sub


#######################
sub userlib_ask_property {        #hide:
#######################

    my ($ask,$close,$form,$info,$t,$opt,$r,$do,$hn);
    $close="<a href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list=$in{'list'}\&amp;zfs=$in{'zfs'}\"><b>$txt{'cancel'}</b></a>";

    #add local user
    if ($in{'action'} eq "add-smbuser") {
        $do="1";
        $form="username $in{'list'}\: <input type='text' name='text' value='' style='width: 120px'> Info:  <input type='text' name='info' maxlength='20' value='' style='width: 120px; margin-left:5px'> <br>";
        $form.="set UID: <input type='text' name='uid' maxlength='20' value='' style='width: 120px; margin-left:17px'> ";
        $form.="GID: <input type='text' name='gid' maxlength='20' value='' style='width: 120px;margin-left:9px'> option<br>";
        $form.="password:&nbsp; <input type='password'  maxlength='16' name='pw' value='' style='width: 120px'> again: <input type='password'  maxlength='16' name='pw2' value='' style='width: 120px'> $txt{'repeat_pw'}";

        $info="name: A-Z,a-z,0-9,-\<br>$txt{'user_user_add'}<br><br>UID/GID settings are optionally used for NFS compatibility otherwise keep empty";
        $info.="<br>Idmap problem: <font style='color:red'>never reuse a UID</font> or a new user may appear as the deleted user from Windows";
    }

    #set userpw
    if ($in{'action'} eq "set_pw") {
        $do="1";
        $form="set pw of user $in{'list'}\: <br><input type='password' name='pw' value='' maxlength='16' style='width: 130px'> $txt{'repeat_pw'}: <input type='password' name='pw2' value='' maxlength='16' style='width: 130px'>";
        $info="$txt{'user_setpw'}";
    }

    #add local group
    if ($in{'action'} eq "add-smbgroup") {
        $do="1";

        $form="add smb+unix group <input type='text' maxlength='8' name='text' value='' style='width: 130px'>";
        $form.="&nbsp;description:&nbsp;<input type='text' name='desc' value='' style='width: 130px'>";
        $info="$txt{'user_smbgroup_add'}";
    }

    #add smb group-member
    if ($in{'action'} eq "add-smb_groupmember") {
        $do="1";
        $hn=&exe('hostname'); $hn=~s/\s+$//;
        $form="add member to group $in{'prop'} <input type='text' name='text' value='' style='width: 150px'>";
        $info="<br> $txt{'user_smbgroup_addmember'}<br>";
    }

    #add idmapping, use prop
    if ($in{'prop'} eq "add-idmapping") {
        $do="1";

        $form="add idmap ". &select('type1','winuser,wingroup,unixuser,unixgroup') ."<input type='text' name='text1' value='' style='width: 130px'> ";
        $form.=&select('dir','=>,=')." <input type='text' name='text2' value='' style='width: 130px'> ";
        $info="<pre>$txt{'user_idmap_add'}</pre>";
    }


     ### form ###
     if ($do) {
        print &ask_pop("$form","$info","$opt");
     }


} #/sub

#################
 sub userlib_unixgroup_overview {            # print group overview (unix-groups only)
 ############### print overview if user zfs
    my ($group,@z,@u,$url,$u,$n,$r,@w,@g,$p);

    push(@g,"<b>Unix-groups</b>\t<b>group-id</b>\t<b>members</b>");

    #get groups
    $group=&exe("cat /etc/group");                #ex root:x:2:
    chomp($group);
    @z=split(/\n/,$group);
    foreach $t (@z) {
        #remove all after last :
        $p=rindex($t,":");
        $t=substr($t,0,$p);
        $t=~s/\:.*\:/\t/;
    }

    # get userinfo
    $r=&exe("cat /etc/passwd");                   #members of group
    @u=split(/\n/,$r);

    foreach $t (@z) {                             # all groups
        chomp($t);
        $p=$t; $p=~s/\s+$//; $p=~s/.*\s//;        # groupid

        $t.="\t";
        foreach $u (@u) {
                 @w=();
                 @w=split(/:/,$u);               # name x uid gid
                 if ($w[3] eq $p) { $t.="$w[0], ";}
        }
        $t=~s/, $//;
        push (@g,$t);
    }
    $out=join("\n",@g);
    #&print_array(@g);

    #show as table
    $out=&list2table($out,'','sort2');
    print "<pre class='tt'>$out</pre>";
    print "\n</body></html>";
    return;

 }



#EoF ######################
# do not remove line below (return true)
1;
