#!/usr/bin/perl
## shebang needed only for tests !! calling only via cron perl auto.pl not via cgi !!
## auto.pl  parameter opt jobid -> run now

## (c) Gnther Alka  2010-2020
# 17.6.16      enable job templates
# 27.6. create /tmp/nappit when missing
# 10.11.2017 report
# 22. mar 18 secure tmp 49
# 23. dec 2018 every/n1;n2 (every but n1 or n2)
# 19. feb 2020 every 2|3 (thangs chris)

# this script is called from cron (root) every 1/15 minutes
# it will then read all jobs in /_log/jobs
# and execute sub auto_job from file job.pl , if job is planned now




#define global var and settings
       use strict;
       use vars qw(@j $p @w $par $os $auto_os $path $logpath $log $date_all $ydat $date_us $date_and_time $isdst $sec $min $hour $mday $mon $year $wday $dow $date $t $f @t %t @m %m $r %zfs %sys %cfg %current %disk %txt);

       $par=$ARGV[0];
       if (!(defined($par))) { $par=""; }


####### presets

use lib "/var/web-gui/data/napp-it/CGI";
use Fcntl qw(:flock);                                                               # filelocking
$|=1;                                                                               # keine Pufferung, no buffering

       $log="/var/web-gui/_log/auto.log";
       `touch $log`;


         if (!(-d '/tmp/nappit')) {  mkdir ('/tmp/nappit');  }                       #logfolder


       $f=`uname -a`;
       if ($f=~/Linux/){
          $f="linux";
          `chmod 666 $log`;

       } else {
           $f="illumos";
           `/usr/bin/chmod 666 $log`;

           # secure tmp is done in admin.pl
           # `/usr/bin/chmod -R 700 /tmp/nappit`;


           # copy pool templates over fo HA configs, keep last local setting from active head
           # obsolete with cluster-control

       }


       $t="/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";
       require "$t";
       &getdate;

        #require jobs.lib
                $t=$0;
                $t="/var/web-gui/data/napp-it/zfsos/_lib/$f/jobslib.pl";                    # require zfs-lib
                require "$t";                                                                       #require jobs-lib


        #require zfs_lib
                $t="/var/web-gui/data/napp-it/zfsos/_lib/$f/zfslib.pl";                                # require zfs-lib
                require "$t";

        #require group_lib
                $t="/var/web-gui/data/napp-it/zfsos/_lib/$f/grouplib.pl";                                # require zfs-lib
                require "$t";

        #require tmp folder
               if (!(-d '/tmp/nappit')) { mkdir('/tmp/nappit'); }


#months
        @m=();
        @m=('','jan','feb','mar','apr','may','jun','jul','aug','sep','oct','nov','dec');

##os info
     &get_os;
     &getp;
     #&getmydate;



#lets do
     &look_for_jobs;
exit;


###############
sub my_jobpar {
###############
   # par str
   my $data=$_[0];
   %current=();
   my ($v,@v);
   my @data=split(/\n/,$data);
   foreach my $l (@data) {
           @v=();
           @v=split(/=/,$l);
           if (($v[0] ne "") && ($v[1] ne "")) {
               $current{$v[0]}=$v[1];
           }
   }
}



###################
sub look_for_jobs {
###################
  my ($r,$logf,@w,$id,$t,$tmp,$err,$last,$job,@plus,$m,$h,$d,$mo,$time,$no);

  #read all jobs
  #get path to logfolder  napp-it/_log/jobs/
  $logf="/var/web-gui/_log/jobs/";

  @m=();
  &read_dir($logf,'m','\.par$');

  foreach $job (@m) {

         #no job
         if (!($job=~/\.par$/)) { next; }

         &getmydate;

         $id=$job;
         $id=~s/\..*//;

         # jobpar
         ########
         $t=`cat $logf$job`;
         &my_jobpar($t);

         #status
         #######
         if ($current{'status'} ne 'active') {
              #&autolog("job $id status: $current{'status'}");
              next;
         }

         #check repli
         if (($current{'job'}=~/repli/) && (!($cfg{'ver'}=~/c|r/))) {
             &autolog(" job $job replicate not auto-executed: - valid replication extension required");
             next;
         }

         #check report
         if (($current{'job'}=~/report/) && (!($cfg{'ver'}=~/\w/))) {
             &autolog(" job $job replicate not auto-executed: - napp-it Pro required");
             next;
         }

          #this month: every or 3 or 4;7  (4 and 7) or every-n
                $mo=$mon; $mo=~s/^0+//; if ($mo eq "") { $mo="0"; }
                if (! (($current{'month'}=~/\b$mo\b/) || ($current{'month'} =~/every/)) )   { next; }

          ##month every-(2,3,4,6)
                if (($current{'month'}=~/every\-2/) && (!(",2,4,6,8,10,12,"=~/,$mo\,/)) )   { next;  }
                if (($current{'month'}=~/every\-3/) && (!(",3,6,9,12,"=~/,$mo\,/)) )        { next;  }
                if (($current{'month'}=~/every\-4/) && (!(",4,8,12,"=~/,$mo\,/)) )          { next;  }
                if (($current{'month'}=~/every\-6/) && (!(",6,12,"=~/,$mo\,/)) )            { next;  }


         # monthy every/n1;n2 -> every not n1 or n2
                $no=0;
                if ($current{'month'}=~/every\/\d/) {
                   $t=$current{'month'};
                   $t=~s/every\///;  # n1 or n1;n2;..
                   @w=();
                   @w=split(/;/,$t);
                   foreach my $w (@w) {
                     if ($mon==$w)  {
                        &autolog("job $id\: skip month $w auto $current{'job'}");
                        $no=1;        # not in this month
                     }
                   }
                }
                if ($no)   { next; }  # skip

         #this day: mon, every
                $dow=&getmydow;
                if ($current{'day'} =~/^\w\w\w$/) {                                          # mon, tue,..
                        if (!($current{'day'} eq "$dow"))  { next; }
                }

         # day 3 or 4-7 (4 plus 7)
                if ($current{'day'}=~/\d/) {
                        $d=$mday; $d=~s/^0+//; if ($d eq "") { $d="0"; }
                        if (! (($current{'day'}=~/\b$d\b/) || ($current{'day'} =~/every/)) ) { next; }
                }

         ##day every-(2,3,7,14)
                if (($current{'day'}=~/every\-2/)  && (!(",2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,"=~/,$d\,/)) )   { next;  }
                if (($current{'day'}=~/every\-3/)  && (!(",3,6,9,12,15,18,21,24,27,30,"=~/,$d\,/)) )    { next;  }
                if (($current{'day'}=~/every\-7/)  && (!(",7,14,21,28,"=~/,$d\,/)) )                    { next;  }
                if (($current{'day'}=~/every\-14/) && (!(",14,28,"=~/,$d\,/)) )                         { next;  }

         # day every/n1;n2 -> every not n1 or n2
                $no=0;
                if ($current{'day'}=~/every\/\d/) {
                   $t=$current{'day'};
                   $t=~s/every\///;  # n1 or n1;n2;..
                   @w=();
                   @w=split(/;/,$t);
                   foreach my $w (@w) {
                     if ($mday==$w)  {
                        &autolog("job $id\: skip day $w auto $current{'job'}");
                        $no=1;        # not in this day
                     }
                   }
                }
                if ($no)   { next; }  # skip

         # mon-fri, mon-sat, sat-sun, first-sun, first-sat
               if (($current{'day'} eq "mon-fri") && (!("mon,tue,wed,thu,fri"=~/$dow/)) )                { next;  }
               if (($current{'day'} eq "mon-sat") && (!("mon,tue,wed,thu,fri,sat"=~/$dow/)) )            { next;  }
               if (($current{'day'} eq "sat-sun") && (!("sat,sun"=~/$dow/)) )                            { next;  }
               if ($current{'day'} eq "first-sun") {
                     if ($dow ne "sun")        { next;  }
                     if ($mday > 7)            { next;  }        #7
               }
               if ($current{'day'} eq "first-sat") {
                     if ($dow ne "sat")        { next;  }
                     if ($mday > 7)            { next;  }
               }

         #this hour: every or 3 or 4-7 (4 plus 7)
                $h=$hour; $h=~s/^0+//; if ($h eq "") { $h="0"; }
                if (! (($current{'hour'}=~/\b$h\b/) || ($current{'hour'} =~/every/)) ) { next; }

         #hour every-(2,3,4,6,12)  opt (ABCD) in min and hour see after min
                if (($current{'hour'}=~/every\-2/) && (!(",0,2,4,6,8,10,12,14,16,18,20,22,"=~/,$h\,/)) )   { next;  }
                if (($current{'hour'}=~/every\-3/) && (!(",0,3,6,9,12,15,18,21,"=~/,$h\,/)) )              { next;  }
                if (($current{'hour'}=~/every\-4/) && (!(",0,4,8,12,16,20,"=~/,$h\,/)) )                   { next;  }
                if (($current{'hour'}=~/every\-6/) && (!(",0,6,12,18,"=~/,$h\,/)) )                        { next;  }
                if (($current{'hour'}=~/every\-12/) && (!(",0,12,"=~/,$h\,/)) )                            { next;  }

         # hour every/n1;n2 -> every not n1 or n2
                $no=0;
                if ($current{'hour'}=~/every\/\d/) {
                   $t=$current{'hour'};
                   $t=~s/every\///;  # n1 or n1;n2;..
                   @w=();
                   @w=split(/;/,$t);
                   foreach my $w (@w) {
                     if ($hour==$w)  {
                       &autolog("job $id\: skip hour $w auto $current{'job'}");
                       $no=1;        # not in this hour
                     }
                   }
                }
                if ($no)   { next; }  # skip

         # ABCD in hour
                my $ok="";
                if ($current{'hour'}=~/A/) {
                  if (",0,1,2,3,4,5,"=~/,$h\,/)          { $ok.="1";  }  else { $ok.="0"; }
                }
                if ($current{'hour'}=~/B/)  {
                  if (",6,7,8,9,10,11,"=~/,$h\,/)        { $ok.="1";  }  else { $ok.="0"; }
                }
                if ($current{'hour'}=~/C/)  {
                  if (",12,13,14,15,16,17,"=~/,$h\,/)    { $ok.="1";  }  else { $ok.="0"; }
                }
                if ($current{'hour'}=~/D/)  {
                  if (",18,19,20,21,22,23,"=~/,$h\,/)    { $ok.="1";  }  else { $ok.="0"; }
                }

                if ($ok ne "") {
                    if (!($ok=~/1/)) { next; }
                }
                ################

                ## once or every n  minutes
                if ($current{'min'} eq "once") {
                     if (-f "/tmp/$id.once") {  next; }
                     `touch /tmp/$id.once`;
                } else {
                    #this min: every or 15 or 15-30 (15 plus 30)
                    $m=$min; $m=~s/^0+//; if ($m eq "") { $m="0"; }
                    if (! (($current{'min'}=~/\b$m\b/) || ($current{'min'} =~/every/)) ) { next; }
                }

                ##min every-(2,3,5,10,15,30)
                if (($current{'min'}=~/every\-2\b/) && (!(",0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34,36,38,40,42,44,46,48,50,52,54,56,58,"=~/,$m\,/)) )   {  next;  }
                if (($current{'min'}=~/every\-3\b/) && (!(",0,3,6,9,12,15,18,21,24,27,30,33,36,39,42,45,48,51,54,57,"=~/,$m\,/)) )   { next;  }
                if (($current{'min'}=~/every\-5/) && (!(",0,5,10,15,20,25,30,35,40,45,50,55,"=~/,$m\,/)) )   { next;  }
                if (($current{'min'}=~/every\-10/) && (!(",0,10,20,30,40,50,"=~/,$m\,/)) )   { next;  }
                if (($current{'min'}=~/every\-15/) && (!(",0,15,30,45,"=~/,$m\,/)) )         { next;  }
                if (($current{'min'}=~/every\-20/) && (!(",0,20,40,"=~/,$m\,/)) )            { next;  }
                if (($current{'min'}=~/every\-30/) && (!(",0,30,"=~/,$m\,/)) )               { next;  }


                ####
                # min every/n1;n2 every not n1 or n2
                $no=0;
                if ($current{'min'}=~/every\/\d/) {
                   $t=$current{'min'};
#print "cmin: $t in min $min\n";
                   $t=~s/every\///;  # n1 or n1;n2;..
                   @w=();
                   @w=split(/;/,$t);
                   foreach my $w (@w) {
                     if ($min==$w)  {
#print "skip: $w\n";
                         &autolog("job $id\: skip min $w auto $current{'job'}");
                         $no=1;        # not in this min
                     }
                   }
                }
                if ($no)   { next; }  # skip

#if ($id=~/106/) {
#&autolog("job $id\: xxxx start auto $current{'job'}");
#}
#print "start auto $current{'job'} $id\n";

           my $time=time();
           &autolog("job $id\: start auto $current{'job'}");

           ## request job
                 $t=$current{'job'};
                 open (PF, ">/tmp/nappit/job-$t\_$id.request");          # ex ex /tmp/nappit/job-scrub_1350378156.request
                       flock(PF, LOCK_EX);
                       print PF "run_$id $time";
                 close (PF);
                 if (-f "/tmp/nappit/job-$t\_$id.cancel")  { `rm /tmp/nappit/$id.cancel`; }     # del last cancel req

   }
   exit;
   #/ look for jobs

}

#########
sub autolog {
########
  my (@data,$log,$t,$info);
  my $info=$_[0];        # log text

  $log="/var/web-gui/_log/auto.log";                                      # $path = path to ../napp-it/_log/


  #log newest at top
  ###################
  open (F,"<$log");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);

  #unshift   $l=ok/error
  unshift(@data,"$date_all\: $info\n");

  if (@data > 100) {
             $t=@data-100;
             splice(@data,100,$t);
  }

 $t=join("",@data);
 open (PF, ">$log");
    flock(PF, LOCK_EX);
    print PF "$t";
 close (PF);
 return;
}



sub getmydate {                # setzt datumsvariablen
###########
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 $mon++;
 if ($sec < 10) { $sec = "0$sec"; }
 if ($min < 10) { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10) { $mon = "0$mon"; }
 $year=1900+$year;
 $date_and_time = "$mday\.$mon\.$year, $hour:$min $sec s";
 $date = "$mday\.$mon\.$year";
 $date_us= "$mon\.$mday\.$year";
 $date_all="$year\.$mon\.$mday\.$hour\.$min\.$sec";
}

############# dow of today
sub getmydow {
#day of week (tt.mm.jjjj)
 my $day="$mday.$mon.$year";

 my @day = ("sun","mon","tue","wed","thu","fri","sat");
 my @d = (0,3,2,5,0,3,5,1,4,6,2,4);
 my @tmp;
 @tmp=split(/\./,$day);
 my $t=$tmp[0];
 my $m=$tmp[1];
 my $j=$tmp[2];
 if ($j < 100) { $j =2000+$j; }
 if ($m < 3) { $j-- ; }
 $tmp[3] = $day[($j+int($j/4)-int($j/100)+int($j/400)+$d[$m-1]+$t) % 7];
 return ($tmp[3]);
}

###############################################
#end of my script, do not delete the line below
