#!/usr/bin/perl

use Fcntl qw(:flock);                                                               # filelocking
$|=1;                                                                               # keine Pufferung, no buffering

## longterm-log
## start this script once every minute as an "other job"
#
# /tmp/arcstat.log and
# /tmp/iostat.log and
# /tmp/zilstat.log

# source:
$source1="/tmp/arcstat.log";
$source2="/tmp/iostat.log";
$source3="/tmp/zilstat.log";

# targetfolder/ (folder must exist, must end with / )
$targetfolder="/var/web-gui/_log/tmp/";

&my_date;       # get datevalues

# main
if (!(-d $targetfolder)) { print "targetfolder is missing!"; exit; }
##


&my_append($source1);
&my_append($source2);
&my_append($source3);


exit;

#################################################### end main ########
sub my_append {
##############
  $from=$_[0];
  if (!(-f "$from")) { print "file is missing!"; exit; }

  @data=();
  open (F,"<$from");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);

  $from=~s/.*\///;              # filename only
  $to="$targetfolder"."$date_log\_$from";

  #print "$to\n";
  
  open (PF, ">>$to");
    flock(PF, LOCK_EX);
    print PF "\n--- $date_and_time ---\n\n";
    foreach my $l (@data) {
       print PF "$l";
    }
    print PF "\n\n";
  close (PF);
}




#####
sub my_date {
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 $mon++;
 if ($sec < 10) { $sec = "0$sec"; }
 if ($min < 10) { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10) { $mon = "0$mon"; }
 $year=1900+$year;
 $date_and_time = "$mday\.$mon\.$year, $hour:$min $sec s";
 $date = "$mday\.$mon\.$year";
 $date_us= "$mon\.$mday\.$year";
 $date_all="$year\.$mon\.$mday\.$hour\.$min\.$sec";
 $date_log="$year\.$mon\.$mday\.$hour";
}