  #!
# (c) Guenther Alka 2020

# minio lib contains functions for minio
# 04. sep 2020

use strict;  #disable when calling direct


#####
sub call_mc {     #
#####
my ($r,$opt,$ex,$mc,$http,$d,$fs);&my_c;

$opt=$_[0];
$fs=$in{'autoselect_s3'};             # server instance
$fs=~s/.*server +//;
$fs=~s/\/S3_data.*//;  # remain zfs filesystem

# config location
$r=`sudo /sbin/zfs get -H -o value s3_config: $fs`;   chomp($r);    # ex pool/s3
if ($r=~/\/\w/) {
    $t=$fs; $t=~s/\//~/g;
    $d="$r/S3_keydata/$t";   # pool~data/s3keydata
    if ("/$r" eq $fs)  {
       $d="$fs";             # config in filesystem
    }
} else {
    $d="$fs";
}
my $port=`sudo cat $d/S3_config/address.txt`;      # ex :9000
$port=~s/.*://;
my $user=`sudo cat $d/S3_config/key.txt`;          # ex :usr1
my $pw=`sudo cat $d/S3_config/secret.txt`;         # ex 12345678
chomp($port); chomp($user); chomp($pw);

 $r=`sudo test -f "/var/web-gui/_log/minio/public.crt" && echo 1 || echo 2`;  chomp($r);
 if ($r eq "1") {
    $http="https:";
 } else {
    $http="http:";
 }

 $ex="export MC_HOST_myminio=$http//$user\:$pw\@127.0.0.1:$port";       # set alias
 $mc="/opt/ooce/bin/minio-mc -C /var/web-gui/_log/minio --no-color --insecure ";
 #&mess("$ex; $mc $opt");   # debug

 $r=`$ex; $mc $opt`;
 # &mess($r);  # debug

 return ($r);

}

sub my_c { if (!($cfg{'ver'}=~/c/)) { print "$txt{'pro'}"; exit; } }

#eof
1;