#!/usr/bin/perl

## shebang needed only for tests !! agent1.pl is called via
## shellscript agent-manager.sh ( started at boot time together with napp-it)

## (c) Gnther Alka  2010-2015

## intension of this script: manage running background tasks
## parameter: ex  /tmp/nappit/abc_nn.request

## exec /_lib/scripts/abc.pl with parameter from first line of request file (if file) otherwise
## exec /_lib/scripts/job-other.pl with parameter from first line of request file

# logoptions: m=monitor, l=joblog, p=print, r=remotelog, a=alert , t=general tasklog

       use strict;
       use vars qw(@jobs $jobid $timer $jobtype $job $par $state $auto_os $os $path $cgipath $logpath $log $t $f $n @t @m $r %zfs %sys %par %cfg);

       use lib "/var/web-gui/data/napp-it/CGI";
       use Fcntl qw(:flock);                                                               # opt filelocking possible
       $|=1;                                                                               # keine Pufferung, no buffering

       require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";   # common used functions of napp-it

       $par=$ARGV[0];


       #debug
       #print "start taskexec.pl 29 $par\n";

       if (!(defined($par))) {
           &log("taskexec.pl 32: missing parameter","ta");
           exit;
       }

       # par= a/tmp/nappit/bc.request
       &log("taskexec.pl 37: parameter $par","ta");

       #
       if (!(-f $par)) {
              &log("taskexec.pl 41: parameterfile $par missing","ta");
              exit;
       }

       if (!($par=~/\.request$/)) {
              &log("taskexec.pl 46: parameter $par must be like abc.par","ta");
              exit;
       }

       # read parameter
       &read_ahfile("$par","t","a","taskexec.pl 36");

       $t[0]=~s/\s+$//s;
       if ($t[0] eq "") {
              &log("taskexec.pl 55: parameter (first line) from $par missing","ta");
              exit;
       }

      unlink ($par);

       $f=$par;
       $f=~s/\_.*request/.request/;                       # ex abc_33.htm.request -> abc.request
       $f=~s/\.request$/.pl/;
       $f=~s/.*\///;                                      # scriptfile to exec  like job-replicate.pl



       #debug
      # print "\ntaskexec.pl 66:  run $f @t\n";

      # use _my/script/ when created, search my_script, script, my_other, other
      $n="1";


      #ln?
      if (!(-e "/var/web-gui/data/scripts")) {
        `ln -s /var/web-gui/data/napp-it/zfsos/_lib/scripts /var/web-gui/data/scripts`;
      }

      #my script
      $t="/var/web-gui/_my/zfsos/_lib/script/$f";
      if (-f "$t") { $n="0"; }

      #script
      if ($n) {
        $t="/var/web-gui/data/scripts/$f";
        if (-f "$t") { $n="0"; }
      }

      #other
      if ($n) {
        $t="/var/web-gui/_my/zfsos/_lib/script/job-other.pl";
        if (-f "$t") { $n="0"; $f="job-other.pl"; }
      }

      if ($n) {  &log("taskexec.pl 96: error, no jobfile"); exit; }

      # exec, max 2 parameter !!
          &no_restart($f,$t[0]);

          &log("taskexec.pl 69: execute $f @t","t");

          $r=`uname -a`;
          if ($r=~/^Linux/i) {
            `perl /var/web-gui/data/scripts/$f $t[0] $t[1] >/dev/null 2>&1`;             # avoids shell spamming in Linux when deleted
          } else {
            exec("perl","/var/web-gui/data/scripts/$f","\'$t[0]\'","\'$t[1]\'");
          }
         #


       exit;


###############
sub no_restart {
#####
       ## do not start multiple times with same par
       my $time=time();

       my $r=`ps axw | grep web-gui`;
       my @t=split(/\n/,$r);
       my $f="1";
       foreach my $t (@t)  {
               if ($t=~/grep/)   { next; }
               if ($t=~/server/) { next; }
               if (($t=~/$_[0]/) && ($t=~/$_[1]/)) {
                    if ($f eq "1") { $f++; next; }

                    #debug
                    # print "########## taskexec.pl $par already started\n";
                    exit;
               }
       }
       #debug
       # print "taskexec 103 $time run $_[0] $_[1]\n";

       return;   # continue
       #####


}

###############################################
#end of my script, do not delete the line below
1;