# get_basic-sys.pl
# basic info for global hashes
# loaded always

# windows

use strict;

return(1);

# 1. zpool hash (info)
#######################

 # get poolnames
 &gethash_sys_poolnames;

 # ldate
 &getdate;
 &get_ldate;


####################### get datapools, allpools
sub gethash_sys_poolnames {
    my $ant=&socket('zpool list -H -o name');                 # get names
    #&mess($ant);
    my @pools=split(/\n/,$ant);
    foreach my $p (@pools) {
          if (!($zfs{'allpools'}=~/\b$p\b/)) {
              $zfs{'allpools'}.="$p\t";
          }
    }
    $zfs{'allpools'}=~s/\t+$//;


    #debug
    #print "Content-type: text/html\n\n";
    #&print_hash(%zfs);

}


sub get_ldate {
###############

return;

#print "Content-type: text/html\n\n";

    my ($ant,@old,@new,$ok,$k,$date,$d,$diff,$ref,$r,@l,@w,$h,$s,$short,$id);


    $sys{'edition'}="Free";      # free license
   # $sys{'version2'}="Free";     # napp-it
   # if ($sys{'version'}>=20) { $sys{'version2'}="Pro";  }       # alt

    if (-f "/var/web-gui/_log/appliance.log") {
       $ant=`cat /var/web-gui/_log/appliance.log`;

       @old=split(/\n/,$ant);
       foreach my $li (@old) {

              $ok="";
              $k="0";
              $s="1";             # wrong key

              if (!($li=~/::/)) { push (@new,$li); next; }

              @w=split(/\|/,$li);

              $h=$w[1];
              $h=~s/.*h:/h:/;
              $h=~s/ \- .*//;
              $h=~s/\_.*//;  # opt name
              $id=&get_hid;   # $id=hid (first mac address),  sysdef id in %sys,

              # mid
              # host without [lem]90
              $short=$h;
              $short=~s/.90$//;
#print "Content-type: text/html\n\n"; &mess("$t<br>$short");

              if (!($id=~/$short/)) {

                   # on aio check only partly
                   $s="1";
                   if (length($id) <= 15) {
                      $s=$id;
                      $s=~s/h:m//;
                      if ($h=~/$s/) { $s="0"; } else { $s="1"; }

                   }

                   #check against sysdef
                   #$t=&sysdef($w[1]);

    #print "Content-type: text/html\n\n";
    #&error("$t<br>$h<br>$sys{'sysdef'}");
    #&print_hash(%sys);

                   if ($h eq $sys{'sysdef'}) {  # old
                      $id=$sys{'sysdef'};
                      $s="0";
                   }
              }

              # check always against all mac
         #     $r=`sudo /usr/sbin/dladm show-phys -m -o ADDRESS | grep :`;  # mac from DEVICE->LINK
              chomp($r);

              $r=~s/://gs;
              $h=~s/h:m//;
              $h=~s/.90$//;
              if ($r=~/$h/is) {
                   $s="0";
              }

              #  last check
              if (($h=~/\w+/) && ($id=~/\w+/) && ($id=~/$h/)) { $s="0"; }  # ex $h=d37d31032850 and $t=h:md37d31032850e90
 #print "Content-type: text/html\n\n"; &mess("$h<br>$t<br>$s");

              if ($id=~/unknown/) { $s="0"; }  # unknown failure of nic detection
              if ($sys{'version'}=~/de/) { $s="0"; }       # dev release
              if ($s) {
                         #
                         open (PF, ">>/tmp/nappit/k.log");
                               print PF "$li (wrong machine id $sys{'date_us'}\n";
                               print PF "$ant\n";
                         close (PF);

                         open (PF, ">>/var/web-gui/_log/appliance.oldkey");
                               print PF "$li (wrong machine id $sys{'date_us'} \'$id\',\'$h\')\n";                                     # \n at the end
                         close (PF);
                         $ok.="0";
              }


              #valid
              $t=&getv2($w[1]);
     #&mess($ok);
              if (!($t=~/\d\d\d\d/)) {
                   open (PF, ">>/var/web-gui/_log/appliance.oldkey");
                         print PF "$li (date expired or invalid key)\n";                                     # \n at the end
                   close (PF);
                   $ok.="0";
              }


              if (!($ok=~/0/)) {

                       $sys{'edition'}="Pro";

                       if ($w[1]=~/^complete/) {
                            if (!($cfg{'ver'}=~/c/)) { $cfg{'ver'}.="c"; }
                            if (!($cfg{'ver'}=~/a/)) { $cfg{'ver'}.="a"; }
                            if (!($cfg{'ver'}=~/r/)) { $cfg{'ver'}.="r"; }
                            if (!($cfg{'ver'}=~/m/)) { $cfg{'ver'}.="m"; }
                        }
                        if ($w[1]=~/\_eval/) {
                            if (!($cfg{'ver'}=~/e/)) { $cfg{'ver'}.="e"; }
                        }
                        if ($w[1]=~/\_home|\_noncom/) {
                            if (!($cfg{'ver'}=~/h/)) { $cfg{'ver'}.="h"; }
                        }
                        if (($w[1]=~/acl/) && (!($cfg{'ver'}=~/a/))) {$cfg{'ver'}.="a";  }
                        if (($w[1]=~/mon/) && (!($cfg{'ver'}=~/m/))) {$cfg{'ver'}.="m";  }
                        if (($w[1]=~/rep/) && (!($cfg{'ver'}=~/r/))) {$cfg{'ver'}.="r";  }
                        if (!($cfg{'ver'}=~/p/)) {$cfg{'ver'}.="p";  }
              }

              if (!($ok=~/0/)) {
                     push (@new,$li);
              }
        }

        if (@new < @old) {
             $t=join("\n",@new);
             open (PF, ">/var/web-gui/_log/appliance.log");
                  print PF "$t";                                     # \n at the end
             close (PF);
             &read_ahfile("/var/web-gui/_log/appliance.log","cfg","h+");                    #read appliance-info -> %cfg
        }
    }


    #edition
    if (!($cfg{'ver'} =~/c|m/)) {
        &exe("touch /var/web-gui/_log/napp-it_ws_off");
        &about_stat_disable;

    }

    if (!($cfg{'ver'} =~/\w/))  {
        &exe("touch /var/web-gui/_log/napp-it_acc_off");
        &about_acc_disable;
    }

}



# eof
1;
